-*- coding: utf-8 -*-

commit 5445e0435260b449decf2ac16f9d09bae3cafe72
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-10-01 21:15:38 +0900

    merge revision(s) 0168094da28c146062db22e69cbd9316418310f9,cdef17096c03099f17ecf0af51f43faa0944f96d,b7d86e330c76b4f9615511307e1c40f4f2937c83:

            Use libSystem.dylib instead of libm.dylib and libc.dylib

              Because macOS 11.0(Big Sur) was removed libc and libm from `/usr/lib`.

            libSystem.dylib is also symlink. Use libSystem.B.dylib

            Workaroud for macOS Big Sur(11.0)

commit b35bfa6abb7760e4323a4341dff840f59ddcfde1
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-10-01 21:02:05 +0900

    merge revision(s) 35ba2783fe6b3316a6bbc6f00bf975ad7185d6e0,e8edc34f0abe176b24975a1fed1f2c3782f0a252: [Backport #16807]

            Use a linked list to eliminate imemo tmp bufs for managing local
             tables

            This patch changes local table memory to be managed by a linked list
            rather than via the garbage collector.  It reduces allocations from the
            GC and also fixes a use-after-free bug in the concurrent-with-sweep
            compactor I'm working on.

            Remove unused struct member

            I accidentally added this in 35ba2783fe6b3316a6bbc6f00bf975ad7185d6e0,
            and it's making the size of RVALUE be too big. I'm sorry! orz

commit 811b2b0df5e670ad8db7951191232ce3f5b0d978
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-10-01 19:10:30 +0900

    bump teeny version to 2.7.2.

commit 229c041f057f24b8e5c0c911738e17dfb3da4515
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-10-01 07:53:55 +0900

    merge revision(s) d732bc51bdbfe7d66038731d42e01a511d13b5f8,633a1f15d8228236094ddee12e4e169d655ec49e,95f387f61a4a4ea92635da760b7de5b1e09bb84e,528a3a17977aa1843a26630c96635c3cb161e729,261569d4aac440f25de588cca365163ecf1124a2,e4a9e926f0fe0acf2fbe61da6e075a95d34be066,318be1cb2f9c6f04403c063a5618c6267012ee51,e1855100e46040e73630b378974c17764e0cccee,9cfa811b0f209d714f89fe0de6778c71f77556c7,b68dab866724aacc1cbc6b7d5e1f555dec092346: [Backport #17202]

            Revert "Revert "Revert "[ruby/fiddle] Use ffi_closure_free by
             default. (#20)"""

            This reverts commit 87f6154bb4c67ca77ee353bb1fe25a922036c0e5.

            It turned out that the change fails to build on macOS

            https://rubyci.org/logs/rubyci.s3.amazonaws.com/osx1014/ruby-master/log/20200304T074503Z.fail.html.gz
            ```
            + make 'TESTS=--hide-skip -v fiddle' RUBYOPT=-w test-all
            dyld: lazy symbol binding failed: Symbol not found: _ffi_closure_alloc
              Referenced from: /Users/hsbt/Documents/cb/tmp/build/20200304T074503Z/ruby/.ext/x86_64-darwin18/fiddle.bundle
              Expected in: flat namespace

            dyld: Symbol not found: _ffi_closure_alloc
              Referenced from: /Users/hsbt/Documents/cb/tmp/build/20200304T074503Z/ruby/.ext/x86_64-darwin18/fiddle.bundle
              Expected in: flat namespace

            make: *** [yes-test-all] Abort trap: 6
            ```

            [ruby/fiddle] Use ffi_closure_free if available

            [ruby/fiddle] ffi_closure_free is available in the bundled libffi

            [ruby/fiddle] use ffi_closure_alloc only with 3.2 or later

            [ruby/fiddle] always use ffi_closure_alloc on Windows

            Fixed a typo

            Show libffi version only if set

            ext/fiddle/extconf.rb: check if ffi_closure_alloc is available

            to define HAVE_FFI_CLOSURE_ALLOC.
            The macro is used in closure.c, so have_func check is needed.

            If pkg-config is not installed, extconf.rb fails to detect the version
            of libffi, and does not add "-DUSE_FFI_CLOSURE_ALLOC=1" even when system
            libffi version is >= 3.2.

            If USE_FFI_CLOSURE_ALLOC is not defined, closure.c attempts to check if
            HAVE_FFI_CLOSURE_ALLOC is defined or not, but have_func was removed with
            528a3a17977aa1843a26630c96635c3cb161e729, so the macro is always not
            defined.

            This resulted in this deprecation warning:

            https://rubyci.org/logs/rubyci.s3.amazonaws.com/ubuntu2004/ruby-master/log/20200512T123003Z.log.html.gz
            ```
            compiling closure.c
            closure.c: In function 'initialize':
            closure.c:265:5: warning: 'ffi_prep_closure' is deprecated: use ffi_prep_closure_loc instead [-Wdeprecated-declarations]
              265 |     result = ffi_prep_closure(pcl, cif, callback, (void *)self);
                  |     ^~~~~~
            In file included from ./fiddle.h:42,
                             from closure.c:1:
            /usr/include/x86_64-linux-gnu/ffi.h:334:1: note: declared here
              334 | ffi_prep_closure (ffi_closure*,
                  | ^~~~~~~~~~~~~~~~
            ```

            Do not try ffi_closure_alloc if libffi is <= 3.1

            Maybe due to e1855100e46040e73630b378974c17764e0cccee, CentOS, RHEL, and
            Fedora CIs have started failing with SEGV.  Try to avoid
            ffi_closure_alloc on those environments.

            https://rubyci.org/logs/rubyci.s3.amazonaws.com/centos8/ruby-master/log/20200512T183004Z.fail.html.gz
            https://rubyci.org/logs/rubyci.s3.amazonaws.com/fedora32/ruby-master/log/20200512T183004Z.fail.html.gz
            https://rubyci.org/logs/rubyci.s3.amazonaws.com/rhel8/ruby-master/log/20200512T183003Z.fail.html.gz

            ext/fiddle/extconf.rb: Fix the condition of libffi <= 3.1

            ver is [3, 1, 0] which is not less then or equal to [3, 1]

commit f46929833923d96e4dc706945fd537a1caaebe66
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-09-30 19:24:17 +0900

    merge revision(s) f96216df8dfd2d1e206150572912289f4dda7386,0091fac1d8de07e86fef8315ba77609bed9dd7f5,04c704c5c967ea9bded6bf645439fe59c7d9f7d6,23655e6de5ee989feb8c65c7061fe9a71579dc54,7cb8904a12c850ee30dcd67817fa2f9dc3fee813,41168f69fbeb32cfc88210911d62e419b8116589,87f6154bb4c67ca77ee353bb1fe25a922036c0e5: [Backport #17202]

            Remove "All Rights Reserved." from Copyright statement.

            Patch assembly so that it aligns properly

            Removed trailing spaces [ci skip]

            Fix build error on Apple silicon macOS

            This patch will fix following build error on macOS 11.0 + Xcode 12 beta.

            ```
            $ ./configure
            $ make V=1
                    BASERUBY = /Users/watson/.rbenv/shims/ruby --disable=gems
                    CC = clang -fdeclspec
                    LD = ld
                    LDSHARED = clang -fdeclspec -dynamiclib
                    CFLAGS = -O3 -ggdb3 -Wall -Wextra -Werror=deprecated-declarations -Werror=division-by-zero -Werror=implicit-function-declaration -Werror=implicit-int -Werror=misleading-indentation -Werror=pointer-arith -Werror=shorten-64-to-32 -Werror=write-strings -Wmissing-noreturn -Wno-constant-logical-operand -Wno-long-long -Wno-missing-field-initializers -Wno-overlength-strings -Wno-parentheses-equality -Wno-self-assign -Wno-tautological-compare -Wno-unused-parameter -Wno-unused-value -Wunused-variable -Werror=extra-tokens -std=gnu99  -pipe
                    XCFLAGS = -D_FORTIFY_SOURCE=2 -fstack-protector-strong -fno-strict-overflow -DRUBY_DEVEL=1 -fvisibility=hidden -DRUBY_EXPORT -fPIE -DCANONICALIZATION_FOR_MATHN -I. -I.ext/include/arm64-darwin20 -I./include -I. -I./enc/unicode/12.1.0
                    CPPFLAGS = -D_XOPEN_SOURCE -D_DARWIN_C_SOURCE -D_DARWIN_UNLIMITED_SELECT -D_REENTRANT
                    DLDFLAGS = -Wl,-undefined,dynamic_lookup -Wl,-multiply_defined,suppress -fstack-protector-strong -Wl,-pie -framework Security -framework Foundation
                    SOLIBS = -lpthread -ldl -lobjc
                    LANG = ja_JP.UTF-8
                    LC_ALL =
                    LC_CTYPE =
                    MFLAGS =
            Apple clang version 12.0.0 (clang-1200.0.22.19)
            Target: arm64-apple-darwin20.0.0
            Thread model: posix
            InstalledDir: /Applications/Xcode-beta.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/bin
            clang -fdeclspec -O3 -ggdb3 -Wall -Wextra -Werror=deprecated-declarations -Werror=division-by-zero -Werror=implicit-function-declaration -Werror=implicit-int -Werror=misleading-indentation -Werror=pointer-arith -Werror=shorten-64-to-32 -Werror=write-strings -Wmissing-noreturn -Wno-constant-logical-operand -Wno-long-long -Wno-missing-field-initializers -Wno-overlength-strings -Wno-parentheses-equality -Wno-self-assign -Wno-tautological-compare -Wno-unused-parameter -Wno-unused-value -Wunused-variable -Werror=extra-tokens -std=gnu99  -pipe  -D_FORTIFY_SOURCE=2 -fstack-protector-strong -fno-strict-overflow -DRUBY_DEVEL=1 -fvisibility=hidden -DRUBY_EXPORT -fPIE -DCANONICALIZATION_FOR_MATHN -I. -I.ext/include/arm64-darwin20 -I./include -I. -I./enc/unicode/12.1.0 -D_XOPEN_SOURCE -D_DARWIN_C_SOURCE -D_DARWIN_UNLIMITED_SELECT -D_REENTRANT    -o cont.o -c cont.c
            In file included from cont.c:19:
            ./coroutine/ucontext/Context.h:32:5: error: 'getcontext' is deprecated: first deprecated in macOS 10.6 [-Werror,-Wdeprecated-declarations]
                getcontext(&context->state);
                ^
            /Applications/Xcode-beta.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX.sdk/usr/include/ucontext.h:37:6: note: 'getcontext' has been
                  explicitly marked deprecated here
            int  getcontext(ucontext_t *) __OSX_AVAILABLE_BUT_DEPRECATED(__MAC_10_5, __MAC_10_6, __IPHONE_2_0, __IPHONE_2_0) __WATCHOS_PROHIBITED __TVOS_PROHIBITED;
                 ^
            In file included from cont.c:19:
            ./coroutine/ucontext/Context.h:51:5: error: 'makecontext' is deprecated: first deprecated in macOS 10.6 [-Werror,-Wdeprecated-declarations]
                makecontext(&context->state, (void(*)(void))coroutine_trampoline, 2, (void*)start, (void*)context);
                ^
            /Applications/Xcode-beta.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX.sdk/usr/include/ucontext.h:38:6: note: 'makecontext' has been
                  explicitly marked deprecated here
            void makecontext(ucontext_t *, void (*)(), int, ...) __OSX_AVAILABLE_BUT_DEPRECATED(__MAC_10_5, __MAC_10_6, __IPHONE_2_0, __IPHONE_2_0) __WATCHOS_PROHI...
                 ^
            In file included from cont.c:19:
            ./coroutine/ucontext/Context.h:59:5: error: 'swapcontext' is deprecated: first deprecated in macOS 10.6 [-Werror,-Wdeprecated-declarations]
                swapcontext(&current->state, &target->state);
                ^
            /Applications/Xcode-beta.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX.sdk/usr/include/ucontext.h:40:6: note: 'swapcontext' has been
                  explicitly marked deprecated here
            int  swapcontext(ucontext_t * __restrict, const ucontext_t * __restrict) __OSX_AVAILABLE_BUT_DEPRECATED(__MAC_10_5, __MAC_10_6, __IPHONE_2_0, __IPHONE_...
                 ^
            3 errors generated.
            make: *** [cont.o] Error 1
            ```

            Extract correct processor name for ARM64 Macs

            Prefix export symbol prefix to coroutine_transfer

            Revert "Revert "[ruby/fiddle] Use ffi_closure_free by default.
             (#20)""

            This reverts commit efd641ffab34e433a8d8a7d78914576f2425aa90.

            This changeset seems to be needed to suppress a warning on Ubuntu 20.04
            https://rubyci.org/logs/rubyci.s3.amazonaws.com/ubuntu/ruby-master/log/20200304T033004Z.log.html.gz
            ```
            closure.c:264:5: warning: 'ffi_prep_closure' is deprecated: use ffi_prep_closure_loc instead [-Wdeprecated-declarations]
              264 |     result = ffi_prep_closure(pcl, cif, callback, (void *)self);
                  |     ^~~~~~
            ```

            I guess there was a reason why the commit was reverted (maybe some CIs
            failed?), so try it again.

commit ea347990a5416c73a74f7dfa8a13b5ad5b7e79d4
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-09-30 07:50:06 +0900

    merge revision(s) 07786edd66f59a529d6febb2e0fe901782991755,1917afa34bca55ba1ea578234132b7e4479ea3c9,0c611d7f4fce67c64bee4815f263c55ef15561c4:

            test/net/http/test_https.rb: Stop the error due to openssl 1.1.1h

            On some environments that uses OpenSSL 1.1.1h, the two tests now fail.

            http://rubyci.s3.amazonaws.com/android29-x86_64/ruby-master/log/20200924T062352Z.fail.html.gz
            https://github.com/ruby/ruby/runs/1159288773?check_suite_focus=true

            ```
              1) Failure:
            TestNetHTTPS#test_get [/data/data/com.termux/files/home/cb/tmp/build/20200924T062352Z/ruby/test/net/http/test_https.rb:47]:
            <"0\x82\x03\xED0\x82\x02\xD5\xA0\x03..."> expected but was
            <"0\x82\x03\xE30\x82\x02\xCB\xA0\x03...">.
            ```

            Not sure why, but verify_callback now seems to receive only SERVER_CERT
            but not CA_CERT.
            It would be good to investigate the issue furthermore, but tentatively,
            I want to stop the failures.

            test/net/http/test_https.rb: the order of verify_callback seems to
             vary

            ... depending upon the environment.

            test/net/http/test_https.rb: The test logic was buggy

            The expected certs must be `[CA_CERT, SERVER_CERT]` before 1.1.1g and
            `[SERVER_CERT]` after 1.1.1h.

commit 828c34e58b63d64558ec0f2d1d7ae401c5e6b21f
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-09-29 22:46:14 +0900

    merge revision(s) d23d2f3f6fbb5d787b0dd80675c489a692be23e2:

            [ruby/webrick] Make it more strict to interpret some headers

            Some regexps were too tolerant.

            https://github.com/ruby/webrick/commit/8946bb38b4

commit df3f52a6331f1a47af9933b77311a8650727d8d1
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-09-29 22:43:25 +0900

    merge revision(s) 996af2ce086249e904b2ce95ab2fcd1de7d757be: [Backport #16345] [Backport #17000]

            Disable deprecation warning by the default [Feature #16345]

            And `-w` option turns it on.

commit 665589cbdf7bf652067113dd1c0bc49012b990e0
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-09-29 20:33:06 +0900

    merge revision(s) df14c758fc705c49c2aaf4c9276a8f7229438fbf: [Backport #17181]

            Make hash returned by Hash#transform_values not have a default

            This sets an explicit default of nil.  There is probably a better
            approach of removing the default.

            Fixes [Bug #17181]

commit c10326d913a0340fc78ec94dc09d9e9398b31f1c
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-09-20 20:23:51 +0900

    bump patchlevel to 128

commit 1b39a995b559677bf4bf2d0ac3a1c924928a936f
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-09-20 20:23:12 +0900

    Revert "statement experssion is a GCCism" to pass ICC CI.

    This reverts commit a6b50f379d4b71acac73ac6b22cbe2d2c5b50b3f.

commit eb8270d67596fff58e245ff4227dd35e67dbef5c
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-09-17 21:23:39 +0900

    Skip bundler spec using irb with simulated JRuby environment.

commit 0ebf6ea9a0d74f859ee4009fbe6693996f1fcdc7
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-09-16 21:10:19 +0900

    bump patchlevel to 126

commit 21c1b676c4e9075549978918304206218478c459
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-09-16 11:36:44 +0900

    Merge latest readline-ext

commit 2159798f4c0f71007db733cddd82b99186c8e424
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-09-16 11:19:17 +0900

    Merge IRB 1.2.6

commit 3bb503e0e8f92c039ce50f430b14649a36c03feb
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-09-16 11:19:06 +0900

    Merge Reline 0.1.5

commit ed39078d37e16b541d717cd87cacb21aa33e6ef1
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-09-15 20:56:13 +0900

    bump patchlevel to 125

commit 7d76314885be3532999684356657ce36da84d04e
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-06-30 21:23:37 +0900

    Merge RubyGems 3.1.4

commit 3590f082442afc4506250f5274a7877371a112de
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-02-09 11:04:53 +0900

    spec/ruby/core/file/utime_spec.rb: far future timestamp may be trancated

    Under some Ext4 filesystem settings, a timestamp is limited up to
    0x37fffffff (2446-05-10).

    https://ext4.wiki.kernel.org/index.php/Ext4_Disk_Layout#Inode_Timestamps
    > Therefore, timestamps should not overflow until May 2446.

    Actually the spec fails under one of our CI environments, like:

    ```
    1)
    File.utime allows Time instances in the far future to set mtime and atime FAILED
    Expected 2446 == 559444
    to be truthy but was false
    ```
    https://rubyci.org/logs/rubyci.s3.amazonaws.com/arch/ruby-master/log/20200208T180002Z.fail.html.gz

commit 277076173af868d297070da43fcb3a06ccb7e21f
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-09-07 21:13:43 +0900

    Run a TracePoint test in an insolated process

    to prevent a random failure like
    http://ci.rvm.jp/results/trunk-random2@phosphorus-docker/3024287

commit 2b5b9e12805597c3577b02b6c344d2b874220f3b
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-09-07 21:07:33 +0900

    * 2020-09-07 [ci skip]

commit a2f3aaea12ebaebf150a27268fc5f0f465e53b8f
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-09-07 21:06:48 +0900

    Fix a random test failure by TracePoint

    A test worker process may already be enabling TracePoint, which results
    in changing the insn name in this test.

    http://ci.rvm.jp/results/trunk-random0@phosphorus-docker/3022750

commit dd4e51d84e01d9c60458dfe19a0b4d4e05b55140
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-09-06 11:16:29 +0900

    merge revision(s) ff5e66034006a875125581114cce19d46843b32a: [Backport #17015]

            Added `NODE_SPECIAL_EXCESSIVE_COMMA` info to `ARGS` of
             `RubyVM::AbstractSyntaxTree`.

commit 3fef159f81fad6ffb9af5b60f4c8ec867fdb2391
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-09-06 11:05:52 +0900

    merge revision(s) 3e02cd518fbe4d91c2aca7fbc3c5aafa387d3cb7: [Backport #17149]

            Trace :return of builtin methods

            using opt_invokebuiltin_delegate_leave insn.

            Since Ruby 2.7, :return of methods using builtin have not been traced properly.

commit e778de2c82478dda930cfc8d795ed4e0e60ea775
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-09-06 10:54:53 +0900

    merge revision(s) 11963da9e8e98821860fbb0c0f2adc118860c814: [Backport #16603] [Backport #17141]

            Check type of empty keyword [Bug #16603]

            Co-authored-by: Yusuke Endoh <mame@ruby-lang.org>

commit 9a1f0240cae95df4207bd95e7c0380d5307b7c9e
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-09-05 19:19:20 +0900

    bump patchlevel to 119

commit 2c9dd060ab487a96e391793bd782cef6fd471b83
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-09-05 19:18:07 +0900

    Revert "Don't display singleton class in Method#inspect unless method defined there"
    [Backport #16771]

    This reverts commit 0d24fb774d84d4a99454ce10fd343da00049a588.

commit e9e4f8430a62f56a4e62dd728f4498ee4c300c12
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-08-07 20:16:51 +0900

    merge revision(s) 8e189df32cacef4b21e357a590d349330532baf5: [Backport #17013]

            Add operator info to `OP_ASGN2` of `RubyVM::AbstractSyntaxTree`.

commit 23d130a9ddcaf766d6ce309f8518b434a2537fc1
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-08-01 17:33:56 +0900

    merge revision(s) d05f04d27dd86c67e4a8dfff4392f806cf577bdf: [Backport #16931]

            Fixed `defined?` against protected method call

            Protected methods are restricted to be called according to the
            class/module in where it is defined, not the actual receiver's
            class.  [Bug #16931]

commit 315f1ee8a80680fd7aff5fa27abfd965d1906809
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-06-02 17:07:41 +0900

    Split test_defined_method

commit 171d4c512b1497178b39db32b255eb521560d78c
  Author: Peter Zhu <peter@peterzhu.ca>
  Date:   2020-05-08 06:05:46 +0900

    Fix typo in test name

commit b222ae41015646e238e1d2f6710da02f38578388
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-04-23 09:43:30 +0900

    Test for [Bug #16669]

commit 34427bc09e68a81a9986bc7fe0d1d9886e6d00d5
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-04-22 22:21:11 +0900

    Split test_defined

commit a024bae53999cb02f6ef556bbe03af8b6d002bcf
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-08-01 16:56:42 +0900

    bump up patchlevel for a332e8a0ddad90c540c6c52f0db2a45e5955a23d

commit a332e8a0ddad90c540c6c52f0db2a45e5955a23d
  Author: MSP-Greg <Greg.mpls@gmail.com>
  Date:   2020-07-26 22:57:59 +0900

    ruby_2_7 update MinGW Actions workflow

commit 05c4c88767b54808cd1459a1d6da11179c422cfa
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-26 18:32:36 +0900

    merge revision(s) 1b4d406e3a04032b6d01e92b6d184a16945c6ac3: [Backport #16498] [Backport #16914]

            Hash#transform_values should return a plain new Hash

            [Bug #16498]

commit 61c6d433060881e952140d2154c06f8c9803dc8a
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-26 17:45:27 +0900

    partially merge revision adf709a78534c1483ba851ccb0490464ca31503c: [Backport #16801]

            Classes made from Struct should have default new singleton method.

            Co-authored-by: Yusuke Endoh mame@ruby-lang.org
            Co-authored-by: John Hawthorn john@hawthorn.email
            Co-authored-by: Adam Hess HParker@github.com
            Co-authored-by: Jose Cortinas jacortinas@gmail.com
            Co-authored-by: Jean Boussier jean.boussier@gmail.com

commit 43cc6997c59d2fbe3b91e91ee52faaa8749e9349
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-26 16:19:40 +0900

    merge revision(s) a0bc3f2a1c2c98f225612101cb4e1ea1a6813546,75a0447c15a7ab017bd4240c2a9cc69b134b80b9,f1699314147bad2cf5550cc582693424fdbc2510: [Backport #16846]

            Suppress C4267 "possible loss of data" warnings

            Suppress C4267 "possible loss of data" warnings

            Just cast down explicitly.

            win32ole: separate global variable declarations and definitions

            https://gcc.gnu.org/gcc-10/changes.html#c

            > * GCC now defaults to `-fno-common`.  As a result, global
            >   variable accesses are more efficient on various targets.  In
            >   C, global variables with multiple tentative definitions now
            >   result in linker errors.  With `-fcommon` such definitions are
            >   silently merged during linking.

commit 578bacc471fa3fa14f8607fe67adccce21e81657
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-25 21:42:20 +0900

    merge revision(s) 5e81e8675a020ecd493620a4ff38db8fcf4b972a: [Backport #16780]

            Ignore exceptions when closing data connections [Bug #16780]

            Patch by koshigoe (Masataka SUZUKI). Thanks!

commit 12391cdbe11f3fbeb3b04c30b944139e5bbd9ea6
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-25 14:17:35 +0900

    merge revision(s) cbe4f75ef802f13d05f94e42274b65a062bd3666: [Backport #16834]

            Fix rb_profile_frame_classpath to handle module singletons

            Right now `SomeClass.method` is properly named, but `SomeModule.method`
            is displayed as `#<Module:0x000055eb5d95adc8>.method` which makes
            profiling annoying.

commit be359442cb07c25fdc769431ffed3249b9016829
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-25 13:40:48 +0900

    merge revision(s) 71c166e11e761dcaaa943f9b94da38f86ada1bdb: [Backport #16854]

            Fixed argument forwarding in reserved word method [Bug #16854]

commit 89f06ce8b8a887f12b53ea190d79a58e98b59008
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-25 12:00:39 +0900

    merge revision(s) 08529a61153e5c40f57a65272211357511d6e6db: [Backport #16798]

            Compare environment variable names in those manor [Bug #16798]

commit 2e9626fddd168bd12352b4f5dc3412c6a33ce44e
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-25 11:56:28 +0900

    merge revision(s) 2f1895fa15386fb3cdc91c5604171290828b9da8: [Backport #16767]

            Fixed formatted substring expansion [Bug #16767]

commit c65aae118ccff86096b9983641b371491bc23434
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-23 17:47:12 +0900

    merge revision(s) 927308108cced69cae478798004524b9a5d2f252: [Backport #16764]

            Fix source location of autoloaded constant [Bug #16764]

commit 4437f9eb0bf8369bcf12bd7cd324e11b5d885e07
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-23 17:30:26 +0900

    merge revision(s) da05c1552ee519d8f180b48d97148d28501acb35: [Backport #16749]

            Update to ruby/spec@cc7b9e5

commit c53cee7a0e7b3e87ba3fbafa86bd74460af18d93
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-23 17:22:45 +0900

    merge revision(s) 72c02aa4b79731c7f25c9267f74b347f1946c704: [Backport #16662]

            Moved not-implemented method tests [Bug #16662]

            Test not-implemented method with the dedicated methods, instead of
            platform dependent features.

commit ae804b143455075687c8b4a401fba48fda72a217
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-23 16:59:03 +0900

    merge revision(s) b23fd59cbb3f097bcd559d0c85a86ff7a1eeeb7e: [Backport #16501]

            marshal.c: Support dump and load of a Hash with the ruby2_keywords
             flag

            It is useful for a program that dumps and load arguments (like drb).
            In future, they should deal with both positional arguments and keyword
            ones explicitly, but until ruby2_keywords is deprecated, it is good to
            support the flag in marshal.

            The implementation is similar to String's encoding; it is dumped as a
            hidden instance variable.

            [Feature #16501]

commit f1563edca0af1a5ad5cc748eb855ff9265e69e7f
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-01-11 16:32:56 +0900

    Get rid of use of magic number 'E'

commit 4f714939efde6d6b3b74c09e1e151e6ce6818b90
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-23 14:02:05 +0900

    merge revision(s) e04418bb16cd99b4a4402e7457d3bdc967284f98: [Backport #16830]

            [ruby/uri] Check if DN exists

            https://bugs.ruby-lang.org/issues/16830

            https://github.com/ruby/uri/commit/b4bf8c1217

commit 9da6470d7b3aa136b4b92469c8bbc522beb1ac31
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-23 13:50:56 +0900

    merge revision(s) a2be428c5fec31b8adbd5ac087e7637ddf7e54d0: [Backport #16826]

            Fix ObjectSpace::WeakMap#key? to work if the value is nil

            * Fixes [Bug #16826]

commit 27fa1c61b78c1685ccf9ac203a95cfa9041d618f
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-23 12:13:30 +0900

    merge revision(s) 579645d9f870fa4116dcd3200bbbb6e2c0b7f400: [Backport #17033]

            Fixed infinite loop at error in printing cause [Bug #17033]

commit 4be9bf1f67b997fc519625d56a93b8a68a70d124
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-23 11:33:11 +0900

    merge revision(s) 99a9c3fe2eaab8157765d792dc871da6daea0327: [Backport #17024]

            Fixed yday and wday with timezone [Bug #17024]

commit 13d2ab0d88bbf72ed310efaec6edc46dd96fdb4d
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-23 11:16:31 +0900

    merge revision(s) 2ecfb88ee50510955acd3ae9fc94a5f109e7f109: [Backport #16918]

            Correctly remove temporary directory if path yielded is mutated

            Another approach would be to freeze the string, but that could
            cause backwards compatibility issues.

            Fixes [Bug #16918]

commit cc39480cf9f2767967b6bcc69ccb3c201e5b2231
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-23 11:11:12 +0900

    merge revision(s) 5a79d8e0507cd143100bf928a88a59a8b5a5bca6,160511d851375f7cb922faae3a9310633187f51f: [Backport #16925]

            Fix error raised by Net::HTTPResponse#inflater if the block raises

            * See https://bugs.ruby-lang.org/issues/13882#note-6

            Quarantine specs which fail frequently with CHECK_LEAKS=true

commit d24cce8e7f48b0b45f726f5f1ac7ff796f46ba72
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-19 12:16:37 +0900

    merge revision(s) bf1a6771f305ea286a3ae575676924551c03e857,c1463625555b061a2b94c3b6c5581730b482a285: [Backport #17012] [Backport #17014]

            Fix non-numeric exclusive Range#minmax bug

            The implementation of Range#minmax added in d5c60214c45 causes the
            following incorrect behaviour:

              ('a'...'c').minmax => ["a", ["a", "b"]]

            instead of

              ('a'...'c').minmax => ["a", "b"]

            This is because the C implementation of Range#minmax (range_minmax)
            directly delegates to the C implementation of Range#min (range_min) and
            Range#max (range_max), without changing the execution context.

            Range#max's C implementation (range_max), when given a non-numeric
            exclusive range, delegates to super, which is meant to call
            Enumerable#max. However, because range_max is called directly by
            range_minmax, super calls Enumerable#minmax instead, causing the
            incorrect nesting.

            Perhaps it is possible to change the execution context in an optimized
            manner, but the simplest solution seems to be to just explicitly
            delegate from Range#minmax to Range#min and Range#max.

            Use static variables in Range#minmax

commit f43b8c4f7304ebea91cd01d5606e13273d0fd755
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-19 11:56:32 +0900

    merge revision(s) 0ba27259d390e902139c0e2e94b9d18ef227748e: [Backport #16940]

            Fix crashes in the peephole optimizer on OpenBSD/sparc64

            These crashes are due to alignment issues, casting ADJUST to INSN
            and then accessing after the end of the ADJUST.  These patches
            come from Stefan Sperling <stsp@apache.org>, who reported the
            issue.

commit e619178e52250ceda3a0fe32ff5addb16617b58c
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-19 11:52:11 +0900

    merge revision(s) 6e7e7c1e577d6c2276e9a8cc85c28c55c46c2618: [Backport #17023]

            Only marked objects should be considered movable

            Ruby's GC is incremental, meaning that during the mark phase (and also
            the sweep phase) programs are allowed to run.  This means that programs
            can allocate objects before the mark or sweep phase have actually
            completed.  Those objects may not have had a chance to be marked, so we
            can't know if they are movable or not. Something that references the
            newly created object might have called the pinning function during the
            mark phase, but since the mark phase hasn't run we can't know if there
            is a "pinning" relationship.

            To be conservative, we must only allow objects that are not pinned but
            also marked to move.

commit ad15fd03e915272bdf4b3a8403722b397e3afcf8
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-19 11:32:59 +0900

    merge revision(s) 26c179d7e7e7ae0eb21050659c3e8778358230ab: [Backport #17026]

            Check argument to ObjectSpace._id2ref

            Ensure that the argument is an Integer or implicitly convert to,
            before dereferencing as a Bignum.  Addressed a regression in
            b99833baec2.

            Reported by u75615 at https://hackerone.com/reports/898614

commit 9e76124a2b11003f1000bd330a0121f1914af290
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-18 13:24:25 +0900

    bump patchlevel to 93

commit 17b088d1e5d0378d9752f807e607adde0cb47ef1
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-03-12 15:30:20 +0900

    Update some syslog tests to absurb the format change of FreeBSD syslog

    FreeBSD

    ```
    $ ruby -rsyslog -e 'Syslog.open("rubyspec", Syslog::LOG_PERROR) {|s| s.log(Syslog::LOG_ALERT, "Hello") }'
    rubyspec 78462 - - Hello
    ```

    Linux

    ```
    $ ruby -rsyslog -e 'Syslog.open("rubyspec", Syslog::LOG_PERROR) {|s| s.log(Syslog::LOG_ALERT, "Hello") }'
    rubyspec: Hello
    ```

    https://github.com/freebsd/freebsd/commit/591ef7c8076109cff3c41f9bb50da996a34121e9

commit 0c4d93e6991d365cc77fbaaeae367b9651f2d4cd
  Author: Kazuki Yamaguchi <k@rhe.jp>
  Date:   2020-02-17 17:14:47 +0900

    test/openssl/test_ssl: skip test_fallback_scsv if necessary

    Run the test case only when the OpenSSL supports both TLS 1.1 and TLS
    1.2. Note that the fallback SCSV mechanism is for TLS 1.2 or older and
    not for 1.3.

    Fixes: https://github.com/ruby/openssl/issues/336

commit bad7ab35d1e38f47b09f15fc5750387ac73b2286
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-05-12 17:47:27 +0900

    test/lib/jit_support.rb: Let JIT tests skip on centos8

    It has the same issue as RHEL 8.  k0kubun said he will fix later

commit b4c893a62c71ac28795f8fcefb375131833afd0c
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-11 16:10:41 +0900

    OpenSSL 1.1.1 introduces a new '.include' directive. Update our config
    parser to support that.

    As mentioned in the referenced GitHub issue, we should use the OpenSSL
    API instead of implementing the parsing logic ourselves, but it will
    need backwards-incompatible changes which we can't backport to stable
    versions. So continue to use the Ruby implementation for now.

    References:
      https://github.com/ruby/openssl/issues/208
      https://github.com/ruby/openssl/pull/216

    The original patch was written by Kazuki Yamaguchi <k@rhe.jp> and
    the patch for ruby_2_7 branch was prepared by Vít Ondruch.

commit a0bb4eb04512b3f8ca50ec5fa72e3d4a8278ca46
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-10 08:51:53 +0900

    bump patchlevel: merge commits: 5c2508060b79b4299a18d05511d3530ad14b1b7a 2480ef904c66812cf366e5d9bc8a9c3c20bbf271 47720e2255f34ecad49763c66a7ea02a55a3f60a

commit b971bad49b95d4c1f68bb2242d4267355f1cd497
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-05-04 13:35:38 +0900

    Bison 3.59.1 folds yydestruct function header

commit 06ab2791c38c431e08bc8d9381c9a1ca727297c4
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-05-20 10:52:32 +0900

    pure_parser.rb: get rid of an error at localed messages

commit 1ee1684a4a3edb26b5aa32acc967b9ef26284d42
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-05-04 18:10:02 +0900

    Bison 3.5.91 now defaults parse.error to "simple"

commit 601613fdf3907f3842a9d465926dca7c37d56f72
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-09 21:03:58 +0900

    merge revision(s) 87ad5ea729735ff6b8f1ac0bb3aad2aedd6f716e,9745e90197f129708986803e8913fb151862478a:

            Skip jit_test on some new RubyCI envs for now

            Propagate JIT skip to all tests

commit 6c22070408f9729621712190bfc8460e5eebcb03
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-09 20:54:28 +0900

    merge revision(s) 21d8e6924844d592ff2d5a2e7309457eb92e66f6:

            disable to show the maximum number of threads.

            On Deiban 9 environment, the thread tests failed and
            this maximum threads information can finish up the machine
            resources. To check it, I turned-off showing this information.

commit 9720591043003a5262c8f3e1c1720771bc77488b
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-07-05 07:03:14 +0900

    merge revision(s) 75802bcff1b941818832f0145071f7ce9c843d8d:

            configure: suppress icc warnings

            Every time a pointer to/from VALUE conversion happens, these two
            warnings are issued:

            - warning #1684: conversion from pointer to same-sized integral type (potential portability problem)
            - warning #2312: pointer cast involving 64-bit pointed-to type

            Thank you, but we are well aware of the "potential portability problem".
            Let us ignore them all.

commit 799c5766a4dc215d139d2c26ac68636f43a64fbf
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-06-27 12:29:42 +0900

    merge revision(s) a19228f878d955eaf2cce086bcf53f46fdf894b9: [Backport #16979]

            brace the fact that lchmod(2) can EOPNOTSUPP

            Musl libc has this function as a tiny wrapper of fchmodat(3posix).  On
            the other hand Linux kernel does not support changing modes of a symlink.
            The operation always fails with EOPNOTSUPP.  This fchmodat behaviour is
            defined in POSIX.  We have to take care of such exceptions.

commit d8a32b146561a0ddd3e60da9863a082b7e7725db
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-06-27 12:20:36 +0900

    merge revision(s) 263b941321c3de6afc8f9dafbc2625f866b7437e: [Backport #16981]

            [ripper] fix mismatched indentations warning [Bug #16981]

            The scanner location has to be set from `lex.ptok` before it is
            flushed by dispatching the scanner event.

commit 3c55d93cf68b1a969b90b306de4dd8b88d74a2f2
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-06-13 11:29:51 +0900

    merge revision(s) 7e289cdf3fed588b2d5a6973e29f9ff95cb8d76c: [Backport #16949]

            [ruby/psych] Fixing compatibility with libyaml 0.2.5

            The main issue is that commas aren't allowed in local tags.  libyaml
            was updated to follow the spec, and our tests were out of date.

            See: https://github.com/yaml/libyaml/issues/196

            https://github.com/ruby/psych/commit/3f5e520fd3

commit 241cb3fa0316b3846f7b137921301f7279a03161
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-06-08 09:58:19 +0900

    * 2020-06-08 [ci skip]

commit 16aef5da5622971ae83dcc281b03a53c5f622ca3
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-06-07 12:04:23 +0900

    merge revision(s) ac2106acc276854ae2ac8cc5fa6859aa28362f2f,cf90df22c74da2f87421749e8d065cfbd3812afd: [Backport #16813]

            [DOC] Fixed explanation for Method#>> [Bug #16813] [ci skip]

            [DOC] Separated Method#[] from Method#call [Bug #16813] [ci skip]

commit a0c7c23c9cec0d0ffcba012279cd652d28ad5bf3
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2020-03-31 19:27:41 +0900

    v2.7.1p83

commit f832d957b837d5167058a3f8579d66e5b5d3472e
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2020-03-31 19:26:10 +0900

    ext/socket/init.c: do not return uninitialized buffer

    BasicSocket#read_nonblock and some methods changes the size of a buffer
    string, but when no data is available, the buffer is returned as
    uninitialized.

    Co-Authored-By: Samuel Williams <samuel.williams@oriontransfer.co.nz>

commit 5caee29164de6477b5cad1328b56e696a41d5025
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-03-31 16:31:53 +0900

    * 2020-03-31 [ci skip]

commit bb93659fefd7f4557129043742771a33bd30c255
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-03-31 16:10:57 +0900

    Fix pp when passed a empty ruby2_keywords-flagged hash as array element (#2966)

    This causes problems because the hash is passed to a block not
    accepting keywords.  Because the hash is empty and keyword flagged,
    it is removed before calling the block.  This doesn't cause an
    ArgumentError because it is a block and not a lambda.  Just like
    any other block not passed required arguments, arguments not
    passed are set to nil.

    Issues like this are a strong reason not to have ruby2_keywords
    by default.

    Fixes [Bug #16519]

    This backports 28d31ead34baff1c4abc0d7d902ef4bc1d576fb2 and
    0ea759eac9234afc47e8fb1bcacfe9ee12c8ffb6, but needed to be modified
    for 2.7 as 2.7 will perform empty keyword to positional hash
    conversion for required arguments, which will happen if "v" in the
    seplist method is empty when yielded.

    Co-authored-by: NARUSE, Yui <nurse@users.noreply.github.com>

commit d04856bdc502eec4055da1e5cf717639c314e189
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-03-30 19:15:42 +0900

    * 2020-03-30 [ci skip]

commit b5fa156b7907b8ea1baf8b9f0cb6a66b0fecb3d4
  Author: Alan Wu <XrXr@users.noreply.github.com>
  Date:   2020-03-11 23:37:14 +0900

    Clear all trace events during teardown

    Since 0c2d81dada, not all trace events are cleared during VM teardown.
    This causes a crash when there is a tracepoint for
    `RUBY_INTERNAL_EVENT_GC_EXIT` active during teardown.

    The commit looks like a refactoring commit so I think this change was
    unintentional.

    [Bug #16682]

    (cherry picked from commit b385f7670ffa420790bc548747fa4b58c4c5d8f6)

commit 0057fe4063b57b445d6ffc893e442f362e3a19e0
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-03-30 19:09:50 +0900

    Ruby 2.7 backport about IRB (#2990)

    * [ruby/reline] Sort completion list

    #### Legacy mode:

      ```console
      $ irb --legacy
      irb(main):001:0> l[TAB][TAB]
      lambda           load             local_variables  loop
      ```

    #### Before this patch:

      ```console
      $ irb
      irb(main):001:0> l[TAB][TAB]
      local_variables
      loop
      lambda
      load
      ```

    #### After this patch:

      ```console
      $ irb
      irb(main):001:0> l[TAB][TAB]
      lambda
      load
      local_variables
      loop
      ```

    https://github.com/ruby/reline/commit/6074069c7d

    * Drop an invalid char as UTF-8

    * Add test_completion_with_indent_and_completer_quote_characters

    This is for 8a705245e55575d4d310a2e956b89a36a5931971.

    * [ruby/irb] Add tests for RubyLex

    The set_auto_indent method calculates the correct number of spaces for
    indenting a line. We think there might be a few bugs in this method so
    we are testing the current functionality to make sure nothing breaks
    when we address those bugs.

    Example test failure:

    ```
      1) Failure:
    TestIRB::TestRubyLex#test_auto_indent [/Users/Ben/Projects/irb/test/irb/test_ruby_lex.rb:75]:
    Calculated the wrong number of spaces for:
     def each_top_level_statement
      initialize_input
      catch(:TERM_INPUT) do
        loop do
          begin
            prompt
            unless l = lex
              throw :TERM_INPUT if @line == ''
            else
    .
    <10> expected but was
    <12>.
    ```

    https://github.com/ruby/irb/commit/752d5597ab

    * [ruby/reline] Degenerate the terminal size to [$LINES, $COLUMNS] if it is unknown

    This is a workaround for https://github.com/ruby/irb/issues/50

    https://github.com/ruby/reline/commit/5725677d1a

    * [ruby/irb] Fix newline depth with multiple braces

    This commit fixes the check_newline_depth_difference method to multiple
    open braces on one line into account. Before this change we were
    subtracting from the depth in check_newline_depth_difference on
    every open brace. This is the right thing to do if the opening and
    closing brace are on the same line. For example in a method definition we
    have an opening and closing parentheses we want to add 1 to our depth,
    and then remove it.

    ```
    def foo()
    end
    ```

    However this isn't the correct behavior when the brace spans multiple
    lines. If a brace spans multiple lines we don't want to subtract from
    check_newline_depth_difference and we want to treat the braces the same
    way as we do `end` and allow check_corresponding_token_depth to pop the
    correct depth.

    Example of bad behavior:

    ```
    def foo()
      [
      ]
    puts 'bar'
    end
    ```

    Example of desired behavior:

    ```
    def foo()
      [
      ]
      puts 'bar'
    end
    ```

    https://github.com/ruby/irb/commit/7dc8af01e0

    * text/readline/test_readline.rb - fix skip on Reline (#2743)

    TestRelineAsReadline#test_input_metachar passes on MinGW

    * Add "require 'openstruct'" what is forgotten

    * [ruby/irb] Fix lib name of OpenStruct

    https://github.com/ruby/irb/commit/1f3a84ab6b

    * Add load path and require for ruby/ruby

    * Rescue EOFError

    If C-d is pressed before IRB is ready, IRB crashes because EOFError occurs.

    * Complete indented and quoted string correctly

      def foo
        ''.upca[TAB]

    This will be completed to be:

      def foo
      ''.upcase

    The indent was gone. This commit fixes the bug.

    * [ruby/irb] Fix crashing when multiple open braces per line

    https://github.com/ruby/irb/issues/55

    If we had put multiple open braces on a line the with no closing brace
    spaces_of_nest array keeps getting '0' added to it. This means that when
    we pop off of this array we are saying that we should be in position zero
    for the next line. This is an issue because we don't always want to be
    in position 0 after a closing brace.

    Example:
    ```
    [[[
    ]
    ]
    ]
    ```
    In the above example the 'spaces_of_nest' array looks like this after
    the first line is entered: [0,0,0]. We really want to be indented 4
    spaces for the 1st closing brace 2 for the 2nd and 0 for the 3rd. i.e.
    we want it to be: [0,2,4].

    We also saw this issue with a heredoc inside of an array.

    ```
    [<<FOO]
    hello
    FOO
    ```

    https://github.com/ruby/irb/commit/80c69c8272

    * Support history-size in .inputrc correctly

    * Introduce an abstracted structure about the encoding of Reline

    The command prompt on Windows always uses Unicode to take input and print
    output but most Reline implementation depends on Encoding.default_external.
    This commit introduces an abstracted structure about the encoding of Reline.

    * Remove an unused setting variable

    * Use Reline.encoding_system_needs if exists

    * Add tests for vi_insert and vi_add

    * Implement vi_insert_at_bol and vi_add_at_eol

    * [ruby/reline] Implement vi_to_next_char

    https://github.com/ruby/reline/commit/066ecb0a21

    * [ruby/reline] Implement vi_prev_char and vi_to_prev_char

    https://github.com/ruby/reline/commit/0ad3ee63fa

    * [ruby/readline-ext] Include ruby/assert.h in ruby/ruby.h so that assertions can be there

    https://github.com/ruby/readline-ext/commit/4d44c12832

    * Stop using minitest dependent methods

    * Skip a test that uses assert_ruby_status if it doesn't exist

    * Use omit instead of skip

    * Check DONT_RUN_RELINE_TEST envvar

    * [ruby/irb] Add newline_before_multiline_output

    https://github.com/ruby/irb/commit/9eb1801a66

    * [ruby/irb] Fix compatibility with rails before 5.2

    Rails before 5.2 added Array#append as an alias to Array#<< ,
    so that it expects only one argument.
    However ruby-2.5 added Array#append as an alias to Array#push
    which takes any number of arguments.

    If irb completion is used in `rails c` (for example "IO.<tab>")
    it fails with:
      irb/completion.rb:206:in `<<': wrong number of arguments (given 3, expected 1) (ArgumentError)

    Using Array#push instead of Array#append fixes compatibility.

    https://github.com/ruby/irb/commit/5b7bbf9c34

    * Reline: Use a more robust detection of MinTTY

    The previous detection per get_screen_size fails when stdout is passed
    to a pipe. That is the case when running ruby tests in parallel ("-j" switch).
    In this case Reline believes that it's running on MinTTY and the tests
    are running with ANSI IOGate instead of the Windows adapter on MINGW.
    So parallel test results were different to that of a single process.
    This commit fixes these differencies.

    The code is taken from git sources and translated to ruby.
    NtQueryObject() is replaced by GetFileInformationByHandleEx(), because
    NtQueryObject() is undocumented and is more difficult to use:
      https://github.com/git-for-windows/git/blob/c5a03b1e29c69f3f06c8fabd92493edb73469176/compat/winansi.c#L558

    * Reline: Fix changed test results due to change to UTF-8 on Windows

    In commit f8ea2860b0cac1aec79978e6c44168802958e8af the Reline encoding
    for native windows console was changed to hardcoded UTF-8.
    This caused failures in reline and readline tests, but they were hidden,
    because parallel ruby tests incorrectly used Reline::ANSI as IOGate.
    Tests failures were raised in single process mode, but not with -j switch.

    This patch corrects encodings on native Windows console.

    * [ruby/irb] [ruby/irb] Rewrite an expression to detect multiline

    https://github.com/ruby/irb/commit/ed5cf375a6

    https://github.com/ruby/irb/commit/5b7bbf9c34

    * [ruby/reline] Implement vi_change_meta

    https://github.com/ruby/reline/commit/8538e0e10f

    * Always refer to Reline::IOGate.encoding

    * Always use UTF-8 for Reline::GeneralIO on Windows

    * Use test_mode on Reline::History::Test for encoding

    * [ruby/reline] Support GNOME style Home/End key sequences [Bug #16510]

    https://github.com/ruby/reline/commit/788f0df845

    * [ruby/irb] Add a new easter egg: dancing ruby

    https://github.com/ruby/irb/commit/e37dc7e58e

    * [ruby/irb] Exclude useless files from RDoc

    https://github.com/ruby/irb/commit/8f1ab2400c

    * [ruby/irb] Exclude useless files from RDoc

    * Fix inaccuracy in encoding tests

    These tests assume
      Encoding.find('locale') == Encoding.find('external')
    and fail if they are distinct.

    * [ruby/reline] Fix Reline::Windows#scroll_down

    I mistook Right and Bottom.

    https://github.com/ruby/reline/commit/8be401c5f5

    * [ruby/reline] Bypass cursor down when a char is rendered at eol on Windows

    A newline is automatically inserted if a character is rendered at eol on
    Windows command prompt.

    https://github.com/ruby/reline/commit/4bfea07e4a

    * [ruby/reline] Organize special keys escape sequences

    https://github.com/ruby/reline/commit/41deb1a3d9

    * [ruby/readline-ext] Remove unnecessary -I$(top_srcdir) when it's an individual gem

    https://github.com/ruby/readline-ext/commit/efaca4a5f4

    * [ruby/readline-ext] Check TestRelineAsReadline existance

    https://github.com/ruby/readline-ext/commit/c0a6303168

    * [ruby/readline-ext] The ruby/assert.h is adopted by Ruby 2.7 or later

    https://github.com/ruby/readline-ext/commit/106c31fc1b

    * Revert "[ruby/readline-ext] Include ruby/assert.h in ruby/ruby.h so that assertions can be there"

    This reverts commit 425b2064d394639101854c83a061a0918b33b857.

    This cherry-pick was a mistake.

    * [ruby/readline-ext] Use require check instead of DONT_RUN_RELINE_TEST env

    https://github.com/ruby/readline-ext/commit/1df99d1481

    * [ruby/readline-ext] Add spec.extensions

    https://github.com/ruby/readline-ext/commit/8c33abb13c

    * [ruby/readline-ext] Use rake/extensiokntask to build

    https://github.com/ruby/readline-ext/commit/b0b5f709bd

    * Fix readline build dependency

    * [ruby/irb] Add test_complete_symbol

    https://github.com/ruby/irb/commit/dbbf086c1f

    * [ruby/irb] Check doc namespace correctly

    IRB::InputCompletor::PerfectMatchedProc crashes when doc not found because a
    variable name was incorrect.

    https://github.com/ruby/irb/commit/889fd4928f

    * [ruby/irb] Fix auto indent with closed brace

    A closed brace in auto-indent shouldn't affect the next brace in the same line,
    but it behaves like below:

      p() {
        }

    It's a bug.

    https://github.com/ruby/irb/commit/fbe59e344f

    * [ruby/irb] Use 0.step instead of (..0).each for Ruby 2.5

    https://github.com/ruby/irb/commit/5d628ca40e

    * Revert "[ruby/irb] Add test_complete_symbol"

    This reverts commit 3af3431c2c145134996e66f3d8d9ade8ad81bde0.

    * [ruby/irb] fix reserved words and completion for them

    https://github.com/ruby/irb/commit/6184b227ad

    * Add test_complete_symbol

    The previous version of the test method used a symbol, ":abcdefg" to complete
    but longer symbols that can be completed are defined by other test methods of
    other libs.

    * test/irb/test_completion.rb: suppress a warning: unused literal ignored

    * [ruby/reline] Use IO#write instead of IO#print

    IO#print always adds a string of $\ automatically.

    https://github.com/ruby/reline/commit/a93119c847

    * [ruby/irb] Version 1.2.2

    https://github.com/ruby/irb/commit/a71753f15a

    * [ruby/reline] Version 0.1.3

    https://github.com/ruby/reline/commit/ea2b182466

    * [ruby/irb] Include easter-egg.rb in gemspec

    `irb` doesn't run because this file isn't included in the gem.
    https://github.com/ruby/irb/commit/73cda56d25

    * [ruby/irb] Version 1.2.3

    https://github.com/ruby/irb/commit/dd56e06df5

    * support multi-run test for test_readline.rb

    * [ruby/irb] `yield` outside method definition is a syntax error

    https://github.com/ruby/irb/commit/dbc7b059c7

    * test/readline - allow ENV control of test class creation

    In ruby/ruby, the tests run on both readline & reline by creating four test classes:
    ```
    TestReadline
    TestReadlineHistory

    TestRelineAsReadline
    TestRelineAsReadlineHistory
    ```

    Reline inports the test files and uses them in its CI.  Adding the ENV control allows it to only run the `TestRelineAsReadline` classes.

    * Omit test_using_quoting_detection_proc_with_multibyte_input temporarily for random order test

    * support random order test.

    test_readline:
      HISTORY should be empty.

    test_using_quoting_detection_proc:
    test_using_quoting_detection_proc_with_multibyte_input:
      Readline.completer_quote_characters= and
      Readline.completer_word_break_characters= doesn't accept nil,
      so skip if previous values are nil.

    * Set Readline.completion_append_character = nil always

    GNU Readline add a white space when Readline.completion_append_character is
    not initialized.

    * Fix a typo [ci skip]

    * skip test if Reline.completion_proc is nil.

    Some other tests can set Reline.completion_proc, so if it is nil,
    simply skip this test.

    * Reset Reline.point

    TestRelineAsReadline#test_insert_text expects Readline.point == 0
    at the beginning of the test, but a test violate this assumption.

    * Convert incompatible encoding symbol names

    * Ignore incompatible convert of symbols

    * Add workaround for test-bundler failure

    https://github.com/ruby/actions/runs/500526558?check_suite_focus=true#step:16:127
    ```
    Failures:

      1) Bundler.setup when Bundler is bundled doesn't blow up
         Failure/Error: expect(err).to be_empty

           expected `"fatal: not a git repository (or any of the parent directories): .git\nfatal: not a git repository (o...the parent directories): .git\nfatal: not a git repository (or any of the parent directories): .git".empty?` to return true, got false

           Commands:
           $ /home/runner/work/actions/actions/snapshot-master/ruby \
             -I/home/runner/work/actions/actions/snapshot-master/lib:/home/runner/work/actions/actions/snapshot-master/spec/bundler \
             -rsupport/hax -rsupport/artifice/fail \
             /home/runner/work/actions/actions/snapshot-master/libexec/bundle install --retry 0
           Resolving dependencies...
           Using bundler 2.1.4
           Bundle complete! 1 Gemfile dependency, 1 gem now installed.
           Use `bundle info [gemname]` to see where a bundled gem is installed.
           fatal: not a git repository (or any of the parent directories): .git
           fatal: not a git repository (or any of the parent directories): .git
           fatal: not a git repository (or any of the parent directories): .git
           # $? => 0

           $ /home/runner/work/actions/actions/snapshot-master/ruby \
             -I/home/runner/work/actions/actions/snapshot-master/lib:/home/runner/work/actions/actions/snapshot-master/spec/bundler \
             -rsupport/hax -rsupport/artifice/fail \
             /home/runner/work/actions/actions/snapshot-master/libexec/bundle exec ruby -e \
             require\ \'bundler\'\;\ Bundler.setup
           fatal: not a git repository (or any of the parent directories): .git
           fatal: not a git repository (or any of the parent directories): .git
           fatal: not a git repository (or any of the parent directories): .git
           # $? => 0
         # ./spec/bundler/runtime/setup_spec.rb:1056:in `block (3 levels) in <top (required)>'
         # ./spec/bundler/spec_helper.rb:111:in `block (3 levels) in <top (required)>'
         # ./spec/bundler/spec_helper.rb:111:in `block (2 levels) in <top (required)>'
         # ./spec/bundler/spec_helper.rb:78:in `block (2 levels) in <top (required)>'
    make: *** [yes-test-bundler] Error 1
    ```

    * [ruby/irb] Unnamed groups are not captured when named groups are used

    https://github.com/ruby/irb/commit/0a641a69b0

    * [ruby/reline] Work with wrong $/ value correctly

    https://github.com/ruby/reline/commit/962ebf5a1b

    * [ruby/irb] Detect multiple lines output simplify

    The old implementation performance test code:

        require 'objspace'
        puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)
        /\A.*\Z/ !~ ('abc' * 20_000_000)
        puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)

    and run `time test.rb`:

        2.5868 MB
        62.226 MB

        real    0m1.307s
        user    0m0.452s
        sys     0m0.797s

    The new implementation performance test code:

        require 'objspace'
        puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)
        ('abc' * 20_000_000).include?("\n")
        puts "%.5g MB" % (ObjectSpace.memsize_of_all * 0.001 * 0.001)

    and run `time test.rb`:

        2.5861 MB
        62.226 MB

        real    0m0.132s
        user    0m0.088s
        sys     0m0.042s

    https://github.com/ruby/irb/commit/40d6610baf

    * [ruby/reline] Suppress error in case INPUTRC env is empty

    https://github.com/ruby/reline/commit/bce7e7562b

    * [ruby/reline] Add yamatanooroti rendering test

    https://github.com/ruby/reline/commit/f092519525

    * [ruby/reline] Rename test suite name of yamatanooroti test

    https://github.com/ruby/reline/commit/b0f32f5de4

    * [ruby/reline] Add a comment why rescue yamatanooroti loading error on the test

    https://github.com/ruby/reline/commit/2a8061daec

    * [ruby/irb] Suppress crashing when EncodingError has occurred without lineno

    https://github.com/ruby/irb/commit/13572d8cdc

    * [ruby/reline] Suppress error when check ambiguous char width in LANG=C

    https://github.com/ruby/reline/commit/623dffdd75

    * [ruby/io-console] Enable only interrupt bits on `intr: true`

    https://github.com/ruby/io-console/commit/baaf929041

    * [ruby/io-console] bump up to 0.5.4

    * [ruby/io-console] Update the minimum requirement of Ruby version

    https://github.com/ruby/io-console/commit/73e7b6318a

    * [ruby/io-console] Filter Ruby engine name rather than just /ruby/

    This breaks tests using this path on JRuby because the `jruby`
    executable turns into `jjruby` after the sub.

    https://github.com/ruby/io-console/commit/e5951aa34c

    * [ruby/io-console] bump up to 0.5.5

    * [ruby/io-console] Prefer keyword arguments

    https://github.com/ruby/io-console/commit/5facbfc4c8

    * [ruby/io-console] [DOC] Improved about `intr:`

    https://github.com/ruby/io-console/commit/82b630cd79

    * [ruby/io-console] Just ignore the extension on other than CRuby

    https://github.com/ruby/io-console/commit/41b6f09574

    * [ruby/io-console] bump up to 0.5.6

    Co-authored-by: KOBAYASHI Shuji <shuujii@gmail.com>
    Co-authored-by: Ben <kanobt61@gmail.com>
    Co-authored-by: Yusuke Endoh <mame@ruby-lang.org>
    Co-authored-by: MSP-Greg <MSP-Greg@users.noreply.github.com>
    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>
    Co-authored-by: Kenta Murata <mrkn@mrkn.jp>
    Co-authored-by: Lars Kanis <lars@greiz-reinsdorf.de>
    Co-authored-by: Lars Kanis <kanis@comcard.de>
    Co-authored-by: Alan Wu <XrXr@users.noreply.github.com>
    Co-authored-by: Hiroshi SHIBATA <hsbt@ruby-lang.org>
    Co-authored-by: Nobuhiro IMAI <nov@yo.rim.or.jp>
    Co-authored-by: Nick Lewis <nick@puppet.com>
    Co-authored-by: S-H-GAMELINKS <gamelinks007@gmail.com>
    Co-authored-by: Koichi Sasada <ko1@atdot.net>
    Co-authored-by: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
    Co-authored-by: Charles Oliver Nutter <headius@headius.com>

commit ecf874edea92796c63cc2b50b36b1179de5114c6
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-03-28 06:14:02 +0900

    * 2020-03-28 [ci skip]

commit 22c3014e36219b072fd6b1e963c4c64c7015a3cd
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-03-03 20:54:31 +0900

    Suppress an "assigned but unused variable" warning

    (cherry picked from commit 501f2c44e6ae79c02a5c4d0f872fc7fa77258fcf)

commit 44f7e3883e49d287a96f7ef36b5c935d833300e5
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-03-03 15:48:53 +0900

    Preserve `kwarg` flag and fix up f5c904c2a9

    (cherry picked from commit c8d0bf0156878df03a71fffc97c44abf7333d5d7)

commit aeda3a7f036aa7c768abffd1965972c658f49c22
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-03-02 22:37:04 +0900

    Suppress "assigned but unused variable" warnings

    (cherry picked from commit 65dd50fc25f6522536d5c4749055384bde1f9371)

commit 004c298738dc0924e7483b0c3f41c798dabe9e5b
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-03-02 15:49:03 +0900

    Allow newlines inside braced pattern

    (cherry picked from commit f5c904c2a907013e22ff74bc3686952c5448d493)

commit 93aaa0bcce829b880d8f52a9168d17c93ecde85b
  Author: Kazuki Tsujimoto <kazuki@callcc.net>
  Date:   2020-03-01 14:23:51 +0900

    Allow trailing comma in hash pattern

    (cherry picked from commit d25a4f413dce6ad3a8baaf61591415b9a8cce082)

commit 5ccf57f23eb7a35ac699edc2fc598c47fa1844a0
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-03-25 22:00:15 +0900

    Make RbConfig::CONFIG values mutable [Bug #16738]

    As `RbConfig.expand` modifies the argument and involved `CONFIG`
    values, its values should be mutable.

    (cherry picked from commit 4adb2d655dcd54b28366b4d17e86b21e2b622cd1)

commit 7b5133801340cfa7e4e4e5dd61384cb90c3f6085
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-01-08 16:11:52 +0900

    Merge bundler-2.1.4

commit 572021c6e4e01c3b8ece90ad42fdd4ee71b8acc5
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-03-26 23:51:12 +0900

    * 2020-03-26 [ci skip]

commit c9a7643a7e5993975e7e8c985df157d73b16a490
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-03-21 15:46:33 +0900

    test/openssl/test_ssl.rb: ignore SSLError when the connection is closed

    "test_close_after_socket_close" checks if ssl.close is no-op even after
    the wrapped socket is closed.  The test itself is fair, but the other
    endpoint that is reading the SSL connection may fail with SSLError:
    "SSL_read: unexpected eof while reading" in some environments:

    https://github.com/ruby/ruby/actions/runs/60085389 (MinGW)
    https://rubyci.org/logs/rubyci.s3.amazonaws.com/android28-x86_64/ruby-master/log/20200321T034442Z.fail.html.gz
    ```
      1) Failure:
    OpenSSL::TestSSL#test_close_after_socket_close [D:/a/ruby/ruby/src/test/openssl/utils.rb:299]:
    exceptions on 1 threads:
    SSL_read: unexpected eof while reading
    ```

    This changeset rescues and ignores the SSLError in the test.

    (cherry picked from commit be76e86e69106c6906322dc30aa75c3ff65da63c)

commit 897d4e31b0e5b29405480ed3236bc8c5c6cac3fa
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-03-07 03:55:54 +0900

    check ar_table first.

    RHASH_AR_TABLE_SIZE() has assertion that it is a ar_talbe.
    The last commit breaks this assumption so check ar_table first.

    (cherry picked from commit c3584dfacce4d0f2058d8403de6fdce4fd4d686b)

commit ab6f78bc926f6fc12dc8d7846056fc9c04d63ead
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-03-07 03:32:15 +0900

    check ar_table after `#hash` call

    ar_table can be converted to st_table just after `ar_do_hash()`
    function which calls `#hash` method. We need to check
    the representation to detect this mutation.
    [Bug #16676]

    (cherry picked from commit 4c019f5a626523e99e2827ed917802e3097c380d)

commit e4efca87ba1aa5b6a94b9007040ac3e783c26b43
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-03-26 01:16:50 +0900

    check flags passed to rb_nogvl()

    RB_NOGVL_UBF_ASYNC_SAFE is wrongly specified because flags
    is not checked.
    [Bug #15499] 23444302

    (cherry picked from commit ff98931daca1265e5bd33025d160c77e452c399e)

commit 2a3027b7b54a3118731f70c9e88aabbd495bb9fe
  Author: Alan Wu <XrXr@users.noreply.github.com>
  Date:   2020-03-14 09:59:55 +0900

    Add missing write barrier for Hash#transform_values{,!}

    21994b7fd686f263544fcac1616ecf3189fb78b3 removed the write barrier that
    was present in rb_hash_aset(). Re-insert it to not crash during GC.

    [Bug #16689]

    (cherry picked from commit 713dc619f5372a645b66bef9dacee217c4101cb4)

commit 95c3bb6c426a11253644a86137bb67c542fd5799
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-03-16 17:26:10 +0900

    Do not make disabled directories at installation  [Bug #12392]

    (cherry picked from commit 8a6ba10f9dd456cf54de800203cf04bbe42271fb)

commit 1853efc46dba862c50df7710cfbacded999ae2ec
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2020-03-26 21:17:07 +0900

    Use power_assert 1.1.7

    Mainly for pry compatibility in test
    https://github.com/k-tsj/power_assert/commit/dcc14cbef48d9790187fa400a5df7531d81a5971

    Also include "Show full_message if available"
    https://github.com/k-tsj/power_assert/commit/53ce0400bf47f722830d6604be0a2e30cccabf34

commit 47b08728cf3d0441a3da4dc1dcdd578817b0e036
  Author: Jean Boussier <jean.boussier@gmail.com>
  Date:   2020-03-12 21:55:20 +0900

    [ruby/stringio] StringIO#initialize default to the source string encoding

    [Bug #16497]

    https://github.com/ruby/stringio/commit/4958a5ccab
    (cherry picked from commit e257c08f2ec27e2d66cdfa7e2415deb492522e22)

commit 3efbd527a86203406664a01126784a10eb136405
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-01-25 05:13:41 +0900

    Do not autosplat when calling proc with empty keyword splat

    With the removal of the splatted argument when using an empty
    keyword splat, the autosplat code considered an empty keyword
    splat the same as no argument at all.  However, that results
    in autosplat behavior changing dependent on the content of
    the splatted hash, which is not what anyone would expect or
    want.  This change always skips an autosplat if keywords were
    provided.

    Fixes [Bug #16560]

    (cherry picked from commit c1d8829ef515ee51fadeadd7dd022b5c47a71cdd)

commit c858a10ce87033beec63516fe6407b50c6539177
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-03-15 19:35:48 +0900

    * 2020-03-15 [ci skip]

commit a36ead3f4fe801ddaebe6d1ed905e9e3276dbac7
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-02-29 16:58:33 +0900

    Prevent unloading methods used in root_fiber while calling another Fiber (#2939)

    Fixing SEGVs like:
    http://ci.rvm.jp/results/trunk-mjit-wait@silicon-docker/2744905
    http://ci.rvm.jp/results/trunk-mjit-wait@silicon-docker/2744420
    http://ci.rvm.jp/results/trunk-mjit-wait@silicon-docker/2741400
    [Bug #16664]

    (cherry picked from commit adcf0316d1ecedae2a9157ad941550e0c0fb510b)

commit 17e925b9917f4877f2da8c64316feb3ce1ca2932
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-02-29 16:20:44 +0900

    Avoid infinite loop on --jit-wait

    (cherry picked from commit a8dcab723316997d9e01c89d6df969edce75bdca)

commit c6944377d798e088042f2944b81aa3fa8a4e5411
  Author: Jean Boussier <jean.boussier@gmail.com>
  Date:   2020-02-03 20:29:37 +0900

    Fix SimpleDelegator respond_to? regression

    In 2.6, SimpleDelegator would always use the target `respond_to?`

    In 2.7.0 it doesn't if the target does not inherit from Object.

    This breaks compatibility for delegated objects that inherit
    from BasicObject and redefine `respond_to?`. [Bug #16606]

    (cherry picked from commit f2552216d43040cd42bbb9fd484eab6c70856fe6)

commit d07a6dc10efa71123b36a4a3ff7d2ec6e52804d7
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-01-21 11:47:04 +0900

    delegate.rb: fixed keyword arguments in DelegateClass

    `Delegator.delegating_block` should delegate keyword arguments
    separately.  [ruby-core:96949]

    (cherry picked from commit 9bcf4f3db26249772c983896ebbc9ff41f4614db)

commit e70d52b0c377f8b2ed04311710c0ca9f4ebabd90
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-02-25 06:19:37 +0900

    Make ruby2_keywords methods correctly handle **{} optimization

    Previously, this code:

      ruby2_keywords def foo(*a) a.last end
      foo(**{})

    Returned an empty frozen hash.  However, the final hash should
    not be frozen in this case, as it wouldn't be if foo accepted
    a keyword splat.

    Use a new unfrozen empty hash instead of reusing the frozen empty
    hash in this case.

    Fixes [Bug #16642]

commit b3fabedc7043593812c9ad507b4648a55d74df99
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-03-14 20:27:57 +0900

    * 2020-03-14 [ci skip]

commit e7555d467b882fa8213f17643b00557ed420b640
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-31 16:20:17 +0900

    Drop MinGW build from AppVeyor

    in favor of #2791

    (cherry picked from commit b00418732c89ce42c1c4cef57d08344659fbdd2b)

commit 0d24fb774d84d4a99454ce10fd343da00049a588
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-03-09 23:57:16 +0900

    Don't display singleton class in Method#inspect unless method defined there

    Previously, if an object has a singleton class, and you call
    Object#method on the object, the resulting string would include
    the object's singleton class, even though the method was not
    defined in the singleton class.

    Change this so the we only show the singleton class if the method
    is defined in the singleton class.

    Fixes [Bug #15608]

    (cherry picked from commit e02bd0e713ef920e6d12c27f16548f48ec5c2cf0)

commit eabf35a5d298c68f45dc600477fc586d7b868788
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-02-10 12:15:48 +0900

    Fixed duplicated warning

    As `command_rhs` is always a "value expression", `command_asgn`
    does not need the same check. [Bug #16619]

    (cherry picked from commit 6e6844320de989cb88a154e2ac75066ccea1bba2)

commit fa48a26d886d86469a0075d91d152252e9fc0c8c
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-02-24 15:33:50 +0900

    Fixed symbol misused as ID

    `rb_funcallv_public` and `rb_respond_to` require an `ID`, not a
    `Symbol`.  [Bug #16649]

    (cherry picked from commit 8b6e2685a4b7c7de905f7ed60c02ef85e0724754)

commit 3e7e1b965b06f3c843972d7e2f6e3d040374d67f
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-02-18 14:34:26 +0900

    Pass keyword arguments to IOs properly [Bug #16639]

    (cherry picked from commit 041c2932e336b509b0ddc1fdbd9f160bce8d4893)

commit 2339be74e737b4c5f5330f845af2e7db0c7450e1
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-02-15 16:27:03 +0900

    lib/drb/drb.rb: Use ruby2_keywords for keyword separation

    [Bug #16634]

    (cherry picked from commit fb472ca7adbaceb35aae1b3a6b948720ffc9eb53)

commit c7e0ce67430b5e312eb626a2c2f4b6a810b3b68b
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-02-04 15:21:49 +0900

    Add the loaded feature after no exception raised

    Retrying after rescued `require` should try to load the same
    library again.  [Bug #16607]

    (cherry picked from commit 7d6903dc476f982e7b432adbeef3a3d9372a309f)

commit 7518b4e945675df9aca223c30ca711e1d82341ec
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2020-03-13 22:31:29 +0900

    fix the order of definition

commit fcaa00e58fd3a4cbaa19c6558783b43ee324d19e
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-03-07 20:42:44 +0900

    Use osuosl instead of GitHub releases

      Because the package provided by GitHub releases is different from sourceware.

    (cherry picked from commit 47a1872cd8b901b8aab6dedce7fa3807c97d290d)

commit 6a2d779027818eda418c9118f700b36816e833a5
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-03-07 19:57:28 +0900

    Switch to download libffi source package to github releases from sourceware.org

    [Bug #16681]
    (cherry picked from commit 86022167461dc90b70164e2bb23316959bbfd6ba)

commit 60d98fad86da1ada204c53789431ac0f5f3390ff
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-01-17 23:49:26 +0900

    [ruby/io-console] Set `OPOST` when `intr` is true

    To enable implementation-defined output processing, for the
    compatibility with readline.  [Bug #16509]

    https://bugs.ruby-lang.org/issues/16509

    https://github.com/ruby/io-console/commit/8c8b0b6757
    (cherry picked from commit 4e56ec4ef74cf77dbcb4ce7c669e0595cd0d12fa)

commit 9f504bb474770f1cac68988eac2a410e41c4bbb8
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-02-09 16:56:40 +0900

    Separate objspace argument for rb_gc_disable and rb_gc_enable

    (cherry picked from commit aeaf0dc55595b8a5bfdd92007fb85ef13855c632)

commit 047dfbdf69e1a300109c729c66b6a761032402dd
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-01-28 09:18:12 +0900

    Skip empty directories to install [Bug #16596]

    (cherry picked from commit 33d02e6bc7502c5a3f09c59908a8c9f08a474b8d)

commit 5bdbee96e479f714c7f9b6b98f012268cbd9051b
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2020-03-13 21:43:44 +0900

    Squashed commit of the following: [Backport #16516]

    commit c98c492578d898dc07a04b8240d8d5b1508ffafa
    Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
    Date:   Fri Jan 17 16:56:53 2020 +0900

        Added test for f38b3e8c707ebdcad05aa9485cf1760640b74fbb

    commit f38b3e8c707ebdcad05aa9485cf1760640b74fbb
    Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
    Date:   Thu Jan 16 18:34:31 2020 +0900

        Fixed the location of args node with numbered parameter

commit a9284ecb90176b4d8e9aa264da14ea08931be48f
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-02-09 16:41:56 +0900

    Disable GC until VM objects get initialized [Bug #16616]

commit 215eb86a7729bf0db487f399031ad55a1062fada
  Author: Jean Boussier <jean.boussier@gmail.com>
  Date:   2020-01-15 22:40:01 +0900

    Increase the frozen_strings table initial size

    It was set to 1000 in a4a2b9be7a55bb61d17cf9673ed0d2a93bb52d31.

    However on ruby-2.7.0p0, there are much more than 1k frozen string right after boot:

    ```
    $ ruby -robjspace -e 'p ObjectSpace.each_object(String).select { |s| s.frozen? && ObjectSpace.dump(s).include?(%{"fstring":true})}.uniq.count'
    5948
    ```

commit 8a54630a6608d9b1a9d32db2ba33289a5454810d
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-03-13 21:32:13 +0900

    * 2020-03-13 [ci skip]

commit 3c93ed59773ca547239850d16f06451afbb0aeec
  Author: Adam Isom <adam.r.isom@gmail.com>
  Date:   2020-01-17 06:42:36 +0900

    Update documentation for Array/Hash Argument section of methods.rdoc

    [Bug #16514]

commit c3cd92582f970812be51310e377c82b6d9e7be92
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-02-20 00:13:44 +0900

    Use `brew upgrade` instead of `brew update`

commit 0149863dff42e0b7b6876cc3669aa3efcab6776e
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-02-20 16:36:30 +0900

    * 2020-02-20 [ci skip]

commit eaee631d5eda03f77ec39ec6fc1826a06ab06205
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-02-19 16:16:19 +0900

    Avoid jumping to a wrong destination

    when the next insn is already compiled by former branches.

commit ccc3b9119c39a6cb08a643ab3d15a9c07ec28b1a
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-02-18 15:30:37 +0900

    * 2020-02-18 [ci skip]

commit 789c1df10a13a53d0504d4ba87c4e246692b1973
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2020-02-18 15:30:00 +0900

    increment teeny

commit 0643eb2e59dbd80f9be001c2ec77c980e8aeff3f
  Author: Ryuta Kamizono <kamipo@gmail.com>
  Date:   2020-01-19 12:49:40 +0900

    Fix typo s/test_ruby2_keywords_hash!/test_ruby2_keywords_hash/

    In #2818, `Hash.ruby2_keywords!` has renamed to `Hash.ruby2_keywords_hash`.

commit 9820f9ee0aaccd78e6e0489e8915d3925c6ee97c
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-01-06 18:22:43 +0900

    hash.c: Add a feature to manipulate ruby2_keywords flag

    It was found that a feature to check and add ruby2_keywords flag to an
    existing Hash is needed when arguments are serialized and deserialized.
    It is possible to do the same without explicit APIs, but it would be
    good to provide them as a core feature.

    https://github.com/rails/rails/pull/38105#discussion_r361863767

    Hash.ruby2_keywords_hash?(hash) checks if hash is flagged or not.
    Hash.ruby2_keywords_hash(hash) returns a duplicated hash that has a
    ruby2_keywords flag,

    [Bug #16486]

commit 420a88d3da6deb5f7d4d8e088cb3737b9a23d29d
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-02-13 15:23:02 +0900

    * 2020-02-13 [ci skip]

commit 78cbe7106b67d007ffdcc1276b352212eaaef4b2
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-01-31 12:52:22 +0900

    Return the makefile content

    Block for `create_makefile` is expected to return the content of
    the makefile.

commit b8e62ccaecf49372833d7eeeb3fdfded4bb2f042
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2020-01-31 08:00:56 +0900

    Move .IGNORE in extconf.rb

commit a89821243da3c80e08bf46669e16ae46d687c80b
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2020-01-31 06:34:49 +0900

    Support nmake

commit a930174d798b58ee10493bf192d277ffe08518a7
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2020-01-31 02:46:05 +0900

    Ignore expected errors on compiling C++ source [Bug #16331]

    BSD make can run parallel more aggressively than GNU make. It communicate
    with other make process through -J option in MAKEFLAGS environment variable
    to notify a build failure happend in an other pararell make process.
    https://www.freebsd.org/cgi/man.cgi?make

    It usually works well but ext/-test-/cxxanyargs/Makefile has two targets
    which are expected to fail (failure.o and failurem1.o).

    Additional note:
    To test and debug this issue, following command will speed up it.
    `make -f exts.mk -j8 clean all`

commit 95ab9cd8f453099d7649dc0e0eec55ea891340f5
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-02-11 15:52:25 +0900

    Restart timer thread even after preparation failed

    If the timer thread is left stopped, memory crash or segfault can
    happen. [Bug #16624]

commit 9c07f803db1c20241fa73e91a8a959d6cbb82e8b
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2020-01-30 13:36:47 +0900

    check ruby_2_7 branch

commit 49430aa4e5bf4020dbdb1cce3bc547cffad6ffae
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-01-19 11:02:18 +0900

    Allow rexml to fail on macOS of Github Actions

    And revert "Stop test-bundled-gems on macOS for now",
    28b290f7f4cb332dab3ddf3132e1916d413ea65c.

commit 30a9dc4aa9cb1985cfe5bd318b8b35dacc103127
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-01-19 09:48:33 +0900

    Stop test-bundled-gems on macOS for now

commit 095a937dc2c0924dbfda7f7625ac2921a10de231
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-01-17 17:25:05 +0900

    .github/workflows/cygwin.yml: Removed

    There is no active maintainer for cygwin.  The CI failure is too noisy.

    [Misc #16407]

commit 5eced3c030f39d10e193c5e33a70365d8e011bb1
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-01-13 10:02:04 +0900

    Checkout with git on cygwin for EOL code

    `shell: bash` runs bash on msys which prefers git on msys too,
    then checked out in CRLF mode.  Cygwin sed doesn't consider the CR
    a part of EOL code, though.

commit 6ec6acd76ed7c718a469841afe4f32571e757c9d
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-01-12 09:59:10 +0900

    Allow failures with rss tests on test-bundled-gems

commit 504b082f364e35516b2727c11713c28b684b5af0
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-01-11 16:24:16 +0900

    Add branch option to checkout on push

commit 5dc82455aef4a42817208e11fbfbcdc1351f0734
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-01-06 18:52:19 +0900

    Slightly change the job wording [ci skip]

    mame-san said it's weird

commit 7d4243254629004007a390f7f1afc4a570a1fd00
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-01-06 18:45:47 +0900

    Support running Actions on a fork

    Since 8c9450e7b875db846b19cc631af0d7fee66db5c6, we increased the chance
    to run GitHub Actions on a fork, as we usually use a topic branch
    instead of master when filing a pull request.

    This patch makes it possible to reuse the same GitHub Actions config on
    a fork repository.

commit bd48a28b1cb9848d194a82139d018f87dd689f99
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-01-06 18:42:30 +0900

    Directly refer to GitHub events

    instead of unnecessarily defining env vars

commit 48f82ad28961c0998b1d426493614875bb487d29
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-01-01 15:03:07 +0900

    Remove code to prevent double build on trunk

    trunk branch was deleted.

commit fdd9d7cd41cde130889d84414395da22706972c8
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-01-01 14:26:39 +0900

    More consistent failure notifications

    The format is the same as Travis / AppVeyor now.

commit 531bbec111d588ad497dd528eae3ac36e2af2632
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-01-01 08:27:40 +0900

    Make test run condition consistent with other jobs

    When `make all` fails, we should not run tests and output of such run is
    confusing.

commit 4d04b32986bb73bfd5d5e56bcd17cfa82c90885c
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-01-01 03:24:00 +0900

    Run tests in the consistent order

    `make check` runs test -> test-all -> test-spec, and other CIs follow that too.

commit 24621f23e5cc9403910b82e671c2b299ec65bd67
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-01-01 02:37:03 +0900

    Fix an outdated comment

    We're actually using it for PR :p

commit e3dfd9f2b5729d4d8ac4541110af409ee218aadd
  Author: MSP-Greg <MSP-Greg@users.noreply.github.com>
  Date:   2020-01-01 02:35:43 +0900

    Actions MinGW - fix test-all (#2803)

commit a24d2f3b8cf98d067f6648a0609b6251d3e0a464
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-01-01 02:34:29 +0900

    Use actions/checkout for PR (#2804)

commit 77dfa520d476143b8be6c4805354838012b4d335
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-31 18:49:08 +0900

    Official actions/checkout is useless

    It died again https://github.com/ruby/ruby/runs/368837347

commit 124878c6aad7c708d7121199bea29962713d319a
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-31 16:46:17 +0900

    Make Slack notifications consistent

commit 110b4e974ddb74472a0eb3ce181705b47eb28d50
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-31 16:42:20 +0900

    There's no such target

commit 4d9f106eaefeee4b160d3c5580039c64ff9c01ae
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-31 16:30:34 +0900

    Make all Actions job names consistent

    like "{platform} / make ({make target}, ...)"

commit ca48fa8e81ca19f4d0c24017662245c933be86eb
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-31 16:23:25 +0900

    Do not doubly build on trunk

commit 44ef8af4fb0a793f020147e3f077cd061953c8fa
  Author: MSP-Greg <MSP-Greg@users.noreply.github.com>
  Date:   2019-12-31 16:19:31 +0900

    MinGW on Actions (#2791)

    * MinGW - skip spec in spec/ruby/optional/capi/thread_spec.rb

    C-API Thread function rb_thread_call_without_gvl
          -- runs a C function with the global lock unlocked and unlocks IO with the generic RUBY_UBF_IO

    stops/freezes spec tests

    See https://bugs.ruby-lang.org/issues/16265

    * MinGW - skip test test/resolv/test_dns.rb

    Test times out in CI (both AppVeyor & Actions), cannot repo locally

    * MinGW - skip test test/ruby/test_thread_queue.rb

    * Add Actions mingw.yml

commit 6646c2b2ab7efd389075ad5f187b458c4bc138cc
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-31 16:09:24 +0900

    Revert "Remove TEST_BUNDLED_GEMS_ALLOW_FAILURES"

    This reverts commit 75e8dd58f69c190c9698d0133942032903fb2f07.

    We seem to randomly hit another issue these days:
    https://github.com/ruby/ruby/runs/368756135
    https://github.com/ruby/ruby/runs/368756191

commit 716e05b82338d75452e86c999ae3e5874a642ecd
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-01-27 10:46:57 +0900

    Fixed a segfault `GC.verify_compaction_references`

    Which is by coercion of `Qundef`, when any keyword argument
    without `toward:` option is given.  [Bug #16598]

commit 52bb32d6b71365cb24273de3eed5a712206815f3
  Author: Alan Wu <XrXr@users.noreply.github.com>
  Date:   2019-12-31 08:13:55 +0900

    Fix Proc#<< spec

    [Bug #16406]

commit db4d136889afbf59e69efcfd495fd91cd401f378
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-01-16 11:25:43 +0900

    `Regexp` in `MatchData` can be `nil`

    `String#sub` with a string pattern defers creating a `Regexp`
    until `MatchData#regexp` creates a `Regexp` from the matched
    string.  `Regexp#last_match(group_name)` accessed its content
    without creating the `Regexp` though.  [Bug #16508]

commit 8e8841f6bf58031a1fe5b0dbacb5a1fb442102df
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-01-13 03:36:47 +0900

    reload AR table body for transient heap.

    ar_talbe (Hash representation for <=8 size) can use transient heap
    and the memory area can move. So we need to restore `pair' ptr after
    `func` call (which can run any programs) because of moving.
    [Bug #16503]

commit 48f324e92f9b36edc267f9871e35039cbd1c2eb9
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-01-09 08:21:42 +0900

    lib/net/imap.rb: use `&blk` instead of Kernel#proc with no block

    [Bug #16488]

commit 580edc25aa00930bdb71b244d70a2007905f5fec
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-01-06 11:36:51 +0900

    script_compiled event on compile error.

    script_compiled event for TracePoint should not be invoked on
    compile error (SyntaxError) because it is not "compiled".
    [Bug #16459]

commit 647ee6f091eafcce70ffb75ddf7e121e192ab217
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-25 18:46:39 +0900

    [ruby/reline] Version 0.1.2

    https://github.com/ruby/reline/commit/b41024e317

commit 1341a279a4becd91f35b23eca6d129990eccc8bb
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-25 18:45:02 +0900

    Save last breaking point to complete

commit a52e364e6541a6e234718ac63aa7eb5c3f2c832f
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2019-12-25 18:02:53 +0900

    fix version regexp

commit ecbf7fe27ce444782f0a48fc41f8043a25078666
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2019-12-25 17:01:26 +0900

    fix typo

commit a65e8644fb97491314387e4138cabf6378a8e8d5
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2019-12-25 15:48:56 +0900

    v2.7.0p0

commit 75dca097b873222eaf3c70b7f43e3ffb98b7f2ed
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-25 14:13:15 +0900

    [bundler/bundler] Do `require "rubygems"` only when needed

    This require causes circular require.

    ```
    $ touch empty_file

    $ RUBYGEMS_GEMDEPS=empty_file ./local/bin/ruby -w -e ''
    /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92: warning: /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92: warning: loading in progress, circular require considered harmful - /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems.rb
            from <internal:gem_prelude>:1:in  `<internal:gem_prelude>'
            from <internal:gem_prelude>:1:in  `require'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems.rb:1417:in  `<top (required)>'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems.rb:1203:in  `use_gemdeps'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/user_interaction.rb:47:in  `use_ui'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems.rb:1204:in  `block in use_gemdeps'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92:in  `require'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92:in  `require'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/bundler.rb:11:in  `<top (required)>'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/bundler.rb:11:in  `require_relative'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/bundler/rubygems_integration.rb:3:in  `<top (required)>'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92:in  `require'
            from /home/mame/work/ruby/local/lib/ruby/2.7.0/rubygems/core_ext/kernel_require.rb:92:in  `require'
    ```

    https://github.com/bundler/bundler/commit/c7c5bcea92

commit 27453b04c85249372950b6b12fabbef8c0d1a80b
  Author: Kenta Murata <mrkn@users.noreply.github.com>
  Date:   2019-12-25 15:21:50 +0900

    Update the version of bigdecimal to 2.0.0 (#2784)

  Notes:
    Merged-By: mrkn <mrkn@ruby-lang.org>

commit 56e002981fab73a94c6038cb9de82aba6ff84eb4
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-25 14:47:31 +0900

    Show the error line only when same as the current

commit 9808e010907bb16068497d9f0f8593a7165fa42d
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-25 14:37:53 +0900

    export a function for MJIT.

    rb_iseq_complete() can be used by MJIT.

commit d9bf9c572f461c282fa6e65833e98bc7d453a66f
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-25 14:10:35 +0900

    take care of USE_LAZY_LOAD=1.

    On USE_LAZY_LOAD=1, the iseq should be loaded. So rb_iseq_check()
    is needed. Furthermore, now lazy loading with builtin_function_table
    is not supported, so it should cancel lazy loading.

commit 81e377023c490998a3fec245ca2fb2b3c710c2c6
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-25 13:35:22 +0900

    range.c: Range#min with a beginless one now raises an explicit exception

    [Bug #16450]

commit cd6c013b075c9c27437f30efcee9d4dd9e0ee1c5
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-25 12:55:31 +0900

    Add readline and readline-ext to default gems list in NEWS

commit 227c3d642631262acfbf140c566a7841c32b372f
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-25 12:06:02 +0900

    add ref to NEWS entry

commit 3345eab934073bdd8394ee8a46fc18954999af76
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-25 11:37:27 +0900

    NEWS: add a ticket reference

commit b9e35d27096290f9544dca685fb4cf5bd0e09397
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-25 11:31:44 +0900

    NEWS: add a ticket reference

commit e0929c44ddc7490dc97cabf12c7505173316a623
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-25 11:27:13 +0900

    NEWS: add ticket references

commit eb3f19b9b896094ae9754de1b48fed86fb35fe39
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-25 11:17:24 +0900

    update-bundled_gems: drop branch name on github [ci skip]

commit 00710d10761ad1aa752cf2c035e3bfbde40092b6
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-25 10:47:53 +0900

    [ruby/readline] Version 0.0.2

    https://github.com/ruby/readline/commit/42b71f3fc0

commit e51a34511c9e4394467cde24deee19cf8536a3e7
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-25 10:47:34 +0900

    [ruby/readline] Use a box to make easier to see the message

    https://github.com/ruby/readline/commit/e49e942053

commit 57c74841c7bc2bb2ffbb8ed89597e993116e26a8
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-25 10:44:52 +0900

    [ruby/readline] Fix any wrong in messages

    https://github.com/ruby/readline/commit/a2cf437c8f

commit de0f4f2fd7620e2486f5aef031dad18324437c2b
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-25 10:30:24 +0900

    [ruby/readline] Version 0.0.1

    https://github.com/ruby/readline/commit/d2363cad33

commit 5d20865708552a522d5eb39c4d9238f96693f8f2
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-25 10:25:15 +0900

    [ruby/readline] Add post_install_message

    https://github.com/ruby/readline/commit/03126372b5

commit 999a2819a75e40aec405e088d01b12eda341025d
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-25 10:31:03 +0900

    [ruby/readline-ext] Version 0.1.0

    https://github.com/ruby/readline-ext/commit/f5abaf5be1

commit 246242700867ed3fdce8288897d74bd261379018
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-25 10:08:06 +0900

    [ruby/reline] Version 0.1.1

    https://github.com/ruby/reline/commit/923f97d068

commit ed5b4bae6a4f991a0c5299581bd0b137a98d3723
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-25 09:52:25 +0900

    The behavior of vi_end_of_transmission should be the same of vi_list_or_eof

commit 03c504ac59a2bf78bab925379e93184d81296e96
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-25 09:38:12 +0900

    Commented-out btest on cygwin environment of GitHub Actions

commit 622e47a1dbeee52fb218b816943b69cb88e17ae6
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-25 09:29:46 +0900

    ^D on non-empty line in vi mode behaves like Enter

commit 8e6d51e09a93ae2c57d56105a5fd39fb92855394
  Author: Yuki Nishijima <yk.nishijima@gmail.com>
  Date:   2019-12-25 08:41:26 +0900

    Sync did_you_mean

commit 2b2be71cabf987effd2783747eedf573af1400cf
  Author: Yuki Nishijima <yk.nishijima@gmail.com>
  Date:   2019-12-25 08:23:59 +0900

    Add did_you_mean's promotion to the NEWS

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2782

commit 1857b4427817755bb0879ca67e1b2f3276f95d4c
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-25 07:28:02 +0900

    Merge Bundler 2.1.2 from bundler/bundler.

    [Misc #16449][ruby-core:96458]

commit da0a0bae8b50087d140309b27eb4d4b4776c27e4
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-25 06:13:49 +0900

    NEWS: add meaning of "CoW" ("copy-on-write")

commit ceba5b70889666b82b80910a441cf4a92b5c7160
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-25 05:50:27 +0900

    [DOC] Fix typo in Time#inspect

commit f3067deb88badf8d15e49d13f082284f58b2c62b
  Author: Alan Wu <XrXr@users.noreply.github.com>
  Date:   2019-12-25 04:54:20 +0900

    Revert "Add NEWS entry about Module#name performance (#2779)" (#2781)

    This reverts commit 3e9221d94a12b54c1285923b642364acdbc31c7e.

  Notes:
    Merged-By: XrXr

commit 3e9221d94a12b54c1285923b642364acdbc31c7e
  Author: Alan Wu <XrXr@users.noreply.github.com>
  Date:   2019-12-25 04:02:50 +0900

    Add NEWS entry about Module#name performance (#2779)

  Notes:
    Merged-By: XrXr

commit 5220145ea289d9eb955b373f31773fab2d4f0271
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-25 01:32:37 +0900

    add debug_counter access functions.

    These functions are enabled only on USE_DEBUG_COUNTER=1.

commit 9b617ffa8884f9f80a0b1bdb89169d8139ba5001
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-25 01:00:40 +0900

    * 2019-12-25 [ci skip]

commit 3679023df822d8bf3f88b9b2e4b849318d2c409e
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-25 00:57:30 +0900

    [DOC] Fix typo and language

commit 8c017824c8eeffe11070ce69c914725af314d9f6
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-24 22:31:38 +0900

    Added entry for json-2.3.0

commit 1cd2ebed616473ed56730292879e8bc9d6dfd060
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-24 21:39:37 +0900

    Update the news entries for RubyGems and Bundler

commit 05b0410f91360e15511903580f0401b123f3abce
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-24 21:17:00 +0900

    [ruby/irb] Fix typo

    https://github.com/ruby/irb/commit/4bb1340687

commit 54083fd41bf876b42e1a97acdc7574c8edbb87ed
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-24 21:01:47 +0900

    [DOC] Fix grammar in Process module docs

commit 66e518f7b3e0bf307f86a51e6db02c3d1ec8df84
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-24 21:01:24 +0900

    [DOC] Fix typo

commit 4ba9347554ab1ac79fdaf1d5b3320776a2b10615
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-24 18:49:57 +0900

    `Object#=~` warning also obeys `Warning[:deprecated]`

commit a3c5dbf29191aa8622d8be7d990c4ac2f9392427
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-24 14:56:17 +0900

    Scale sleeping times to wait for the OS operations

commit 7758849cb5432ae974f616668f9c9bab415bb18a
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-24 18:39:48 +0900

    Remove unused variable

commit 42e2a322f100c7c798fcfbcbbfe0b4cdaf3f5855
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-24 18:32:50 +0900

    The delete-char-or-list shows completed list when called at end of line

    It doesn't behave the same as the delete-char.

commit b03aea62abfbdc7c8ee53c30a27127c3c394a6ba
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-24 18:02:22 +0900

    NEWS: fix method references for Range#{cover?,include?}

commit 44a1f51695058159ff2f191c97a082bed9665137
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-24 17:49:22 +0900

    NEWS: improve sections for warning option / Warning

commit 27b4f477d960c75f3ff5cd5e045b307cad314ec7
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-24 17:03:42 +0900

    [DOC] Improve docs for Enumerator.produce, Enumerator.new

commit 81504e83e72bf125476528e5f119604d9697f682
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-24 15:47:59 +0900

    Synchronize with a Queue instead of sleeping

commit 47ad57f2450251f47b3f8e1f744d782269bbcdeb
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-24 15:38:46 +0900

    Revert "Scale sleeping times"

    This reverts commit e57d6194218efc73c30f3fed9dd321d2e357030b.

    Test fails:
    http://ci.rvm.jp/results/trunk-gc-asserts@ruby-sky1/2518563
    http://ci.rvm.jp/results/trunk-gc_compact@silicon-docker/2518533

commit c47106699cf2bcf426285efcd795223c200a3120
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-24 14:57:55 +0900

    NEWS: added references to warning option [ci skip]

commit e57d6194218efc73c30f3fed9dd321d2e357030b
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-24 14:56:17 +0900

    Scale sleeping times

commit adf498b84f56e57b74b72a3ddcc512f6d2078cef
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-24 13:24:41 +0900

    Moved warning option section and added a reference [ci skip]

commit 302e896833bc611ba39c8697712313fd2dbd70cc
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-24 13:12:28 +0900

    Added warning.rb to .document

commit 3739ddc36f462b794ec05c0cfc36458a8d1e17a7
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-24 12:11:42 +0900

    Added `-W:experimental` to `--help` [Feature #16420]

commit d0f1eb3e4ef7cde2d78b493b3ba1561eee79b18f
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-24 11:28:18 +0900

    Separated command line option in NEWS [ci skip]

commit 5a62fb1277fb351a1a11b89b0f8510c8f1a0cdff
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-24 11:14:13 +0900

    Mentioned `-W:` command option in NEWS [ci skip]

commit f2e1e6cba451375d8eb839bf2e7c9a39bccc044c
  Author: zverok <zverok.offline@gmail.com>
  Date:   2019-12-22 06:23:20 +0900

    Enhance explanations for beginless range and #clamp, and add missing feature

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2769

commit e954be14d07e54b8dbf71c0fa227e5818eaa01e6
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-24 10:27:18 +0900

    Get rid of false positive misspellings

    [Bug #16437]

commit 992aa2cda50140abbca165024682eae998756e2d
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-24 10:24:45 +0900

    enc/x_emoji.h: fixed dead-links [ci skip]

    English version pages seem no longer provided.

commit f09a4ff265093742c356c69bcf56db68bd6cf064
  Author: manga_osyo <manga.osyo@gmail.com>
  Date:   2019-12-24 09:53:36 +0900

    Added NEWS for Feature 15373

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2777

commit 360f153fcaab637486aa2669d354d53e0eb1c3d2
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-24 10:23:38 +0900

    remove "experimental" from numbered parameter.

    Numbered parameter is not an experimental feature,
    confirmed by Matz.
    https://twitter.com/yukihiro_matz/status/1209271452798607361

commit 5e17834fc900a699241764ef0baacd53992d7f07
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-24 09:55:05 +0900

    [ruby/reline] Version 0.1.0

    https://github.com/ruby/reline/commit/55d4dfec1e

commit 8316b330fb04413bb480462941cb6b14c5352e2e
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-24 09:54:38 +0900

    [ruby/irb] Version 1.2.1

    https://github.com/ruby/irb/commit/8da0c74640

commit 0e528ae9cb5c1078e4d07287e403cb548e97f0a3
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-24 09:53:43 +0900

    [ruby/irb] Remove warning message to bundle on Ruby 2.7.0

    https://github.com/ruby/irb/commit/d9a7844f50

commit 0231661939310951c8ed339d8600a53a21015918
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-24 08:13:46 +0900

    [DOC] Fix wording in Math::E documentation

commit 30c5e8c4b9353dfb716033901cec7529eace3922
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-24 08:03:00 +0900

    [ruby/rdoc] Version 6.2.1

    https://github.com/ruby/rdoc/commit/c65e14d112

commit 2bf0743edcf6fd70cd73952e1e023821c4549a9e
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-24 07:58:49 +0900

    Update parsers of RDoc that are generated by Racc

commit adc9b3ca7f4e75e368731fe8a7092ce078bcec04
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-24 07:41:37 +0900

    [ruby/rdoc] Support newline in the middle of constant definition

    https://github.com/ruby/rdoc/commit/74d3984324

commit e50e55269358520dc55595a9c3e074d351d96b66
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-24 07:00:35 +0900

    [ruby/rdoc] Treat Proc#call syntax sugar for constant correctly

    https://github.com/ruby/rdoc/commit/957d041ae0

commit 819b604037c317d2b53a1aaca67aef25da2d5ec9
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2019-12-23 16:34:16 +0900

    Reword keyword arguments warning messages to convey these are deprecation warnings

commit df6f5c44af1f261fa940ec3954468be8b820450e
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-24 06:41:58 +0900

    [DOC] Fix invalid code to make it syntax highlighted

commit a7b5018495c4a6b82d779958b086647226ce61e7
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-24 06:07:02 +0900

    [DOC] Use capitalized "Ruby"

commit ba9ccef81811e9387c0189d596189236b25d0dba
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-24 06:04:59 +0900

    [DOC] Various fixes in bug triaging guide

commit aa01441fd29be8be28644db7abac9f7940fcc814
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-24 04:17:11 +0900

    * 2019-12-24 [ci skip]

commit f201700051cc107b55c425bf331ce6d7ad3ef22b
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-24 04:16:40 +0900

    move a NEWS entry about inline method cache

commit 16fddfe352828d26aaa6cdbce696e62de04511ce
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-23 23:02:59 +0900

    [DOC] Improve readability of requirements for <=>

commit 9a42e0c7ed4dcc57043a8a35a50686625adba686
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-23 22:46:58 +0900

    NEWS: add reference for [Feature #14405]

commit de1a462454f4196490263c9be8be16a44513f5a0
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-23 22:45:24 +0900

    NEWS: revise grammar, language, markup, etc.

commit bbde77cd2694e87646842777e873d849bbf5703e
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-23 17:46:08 +0900

    NEWS: fix some typos, grammar, and language

commit 100fc2750b8f2c4dbe0aaa6c622bbf5f6d61e3c0
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-23 17:04:31 +0900

    fix wmap_finalize.

    wmap_finalize expects id2ref() returns a corresponding object
    even if the object is dead. Make id2ref_obj_tbl() for this
    purpose.

commit 9eeaae432b9a894e28e3906435f3d454d8fd025c
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-23 16:30:45 +0900

    add more debug counters to count numeric objects.

commit 7779ade48c2786992e41c0ab87761ab467f4be49
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2019-12-23 15:59:17 +0900

    NEWS: Fix issue reference [#15807] [DOC]

commit dadf1255b6e13578f888c239f0dc6fb201fd40bb
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2019-12-23 15:55:39 +0900

    README: Add Range#minmax to the list of potential incompatibilities [#15929] [DOC]

commit 3e1adf573110ddce8f900d9473dde7fa7de9c0e2
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2019-12-23 15:48:38 +0900

    README: Improve wording [DOC]

commit 7df2503b7770147a8589a594bf30726f733b1d86
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2019-12-23 15:37:45 +0900

    NEWS: Hint at potential incompatibility with Range#minmax [#15807]

commit a96f8cecc2488126d7298ea304da8bad3dde1792
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-23 15:02:14 +0900

    ObjectSpace._id2ref should check liveness.

    objspace->id_to_obj_tbl can contain dead objects because of lazy
    sweep, so that it should check liveness.

commit 672a61b97fe0cdb256611c707e7cc69856208467
  Author: Yuki Nishijima <yk.nishijima@gmail.com>
  Date:   2019-12-23 14:47:03 +0900

    Port https://github.com/ruby/did_you_mean/commit/dd1dd86e6c3188c36224d5dd4389676e6653a727

commit 92d0958257965adf426e6f6c654c5935a690bf5b
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-23 13:23:08 +0900

    FrozenError.new accepts :receiver instead of 2nd argument [ci skip]

    [ruby-core:96227] [Feature #16419]

commit 3142a6beb28db36dc9150f1ad6752cd1e19a8712
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-23 12:07:15 +0900

    Revert "Changed behavior on windows platforms too [ci skip]"

    This reverts commit 1bf8d5e9797f6304b2e27cb7f42d467f84de0ff4.

    Because 204dc3f39f12b4e2640555306bd1dd4530344277 reverts 61aff0cd189e67fa6f2565639ad0128fa33b88fc

commit 204dc3f39f12b4e2640555306bd1dd4530344277
  Author: NAKAMURA Usaku <usa@ruby-lang.org>
  Date:   2019-12-23 11:54:25 +0900

    Revert "Should return "." for File.extname("file.") also on Windows"

    We want to introduce consistency and better compatibility with unixen,
    but the Windows APIs do not have consistency fundamentally and
    we can not found any logical way...

    This reverts commit 61aff0cd189e67fa6f2565639ad0128fa33b88fc.

commit 048f797bf019cdf303d70494fba63d4a4e606462
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2019-12-23 10:54:50 +0900

    [ruby/prime] Bump version

commit 446c243da35831de701ff6dd6c3c6da8252b6a10
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2019-12-23 09:44:43 +0900

    [ruby/ostruct] Bump version

commit 9be3295d53b6fd9f8a3ad8157aa0655b1976d8ac
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2019-12-23 09:40:32 +0900

    [ruby/ostruct] Create OpenStruct::VERSION

commit 49d94248ebfb7a51e342f8102d21ad132a40f91a
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2019-12-23 09:34:42 +0900

    [ruby/ostruct] Move gemspec

commit 48d1acdf25b13bd9e28bf6baa3f74ec082a27a00
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2019-12-23 08:33:19 +0900

    [ruby/matrix] Bump version

commit 1ed87dd3c4fb085955bb3848579a3ed7aba38507
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-22 13:56:20 +0900

    Add NEWS about Warning.[] [Feature #16345] [ci skip]

commit 5de284ec78220e75643f89b454ce999da0c1c195
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-23 10:37:30 +0900

    Fixed a typo in an exception class name

commit 5f18635a800eee29fd051ea758a2ec561f090ebe
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-23 10:10:23 +0900

    make-snapshot: fixed mode

    "X" must be used in conjunction with "+".

commit 80d5d220b948517306e23b18260768ab8fe008bc
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-23 08:42:53 +0900

    Fix typo in commit logs by log-fix notes

commit 4de2297d74fbc0a0e69ac8bcc2aad5b192fd11b6
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-23 09:07:07 +0900

    Re-apply f85e8d2a8b keeping characters < 80

commit f156f70b3192ddab41e432e743936a09a5aaae09
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-23 09:02:49 +0900

    Revert "Fixed misspellings"

    This reverts commit f85e8d2a8b2a37740334db4fd92ef820f05ddbc5.

    It violated the limit of width (> 80) and caused the test failure

commit f85e8d2a8b2a37740334db4fd92ef820f05ddbc5
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-23 08:31:46 +0900

    Fixed misspellings

    Fixed misspellings reported at [Bug #16437]

commit a4b99f97642d31fc8ddd537155ff6cf61be6a43c
  Author: zverok <zverok.offline@gmail.com>
  Date:   2019-12-23 05:56:44 +0900

    Fix typos of previous docs PR

    In #2612 I made two typos (extra ,, and copy-pasted
    same line of code instead of showing two different
    ones), fixing them.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2771

commit c1bd1bf27236b33965dd92c1b2297edc91327cfb
  Author: zverok <zverok.offline@gmail.com>
  Date:   2019-12-14 01:59:23 +0900

    Document Module#const_source_location

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2750

commit ade6543f4cf7dfb1ab4585a1bfca20f3d64d5add
  Author: Alan Wu <XrXr@users.noreply.github.com>
  Date:   2019-12-23 08:21:13 +0900

    Adjust sentence in doc [ci skip]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2773

    Merged-By: XrXr

commit bb05cdcd78b3e3d54f0ad9afc01de383ed33dc1c
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-23 06:36:14 +0900

    [DOC] Improve documentation for Enumerable#tally

commit 7c37f2cb1ad248a1db327f3522a8e3ffa5c5412f
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-23 03:46:24 +0900

    Some fixes in Enumerator::Lazy docs

    * fix list in #flat_map
    * fix wrong indentation in #filter_map and #with_index
    * other small fixes

commit 679bc4f9cb6a5471df903436c6240ca2157986dd
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-09-08 21:04:46 +0900

    [ruby/reline] Use IO#raw to read one byte

    https://github.com/ruby/reline/commit/be17740e82

commit 3a18e43caac4ce31702c9b79de3b6e8af05ef173
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-23 00:17:25 +0900

    * 2019-12-23 [ci skip]

commit 1bf8d5e9797f6304b2e27cb7f42d467f84de0ff4
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-23 00:16:51 +0900

    Changed behavior on windows platforms too [ci skip]

    at 61aff0cd189e67fa6f2565639ad0128fa33b88fc [Bug #15267]

commit d339de9d1a11923cd6d435d995ee479d08791720
  Author: zverok <zverok.offline@gmail.com>
  Date:   2019-12-22 06:05:45 +0900

    Enhance docs for Module#deprecate_constant

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2768

commit 5a0102cb615f27f2daef8af6d9ae996926b2d167
  Author: zverok <zverok.offline@gmail.com>
  Date:   2019-12-22 05:58:14 +0900

    Enhance Range docs

    * Change === docs to mention it uses cover?
    * Add different example to === docs to showcase
      behavior better
    * Change include? docs to mention cover?
      and clarify the difference

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2768

commit 4988843188c7a1666b11e1390acd7b991941c3a8
  Author: zverok <zverok.offline@gmail.com>
  Date:   2019-12-22 05:37:35 +0900

    Actualize Time#inspect docs

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2768

commit 5fa9c2eeb04a2e44a2a028d933bc95f219a6a282
  Author: zverok <zverok.offline@gmail.com>
  Date:   2019-12-22 05:31:30 +0900

    Actualize Method#inspect docs

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2768

commit d78fcfb7ab351fd4861e42985db34e9bda3509a7
  Author: zverok <zverok.offline@gmail.com>
  Date:   2019-12-22 05:21:20 +0900

    Fix FrozenError#receiver and #initialize docs

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2768

commit e568bb5649a93c60aaa51c1e5308054079815bcc
  Author: zverok <zverok.offline@gmail.com>
  Date:   2019-12-22 05:17:35 +0900

    Update private visibility explanation

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2768

commit 03b983d54c17615e36d56d2937a685fc8c3f2cdb
  Author: zverok <zverok.offline@gmail.com>
  Date:   2019-12-21 05:51:22 +0900

    Document numbered block parameters

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2767

commit 890c834ec6bb03fab4fee6f5b14f99660a64d207
  Author: BurdetteLamar <burdettelamar@yahoo.com>
  Date:   2019-12-17 07:58:53 +0900

    Enhancements for ENV doc

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2757

commit 54be15f3256fd2dbb0d5d7962e9dfac2b87c797b
  Author: QuestionDriven <QuestionDriven@gmail.com>
  Date:   2019-12-17 16:11:02 +0900

    [Doc] Fix sample in Encoding#names

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2760

commit 9654241d5d5717b7cd6ddedb6c192e971f9d473a
  Author: QuestionDriven <QuestionDriven@gmail.com>
  Date:   2019-12-17 16:05:17 +0900

    [Doc] Fix wrong example in Encoding.aliases

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2760

commit cc87037f1c5a143af8089555e704505fcf0b2879
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-22 22:49:17 +0900

    Fixed misspellings

    Fixed misspellings reported at [Bug #16437], missed and a new
    typo.

commit 7c33ee5ddfafe737add2a7f4c4975108f9196dbd
  Author: Benoit Daloze <eregontp@gmail.com>
  Date:   2019-12-22 19:39:22 +0900

    Move version guard outside to make it clear the method was added in Ruby 2.5

commit d76c8cfecdaa2960153b5b24ccd0d61f9af60abd
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-22 15:18:22 +0900

    RDoc of Warning.[] and .[]= [Feature #16345] [ci skip]

commit d2ac6d4d9f57b34eeb94bd6302b54a632051ce64
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-22 14:45:42 +0900

    Manage deprecation warning by the flag

commit 58527a79263c6572bd4f97d0a0e0359c0ace6f3c
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-22 13:52:59 +0900

    [ruby/io-console] bump up to 0.5.3

commit ced4c5dace63dcb5aabe4d9c480e02e7581b8816
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2019-12-22 11:40:07 +0900

    add NEWS about cache improvement [ci skip]

commit efd4a11ada731ce18f5eb1500c76f77b4d0f313f
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-22 11:46:09 +0900

    Support multibyte input

commit cf59e1476d01be27dc88cbee5f6c6cf87f007043
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-22 06:28:13 +0900

    fix a thread test.

    * Use Queue for synchronization.
    * Don't use `sleep 0.2` and use `th.join` because created thread
      can raise an exception after 0.2 seconds.

commit fa1bf8ab37caad5fa0679adc0ecb8f6f5cec2eea
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-19 23:13:21 +0900

    [ruby/reline] Support Ctrl+right as em_next_word, and Ctrl+left as ed_prev_word

    https://github.com/ruby/reline/commit/e98ad3b486

commit 644336eef54c8ee2aeb7fd6c55fcd5620bcfa5b4
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-22 05:20:08 +0900

    add a NEWS entry for [Feature #16163]

commit 75acbd5f0076970d48bc423c2b058adbdb5da9e8
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-22 03:31:27 +0900

    compile.c: avoid newarraykwsplat for arguments

    `foo(*rest, post, **empty_kw)` is compiled like
    `foo(*rest + [post, **empty_kw])`, and `**empty_kw` is removed by
    "newarraykwsplat" instruction.
    However, the method call still has a flag of KW_SPLAT, so "post" is
    considered as a keyword hash, which caused a segfault.
    Note that the flag cannot be removed if "empty_kw" is not always empty.

    This change fixes the issue by compiling arguments with "newarray"
    instead of "newarraykwsplat".

    [Bug #16442]

commit 3a29f05ba5ba7ed4b821ba5f566eeb3ff3c5c3b1
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2019-12-22 01:39:17 +0900

    Move stats under a dict

commit 61aff0cd189e67fa6f2565639ad0128fa33b88fc
  Author: NAKAMURA Usaku <usa@ruby-lang.org>
  Date:   2019-12-22 02:36:55 +0900

    Should return "." for File.extname("file.") also on Windows

    But not changes another cases, such as "file.rb."
    [Bug #15267]

commit 29ea228efc5af08a0e91fafe155617f20e22976b
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-22 01:58:02 +0900

    * 2019-12-22 [ci skip]

commit 0835a971ef84dfebefbc73ddd468450cbfb90974
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-18 22:57:25 +0900

    Remove TODO comment

commit 616f1357c3030fad73c42ea061a7f21b0df57fb5
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-14 16:14:43 +0900

    [ruby/irb] Make nesting level up for `1.times do`

    Follow up of the previous commit

    https://github.com/ruby/irb/commit/ab207353d3

commit a3cc2a2fbde23637fb924f75e977599b7a475118
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-14 16:07:21 +0900

    [ruby/irb] Fix auto-indent for `1.times do`

    Fixes #47

    https://github.com/ruby/irb/commit/6b8eca4635

commit ec1de789a98923417cf983cb3cdaed003c0f8be6
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-14 15:46:42 +0900

    [ruby/reline] Preserve the input buffer across cursor_pos

    The old version of cursor_pos discards the input buffer, which made IRB
    ignore the input immediately after IRB is invoked.

    This change keeps the input before cursor_pos by using ungetc.

    https://github.com/ruby/reline/commit/4a8cca331f

commit 7fd6077d9896cc10244fb9416ef87ae461c079db
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-14 11:01:49 +0900

    [ruby/reline] Consider Reline::ANSI.input at prep

    https://github.com/ruby/reline/commit/b111cde3c3

commit 85a337f986fe6da99c7f8358f790f17b122b3903
  Author: Alan Wu <XrXr@users.noreply.github.com>
  Date:   2019-07-14 01:04:01 +0900

    Kernel#lambda: return forwarded block as non-lambda proc

    Before this commit, Kernel#lambda can't tell the difference between a
    directly passed literal block and one passed with an ampersand.

    A block passed with an ampersand is semantically speaking already a
    non-lambda proc. When Kernel#lambda receives a non-lambda proc, it
    should simply return it.

    Implementation wise, when the VM calls a method with a literal block, it
    places the code for the block on the calling control frame and passes a
    pointer (block handler) to the callee. Before this commit, the VM
    forwards block arguments by simply forwarding the block handler, which
    leaves the slot for block code unused when a control frame forwards its
    block argument. I use the vacant space to indicate that a frame has
    forwarded its block argument and inspect that in Kernel#lambda to detect
    forwarded blocks.

    This is a very ad-hoc solution and relies *heavily* on the way block
    passing works in the VM. However, it's the most self-contained solution
    I have.

    [Bug #15620]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2289

commit ddb6023d64a8c96348b4e67603753e2916a04f28
  Author: Alan Wu <XrXr@users.noreply.github.com>
  Date:   2019-07-15 13:35:30 +0900

    Add spec for capturing Kernel#lambda with Kernel#method

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2289

commit e0b336c8ce84e1456fc6126ca232289667db3e19
  Author: Alan Wu <XrXr@users.noreply.github.com>
  Date:   2019-07-15 12:41:43 +0900

    Add specs for calling into Kernel#lambda with super

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2289

commit ea405ee8ed00c03e0521ff4b852d8f3bea849243
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-21 10:06:14 +0900

    test/ruby/test_pattern_matching.rb: suppress "unused variable" warning

commit 9eded02446e34d4db1051f5f18c2d7d554e792d3
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2019-12-21 03:47:56 +0900

    Add Array#minmax, Range#minmax, and Proc#ruby2_keywords to NEWS

commit 63ce77929ab0ebe992e91a1bad436a5d8e6488a9
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-21 00:07:13 +0900

    * 2019-12-21 [ci skip]

commit 484c1be8956b7bb7a0253c6d6c7a740c341487fa
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-20 23:51:17 +0900

    Added `-W:experimental` command line option

    [Feature #16420]

commit 07e595fdbd75ed44473073cdf8cd758572d11709
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-20 23:48:15 +0900

    Added `experimental` warning category

    [Feature #16420]

commit dd7f0c87c9da8e695c38a6529deb6e0f24f6d06c
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-20 23:36:19 +0900

    Hoisted out new_case3

commit a84ad24386d27269b90794146c2a351c1d79471b
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-20 23:05:22 +0900

    Added -W: command line option

    To manage `Warning[category]` flags.  Only `-W:deprecated` and
    `-W:no-deprecated` are available now.  [Feature #16345]

commit 6876aa38f607cdd6fb24910e54143d9110d025c9
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-20 22:50:46 +0900

    Added `FEATURE_SET_RESTORE` macro

commit 1fea3a7636cfaf25baba1e9f208c68a8a8ba52cc
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-20 21:37:46 +0900

    NEWS: Update the explanation of pattern matching

    Add an example of "<expr> in <pattern>", an example of
    NoMatchingPatternError, and mention that the slides are slightly
    obsolete.

commit f7aee584987e24768670e96b1455ed1193f91ef2
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-20 19:41:15 +0900

    vm_args.c: rephrase the warning message of keyword argument separation

    (old)
    test.rb:4: warning: The last argument is used as the keyword parameter
    test.rb:1: warning: for `foo' defined here; maybe ** should be added to the call?

    (new)
    test.rb:4: warning: The last argument is used as keyword parameters; maybe ** should be added to the call
    test.rb:1: warning: The called method `foo' is defined here

commit 2b2030f265e4ec0782de9c8dd9f8828a1a0af1b5
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-20 15:05:10 +0900

    Refined the warning message for $, and $;

    [Bug #16438]

commit 7a94225e7d04f17ddd37433c3904b04fec97f281
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-20 14:54:44 +0900

    Refined the warning message for numbered-parameter like variables

    [Bug #16438]

commit a8bddb3a189545a2bef8ee7cffdb328d8de7974c
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-20 14:29:42 +0900

    Refined the warning message for numbered-parameter like variables

    [Bug #16438]

commit 435a4ca2a38f3be1f5d2db0f71487a52c8285e9c
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-20 14:14:07 +0900

    Makes the receiver to FrozenError.new a keyword parameter

    [Feature #16419]

commit 216b62aa87f069c51085e9f9abb548930370bc53
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2019-12-20 14:10:37 +0900

    use UTC to use previous day in midnight

commit e68999c82c4863d33a6f893661fba1b7538c5671
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-20 12:19:45 +0900

    Fixed misspellings

    Fixed misspellings reported at [Bug #16437], for default gems.

commit e672494cd737b8fea3a186aeb5c2c17d1a18cb96
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-20 11:50:32 +0900

    Merge RubyGems 3.1.2

commit fac60be324260cd834478fedf934e59b97935dbf
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-20 09:39:50 +0900

    shell.rb is no longer bundled [ci skip]

commit db166290088fb7d39d01f68b9860253893d4f1a7
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-20 09:19:39 +0900

    Fixed misspellings

    Fixed misspellings reported at [Bug #16437], only in ruby and rubyspec.

commit 2898367b3a1de00ca78067cc17dd4d1f8df37778
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-20 08:18:19 +0900

    Warn also numbered parameter like methods

commit 3816cd945d68eac7ca8fecbc9d71f878ff3e7b3d
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-20 01:40:00 +0900

    Add `URI#open` to warning message

commit 844f1fada6f364dc26bd6eb6de2c4299a69e272a
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-20 01:37:11 +0900

    * 2019-12-20 [ci skip]

commit 27ddb6e99848c397a415b785315896ab50308076
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-20 01:01:17 +0900

    Warn also numbered parameter like parameters

    [Feature #16433]

commit c6c67254fb17b3196a7b0d3fda4650f6b20a467d
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-17 17:17:07 +0900

    Added rb_warn_deprecated

commit 7aa8a786740fd84bd718b0c055f190b25a8f0277
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-17 17:16:12 +0900

    Manage deprecation warnings about keyword argument

commit 9bf9de3d9d2f67bc401151fb94abf75b5eff5913
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-17 14:52:15 +0900

    Made the warning for deprecated constants follow the category flag

commit 76035e5bb6a5b44621fd1c11a0553780474d1c01
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-16 18:19:01 +0900

    Adjusted the format

commit e732e0074e53e7ddbaf863197ec3775d7e9d4516
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-19 02:08:51 +0900

    * 2019-12-19 [ci skip]

commit 1e88f6eb95672cae2b0628895a9ee9a5d384e048
  Author: Aaron Patterson <tenderlove@ruby-lang.org>
  Date:   2019-12-18 10:26:11 +0900

    Refactor free page insertion

    I am trying to fix this error:

      http://ci.rvm.jp/results/trunk-gc_compact@silicon-docker/2491596

    Somehow we have a page in the `free_pages` list that is full.  This
    commit refactors the code so that any time we add a page to the
    `free_pages` list, we do it via `heap_add_freepage`.  That function then
    asserts that the free slots on that page are not 0.

commit efbc0d499c0dc5b74698418c76e58098c6c113e1
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-18 14:53:19 +0900

    Merge bundler-2.1.1 from bundler/bundler

commit fa7fa5c86b0674eca233922045e4d3dd4ee49cb7
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2019-12-18 13:03:54 +0900

    delete rb_vm_call()

    Nobody uses it any longer.

commit dcb603bbdbe3a8ea6f6d07198c8711cf9a44a4d2
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2019-12-18 12:57:46 +0900

    describe mc_miss_reuse_call [ci skip]

commit fcd8bafd086a7105b535ec1691f960e37d5c911b
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-18 13:35:58 +0900

    Use a temporary file for chown test

    Errno::EROFS may occur when the source tree is placed in a
    read-only filesystem.

commit c147eeff7c2b8d4b8864c8be6496abf7f622a983
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-18 13:29:55 +0900

    [ruby/io-console] Skip Interrupt test on Linux

    Hangs up only in ruby/ruby on Travis-CI.

    https://github.com/ruby/io-console/commit/de39aa6dd6

commit f054f11a38f66af17a0aed8e0d2d46731eaab27d
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2019-12-17 15:49:41 +0900

    per-method serial number

    Methods and their definitions can be allocated/deallocated on-the-fly.
    One pathological situation is when a method is deallocated then another
    one is allocated immediately after that.  Address of those old/new method
    entries/definitions can be the same then, depending on underlying
    malloc/free implementation.

    So pointer comparison is insufficient.  We have to check the contents.
    To do so we introduce def->method_serial, which is an integer unique to
    that specific method definition.

    PS: Note that method_serial being uintptr_t rather than rb_serial_t is
    intentional.  This is because rb_serial_t can be bigger than a pointer
    on a 32bit system (rb_serial_t is at least 64bit).  In order to preserve
    old packing of struct rb_call_cache, rb_serial_t is inappropriate.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2759

commit 77e3078ede833e86a1ee0e2ce745b15e892bdbf6
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-18 10:25:18 +0900

    [ruby/io-console] Set raw mode strictly same as cfmakeraw

    * Default VMIN and VTIME to minimum input.
    * Disable parity check bits explicitly.
    * Disable all bits for flow control on input.

    Co-Authored-By: NARUSE, Yui <naruse@airemix.jp>

    https://github.com/ruby/io-console/commit/5ce201a686

commit 254477248cde5bf82c4f256dca05b13d01c9774c
  Author: John Hawthorn <john@hawthorn.email>
  Date:   2019-12-13 08:47:59 +0900

    Skip optimized method check for most method IDs

    Previously every time a method was defined on a module, we would
    recursively walk all subclasses to see if the module was included in a
    class which the VM optimizes for (such as Integer#+).

    For most method definitions we can tell immediately that this won't be
    the case based on the method's name. To do this we just keep a hash with
    method IDs of optimized methods and if our new method isn't in that list
    we don't need to check subclasses at all.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2752

commit 9245462499e7c3216a468aadccdc11e69de8cd54
  Author: John Hawthorn <john@hawthorn.email>
  Date:   2019-12-13 15:43:00 +0900

    Replace debug test with assertion

    It's a Ruby bug if this ever happens check it as an assertion instead of
    paying the cost of the check every time.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2752

commit a01d22b8c16d9bd44767cced8d45398493af0a7c
  Author: John Hawthorn <john@hawthorn.email>
  Date:   2019-12-12 08:47:49 +0900

    Check type with BUILTIN_TYPE in method cache clear

    We know that this is a heap-allocated object (a CLASS, MODULE, or
    ICLASS) so we don't need to check if it is an immediate value. This
    should be very slightly faster.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2752

commit 8e56d3a6ab7cc05be586010acd9f85384d53403a
  Author: John Hawthorn <john@hawthorn.email>
  Date:   2019-12-13 09:42:34 +0900

    Define PREV_CLASS_SERIAL

    Avoids generating a "throwaway" sentinel class serial. There wasn't any
    read harm in doing so (we're at no risk of exhaustion and there'd be no
    measurable performance impact), but if feels cleaner that all class
    serials actually end up assigned and used (especially now that we won't
    overwrite them in a single method definition).

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2752

commit d7a50a5cc694ab28608a9d5a2e39c2766330ffe6
  Author: John Hawthorn <john@hawthorn.email>
  Date:   2019-12-12 06:10:39 +0900

    Avoid revisiting seen nodes clearing method cache

    rb_clear_method_cache_by_class calls rb_class_clear_method_cache
    recursively on subclasses, where it will bump the class serial and clear
    some other data (callable_m_tbl, and some mjit data).

    Previously this could end up taking a long time to clear all the classes
    if the module was included a few levels deep and especially if there
    were multiple paths to it in the dependency tree (ie. a class includes
    two modules which both include the same other module) as we end up
    revisiting class/iclass/module objects multiple times.

    This commit avoids revisiting the same object, by short circuiting when
    revisit the same object. We can check this efficiently by comparing the
    class serial of each object we visit with the next class serial at the
    start. We know that any objects with a higher class serial have already
    been visited.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2752

commit 8a40dce0ff2964df22e06ae9a08f50592d17caf0
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-18 00:08:43 +0900

    * 2019-12-18 [ci skip]

commit bcec03af05649a8132f5e4e49c2c64762e60b605
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-18 00:08:21 +0900

    Revert "Skip interruptible raw mode test on Travis-CI"

    This reverts commit 65731a1330ed02691e3c343d2feeb8d0a72af3fd.

commit 07ed8f2f916a512b35bc69b49f1c482a2ea6e9dd
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-17 23:26:07 +0900

    [ruby/io-console] Skip interrupt

    https://github.com/ruby/io-console/commit/8ed5a2bcc3

commit 905a926ea84e199478e32e6da5cd0e8d756132f1
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-17 18:20:37 +0900

    [ruby/io-console] Timeout in the child process

    https://github.com/ruby/io-console/commit/b8411689a5

commit 4b7d27ca0de5e1294fa2072d948953ef49753fc5
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-17 17:24:21 +0900

    [ruby/io-console] Use IO.console instead of STDIN

    https://github.com/ruby/io-console/commit/9e3ec5b936

commit 1b86309b04709ce0a64a9206ca638eccda9d4fec
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-17 23:38:18 +0900

    Squelch filter-branch warning and sleeping

commit ffa7ceceaf7d9f0268db9021eb0df6f197dcb3c8
  Author: mihaibuzgau <mihai.buzgau@puppet.com>
  Date:   2019-12-17 19:47:15 +0900

    [rubygems/rubygems] Move `require uri` to source_list

    https://github.com/rubygems/rubygems/commit/c6b4df5bfc

commit 299db379575da122bc20745811fc1e20ba01f3ce
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-17 09:46:45 +0900

    Use while instead of loop

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2758

commit 9d3ffcfbfc742ed5053b59678dbf97773a7dddc1
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-17 20:22:00 +0900

    disable assertion.

    This assertion is not needed because we found the bug.
    ba11a74745.

commit 65731a1330ed02691e3c343d2feeb8d0a72af3fd
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-17 17:18:42 +0900

    Skip interruptible raw mode test on Travis-CI

commit b226a68141bd60db4b14264cb579e3eab9b6bcbd
  Author: mihaibuzgau <mihai.buzgau@puppet.com>
  Date:   2019-12-16 21:42:34 +0900

    [rubygems/rubygems] require `uri` in source.rb

    https://github.com/rubygems/rubygems/commit/8de4d0272e

commit ea717d1ce1199bbd2e6532f1607bab6e1a1f9274
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2019-12-17 13:22:24 +0900

    convert macros into inline functions

    For better readability.

commit d616926af916d140f0bd1be3cdc232193d46286a
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-17 14:20:51 +0900

    Remove an unnecessary variable

commit 8f52604b478fee5243080116b8e62f0c1f5cb9a0
  Author: Masataka Pocke Kuwabara <kuwabara@pocke.me>
  Date:   2019-12-09 00:48:13 +0900

    Remove unnecessary double bangs from Pathname#root?

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2732

commit 9421c7804191b73aa9fde8f14235b3a1f37ffd4b
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-16 12:33:13 +0900

    [ruby/logger] Fixed leaked tempfile

    https://github.com/ruby/logger/commit/fb3eff153f

commit 4f9a4c1a8f6a31def5fdf58582f064cf644a5828
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-17 13:47:06 +0900

    Remove unnecessary branches

commit e36319249b1a9967a83e66df2661769c136594ad
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-17 13:57:58 +0900

    [ruby/io-console] bump up to 0.5.2

commit b39d5da97426c6f65e2b39b307ce19d774d93ddd
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-14 19:15:02 +0900

    [ruby/io-console] Use TCSANOW to prevent from discarding the input buffer

    TCSAFLUSH discards the buffer read before the mode change, which makes
    IRB ignore the buffer input immediately after invoked.  TCSANOW
    preserves the buffer.

    https://github.com/ruby/io-console/commit/b362920182

commit 81eb2d16efcb29899e88e30a25ca5440195e2393
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-13 11:41:31 +0900

    [ruby/io-console] Disable implementation-defined special control characters

    In raw mode with interrupt enabled.

    https://github.com/ruby/io-console/commit/e9e8e3ff17

commit ec89a0f8033215817d9c6f9300d9513178e785b7
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-13 12:14:10 +0900

    [ruby/io-console] Added the test for intr option

    https://github.com/ruby/io-console/commit/4f01db102d

commit a9d17af242748c160cb79909fd881e06141fe428
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-10 10:07:00 +0900

    [ruby/io-console] Removed dead code

    https://github.com/ruby/io-console/commit/a49462ed97

commit 64ce658ec5a6d6fc6eb969f607e703fd9372287a
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-17 13:30:54 +0900

    Fix return condition according to the condition to skip

commit a1713bedb1de676fdd7d9bf3458b931c4702a1af
  Author: Thomas Leitner <t_leitner@gmx.at>
  Date:   2019-10-04 17:03:32 +0900

    [ruby/reline] Implement completion_append_character

    There is already the possibility to set Reline.completion_append_character.
    However, it is not used by the line editor.

    https://github.com/ruby/reline/commit/ab798931b9

commit 11db4d3a3b315ed2495ec0cdde4449554c002bff
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-14 11:05:16 +0900

    [ruby/reline] Disable any implementation-defined special control characters

    Including dsusp, lnext, and so on.

    https://github.com/ruby/reline/commit/a44abe586b

commit fbe229906b6e55c2e7bb1e68452d5c225503b9ca
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-17 13:14:52 +0900

    add debug counter to count `call` reusing cases.

commit 618d09115185efa05f6948247d86087f4aa96118
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-17 13:10:39 +0900

    Support change search direction

commit a14a0244b48c422e392547b198af6fb57f7ca568
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-17 12:47:09 +0900

    Support forward-search-history by C-s

commit c687be4bc01c9ce52ea990945d9304d6fe59fe9b
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-17 11:53:30 +0900

    Added a test for [Bug #16159]

commit ebe5b66ca8e639468e14c4134a415403d949385e
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-17 10:48:17 +0900

    Reduce tzset calls

    Set up-to-date flag always when calling tzset().

commit d6a2bce64a7fa1099e507e1d36b5f1533f42f60f
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-17 10:31:20 +0900

    time.c (find_time_t): fix round-to-zero bug

    `find_time_t` did not work correctly for year older than the Epoch
    because it used C's integer division (which rounds negative to zero).

    For example, `TIme.new(1933)` returned a wrong time whose year is 1922
    in Asia/Kuala_Lumpur because there is no 00:00:00 1st Jan. 1933 in the
    time zone.

    ```
    $ TZ=Asia/Kuala_Lumpur ruby -e 'p Time.new(1933)'
    1932-12-31 00:00:00 +0700
    ```

    This change fixes the issue by using `DIV` macro instead of `/`.
    Now `Time.new(1933)` returns a time in 1933.

    ```
    $ TZ=Asia/Kuala_Lumpur ruby -e 'p Time.new(1933)'
    1933-01-01 00:20:00 +0720
    ```

    [Bug #16159]

commit 5da4a310ccf7f4131c1814a2c9279a5682777f1b
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2019-12-17 00:49:17 +0900

    close datasocket on stor of server side

commit 5be34d6a3310065850c0c530db6936415124b5d9
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2019-12-10 19:25:00 +0900

    ensure to close the data connection [Bug #16413]

commit 95213f6df6a23918d57a743975708c638da42aae
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-15 10:29:44 +0900

    Check whether Readline.completion_append_character= exists

commit b12bc3b0461f7331db6e27865fa7a8ef29a0f652
  Author: Eric Wong <normal@ruby-lang.org>
  Date:   2019-12-17 03:28:44 +0900

    thread.c: avoid needless read after select|ppoll

    We do not need to issue pipe|eventfd read(2) syscall
    unless select, ppoll|poll declares the FD needs reading.

commit bba6386d9568123a7c76693e3a5fa5e33562a640
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-17 00:44:32 +0900

    test/ruby/test_process.rb: suppress "unused variable" warning

commit c6b1342d29a71e44c0275516d4f8408ce07bf397
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-17 00:01:56 +0900

    * 2019-12-17 [ci skip]

commit 6a75a460536a32fb62184dc5d8d66ddd737a9bad
  Author: Richard Viney <richard.viney@gmail.com>
  Date:   2017-01-22 10:50:08 +0900

    Make prettyprint’s cycle detection aware of Delegator instances

    Fixes [Bug #13144]

    Co-Authored-By: Nobuyoshi Nakada <nobu@ruby-lang.org>

commit 251f5d8226dbde06ba06e980e3b741b45ae3826d
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-16 23:39:10 +0900

    Revert "lib/net/http/response.rb: support raw deflate correctly"

    This reverts commit 5105240b1e851410020b3b3f1a2bead7ffdd4291.

    In RFC 2616:

    ```
       deflate
            The "zlib" format defined in RFC 1950 [31] in combination with
            the "deflate" compression mechanism described in RFC 1951 [29].
    ```

    So "Content-Encoding: deflate" means zlib format, not raw deflate.

    [Bug #11268]

commit 5105240b1e851410020b3b3f1a2bead7ffdd4291
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-16 23:20:42 +0900

    lib/net/http/response.rb: support raw deflate correctly

    Net::HTTP had used `Zlib::Inflate.new(32 + Zlib::MAX_WBITS)` for all
    content encoding (deflate, zlib, and gzip).
    But the argument `32 + Zlib::MAX_WBITS` means zlib and gzip decoding
    with automatic header detection, so (raw) deflate compression had not
    been supported.

    This change makes it support raw deflate correctly by passing an
    argument `-Zlib::MAX_WBITS` (which means raw deflate) to
    `Zlib::Inflate.new`.  All deflate-mode tests are fixed too.

    [Bug #11268]

commit d6fd39030d8b14eef117c1e5e265e0b769a9f4fd
  Author: BurdetteLamar <burdettelamar@yahoo.com>
  Date:   2019-12-14 04:46:54 +0900

    Enhancements for ENV doc

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2751

commit d8db343a21b175563fa58a7d33c600ae7c7973cc
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-16 20:47:02 +0900

    Merge RubyGems 3.1.1 and update the NEWS entry for RubyGems

commit ba11a74745e10fac88a74c2da2e0032ccf254265
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2019-12-16 17:38:41 +0900

    ensure cc->def == cc->me->def

    The equation shall hold for every call cache.  However prior to this
    changeset cc->me could be updated without also updating cc->def.  Let's
    make it sure by introducing new macro named CC_SET_ME which sets cc->me
    and cc->def at once.

commit 6545d5bbb9517a9364bd59a12a98d3e00516e07e
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-16 16:59:23 +0900

    Use CDN instead of raw.githubusercontent.com

commit 8b921813aa8d5ea8f4e6c1e700ad48a120c500ab
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-16 16:58:21 +0900

    Fix open without close [ci skip]

commit 04e95f8985066b4ae1e97b045efda98bdefa07bd
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-16 11:19:59 +0900

    Get rid of infinite recursion at loading transcoder

    Disable encoding US-ASCII path to filesystem on Windows too.
    [Bug #16392]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2755

commit d2f04d332f2ff04f25202ed38e23de526a9aea46
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-16 09:44:01 +0900

    Kernel#abort without arguments should print error info

    [Bug #16424]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2754

commit 1e80a208cc44cbbdd4e49d6146eea29cde5cd42a
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-16 10:09:13 +0900

    Update the NEWS entry for Bundler 2.1.0

commit 2344d8ac9aefae6258b1967014d17564cf2d2e43
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-16 10:05:44 +0900

    * 2019-12-16 [ci skip]

commit f47c38245ff6976c5d1fc27a79f239bba00fc333
  Author: Breno Leitao <breno.leitao@gmail.com>
  Date:   2019-12-16 10:05:21 +0900

    gc.h: Add SET_MACHINE_STACK_END specific for Powerpc64 (#1767)

    Currently we are not able to grab the correct end/top of the stack on
    powerpc64 due to the fact that it uses the fallback function.

    The fallback function does not return the correct top of the stack
    because it adds a new frame and the returned top of the stack contains
    this frame overhead that could be something around 112 bytes on
    Powerpc64.

    This patch simply gets the correct top of the stack pointer, which is
    always on r1 register according to both ABI v1 and ABI v2 (Little
    endian).

    Signed-off-by: Breno Leitao <leitao@debian.org>

commit e8c62836a6292bf2f691de458b24ea50c51b452a
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-15 23:13:16 +0900

    IO#set_encoding_by_bom should err when encoding is already set

    Except for ASCII-8BIT.  [Bug #16422]

commit eeb99fb52500b571b1239442a7d17d335cfde060
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-15 22:19:45 +0900

    tool/gen-mailmap.rb: odaira is removed as he is added in upstream

    https://github.com/ruby/ruby-commit-hook/commit/ddc83bea6fe6f4696e140b605db10ef0c922bba6

commit 48bab6fe1eb77b481bffbc97fdbf5ba74c45a07a
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-15 21:59:30 +0900

    tool/gen-mailmap.rb: Added for generating git `.mailmap` file

    `.mailmap` can be used To show canonical names and email addresses.
    It is helpful for statistics of committers.

commit a83c46e3fd1e3480404c6dda4c4cda73533a6a1d
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-15 20:03:47 +0900

    Add more debug info

    closed server doesn't have useful info.
    So call inspect before close.
    And add local debug code in comment.

    https://rubyci.org/logs/rubyci.s3.amazonaws.com/unstable11x/ruby-master/log/20191215T092405Z.fail.html.gz
    ```
      1) Failure:
    IMAPTest#test_connection_closed_without_greeting [/export/home/rubyci/chkbuild-tmp/tmp/build/20191215T092405Z/ruby/test/net/imap/test_imap.rb:483]:
    [Net::IMAP::Error] exception expected, not #<RuntimeError: {:e=>#<Errno::EINVAL: Invalid argument - connect(2) for [::1]:41748>, :server=>#<TCPServer:(closed)>, :port=>41748, :server_addr=>"::1"}>.
    ```

commit 980ddca47e892535c1da897b33ac7bc727efd52d
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-15 16:48:40 +0900

    Prepare to release rubygems-3.1.0

commit 9f43160014905db159ec67e3ee2b485d870de05d
  Author: David Rodríguez <deivid.rodriguez@riseup.net>
  Date:   2019-12-14 22:15:43 +0900

    Delegate should be supported now

    Since `did_you_mean` dropped its dependency on it.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2753

commit 286cb3395f8be493b21d0bdf13bcf40fe5c3ab50
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-14 21:19:28 +0900

    Fixed test failures with gem command path on ruby core repo.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2753

commit 0fab9005387549d5c5b13cf330012d02e5312bc2
  Author: David Rodríguez <deivid.rodriguez@riseup.net>
  Date:   2019-12-14 04:41:13 +0900

    Vendor thor 1.0.0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2753

commit 38002a8adbd98266426940d829429a30af0622a4
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-14 19:49:16 +0900

    Prepare to release bundler-2.1.0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2753

commit e2b192f7d5b4f0e2133bb6cf03cfc609258826be
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-15 14:47:36 +0900

    rand(beginless_range) raise Errno::EDOM instead of TypeError

    same as `rand(endless_range)`

    Before:
    ```
    $ ruby -e 'rand(..1)'
    Traceback (most recent call last):
            2: from -e:1:in `<main>'
            1: from -e:1:in `rand'
    -e:1:in `-': nil can't be coerced into Integer (TypeError)
    ```

    After:
    ```
    $ ruby -e 'rand(..1)'
    Traceback (most recent call last):
            1: from -e:1:in `<main>'
    -e:1:in `rand': Numerical argument out of domain (Errno::EDOM)
    ```

commit db2ea9b0c5fb49a04af1b299a37e92f81d7cccd2
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-15 00:21:19 +0900

    [DOC] Fixed the class name in FrozenError#receiver

commit 38b9d213f1fc474549d7ca6858ed4f1d1436d1ee
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-15 00:18:09 +0900

    Revert "[DOC] Fixed the class name in FrozenError#receiver"

    This reverts commit 5f56a5fc9be9ea7b088795c2d3871c2352a020c2.
    `FrozenError.new(mesg, nil).receiver` should not raise an
    ArgumentError.

commit 52b1ba0b0242dc8b10b24df716ec439cd4b2bd88
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-15 00:15:23 +0900

    * 2019-12-15 [ci skip]

commit 5f56a5fc9be9ea7b088795c2d3871c2352a020c2
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-14 23:57:44 +0900

    [DOC] Fixed the class name in FrozenError#receiver

commit 33f0ef44fde7b042d15056cea9af49d160268537
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-14 23:56:28 +0900

    [DOC] Fixed the FrozenError.new result [ci skip]

commit 9e0256836370d6294114320f1b5fa9b3b16b8ae2
  Author: Benoit Daloze <eregontp@gmail.com>
  Date:   2019-12-14 20:26:30 +0900

    Improve highlighting in RubyVM::AbstractSyntaxTree docs when using `ri`

commit b4b22b9278007b106fe40c0191f8dcf5e7e8c0f2
  Author: Benoit Daloze <eregontp@gmail.com>
  Date:   2019-12-14 20:16:58 +0900

    Clarify in the documentation that RubyVM::AbstractSyntaxTree is not stable API

    * See [Feature #14844].

commit 4cc83f9ac60d18ba330dc7f8e92eae1ffce67322
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-14 16:05:49 +0900

    [Feature #13083] is already reverted

commit 90cdcefa78ee9f3c7c78db2c5f3df0fdba25d83f
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-14 16:05:15 +0900

    Update warnings in NEWS

commit e2708068ad65f7f9986adf4fb3a4fa660f430a5a
  Author: Yuki Nishijima <yk.nishijima@gmail.com>
  Date:   2019-12-14 11:39:58 +0900

    Drop delegate dependency

    Original comment:
      https://github.com/ruby/did_you_mean/commit/2f26c9ee770f28da0942c42cbc9e5800535b75e1

commit f3240eb67dc4c807f6489a8a5ccb6eeec239efe5
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2019-12-14 06:07:59 +0900

    NEWS: fix pattern matching example

commit 835703c69f2b1b770b1e3c8c9dd73aca4ed734e6
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-14 00:40:25 +0900

    * 2019-12-14 [ci skip]

commit 84b873e381c6928965e36d0a83c899a01b65e646
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-13 14:35:11 +0900

    [ruby/irb] Restore environment variables

    https://github.com/ruby/irb/commit/236590882c

commit ab1f3d63b0b08fcb8e90557a0d8d72e624221557
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-13 22:10:28 +0900

    Fixed a typo

commit 2ef5f012c1d1dcef18d3c4c56d0d07fc72362be7
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-13 22:00:28 +0900

    Added explicitly loading `Gem::Command` class

commit eb512c5a9530322280991441954b0405cadeebf1
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-13 21:38:50 +0900

    warn should be a global function

commit a2e87123499f6eef9c03089f61f174dd4b3cc673
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-13 20:51:58 +0900

    Fix visibility as module_function

commit 6183addf6a4b94db7fe5b9187ac66fa11c8d2825
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-11-12 18:34:49 +0900

    Add `Warning.[]` and `Warning.[]=`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2739

commit f3b1b645edfc5a8c938da74a5ed44564b9e2fc08
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-10 20:54:01 +0900

    Create backtrace location array directly

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2739

commit 0b5268afbcf11c299e11102c366e836ae55cc39f
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-10 20:22:42 +0900

    Moved Kernel#warn to warning.rb

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2739

commit 82cc2843a92b286cc13afd0860a4e111d4ea2a0b
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-13 20:19:08 +0900

    Prepare to release RubyGems 3.1.0 final version.

commit 26774351dc5f494253ba031e4bc453dc4dddb2cf
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-13 18:06:36 +0900

    Ignore error of `apt-get update` in MJIT workflow too

commit d5c73681f8fd9e17b5378cb029fc88e98d7b6abb
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-13 18:04:21 +0900

    Ignore error of `apt-get update` on GitHub Actions

commit 97a17a51b8e6eca31fd6421511f1907e6e95b415
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-13 17:26:12 +0900

    readable function names for inline functions.

    Now, C functions written by __builtin_cexpr!(code) and others are
    named as "__builtin_inline#{n}". However, it is difficult to know
    what the function is. This patch rename them into
    "__builtin_foo_#{lineno}" when cexpr! is in 'foo' method.

commit 1140625cd31f7ad74c42dc625b9dab389b12653c
  Author: Matt Valentine-House <matt@eightbitraptor.com>
  Date:   2019-12-12 22:37:31 +0900

    Allow more than one major version number in target_os

commit c2dfc6d869979124a46fb0c5404956891c27575f
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-13 03:57:32 +0900

    Show a menu before a document

    IRB should show a menu first if a completed list has plural items. But just
    shows document without menu if a completed list with plural items includes a
    perfect matched item. The behavior is a bug. This commit fixes it.

commit b8d6c883b3f49e6339da4fa5111dbdbe7d3c6df5
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-13 08:52:07 +0900

    Improved the test for Thread#inspect [Feature #16412]

commit fa5f7a8f7ef0d03b8ac97d25a0460c0dc6bb33f3
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-13 00:05:20 +0900

    * 2019-12-13 [ci skip]

commit 69b6f8fd047c5c9e0fa6f65656fda762f8ecfc5e
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-13 00:04:01 +0900

    Check whether TestReadline is defined

commit 93b27c69cc65b5019df061bb8fefaa097bf8a33d
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-12 23:26:29 +0900

    Show the failed message too

commit 68321dd1fa6f55e578bc9776f906ee1f948c7095
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-12 22:04:07 +0900

    Move `rescue` for debug into block of assert_raise

commit dd60856f8ddaa0652bf019589f05705e00279b8c
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-12 20:53:59 +0900

    [cygwin] fix File.absolute_path? test

    Paths start with the root are absolute on cygwin, regardless the
    drive letter.

commit b6f25318c5a1efca0ab963b49ae69db82787e783
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-12 20:50:01 +0900

    Cygwin path cannot be mapped to a UNC as-is

commit c20dd2f75491fc6e78dab55b492c507ee3bb670d
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-12 17:38:27 +0900

    Add more debug info when Errno::EINVAL

    https://rubyci.org/logs/rubyci.s3.amazonaws.com/unstable11x/ruby-master/log/20191212T072406Z.fail.html.gz

commit 54e089df9e37d438687effd092feda2442116c62
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-12 17:02:36 +0900

    show self on control frame dump.

    control frame detailed info on RUBY_DEBUG=ci should also show
    self information.

commit 55b7ba368696033f2e89b77cbcd4a05dec97b139
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2019-08-22 05:59:36 +0900

    Make super in instance_eval in method in module raise TypeError

    This makes behavior the same as super in instance_eval in method
    in class.  The reason this wasn't implemented before is that
    there is a check to determine if the self in the current context
    is of the expected class, and a module itself can be included
    in multiple classes, so it doesn't have an expected class.

    Implementing this requires giving iclasses knowledge of which
    class created them, so that super call in the module method
    knows the expected class for super calls.  This reference
    is called includer, and should only be set for iclasses.

    Note that the approach Ruby uses in this check is not robust. If
    you instance_eval another object of the same class and call super,
    instead of an TypeError, you get super called with the
    instance_eval receiver instead of the method receiver.  Truly
    fixing super would require keeping a reference to the super object
    (method receiver) in each frame where scope has changed, and using
    that instead of current self when calling super.

    Fixes [Bug #11636]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2717

commit 1a4a9bdb5da973f8a89e699ce6d0fb1ca21090bd
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2019-12-12 13:59:52 +0900

    proper initialization of struct RVALUE

    This changeset makes no difference unless GC_DEBUG is on.  When that flag is
    set, struct RVALUE is bigger than struct RObject.  We have to take care of the
    additional fields.  Otherwise we get a SIGSEGV like shown below.

    The way obj is initialized in this patch works for both GC_DEBUG is on and off.
    See also ISO/IEC 9899:1999 section 6.7.8 paragraph #21.

    ```
    Program received signal SIGSEGV, Segmentation fault.
    __strlen_avx2 () at ../sysdeps/x86_64/multiarch/strlen-avx2.S:62
    62      ../sysdeps/x86_64/multiarch/strlen-avx2.S: No such file or directory
    (gdb) bt
    #0  __strlen_avx2 () at ../sysdeps/x86_64/multiarch/strlen-avx2.S:62
    #1  0x00005555557dd9a7 in BSD_vfprintf (fp=0x7fffffff6be0, fmt0=0x5555558f3059 "@%s:%d", ap=0x7fffffff6dd0) at vsnprintf.c:1027
    #2  0x00005555557db6f5 in ruby_do_vsnprintf (str=0x555555bfc58d <obj_info_buffers+1325> "", n=211, fmt=0x5555558f3059 "@%s:%d", ap=0x7fffffff6dd0) at sprintf.c:1022
    #3  0x00005555557db909 in ruby_snprintf (str=0x555555bfc58d <obj_info_buffers+1325> "", n=211, fmt=0x5555558f3059 "@%s:%d") at sprintf.c:1040
    #4  0x0000555555661ef4 in rb_raw_obj_info (buff=0x555555bfc560 <obj_info_buffers+1280> "0x0000555555d2bfa0 [0     ] T_STRING (String)", buff_size=256, obj=93825000456096) at gc.c:11449
    #5  0x000055555565baaf in obj_info (obj=93825000456096) at gc.c:11612
    #6  0x000055555565bae1 in rgengc_remembered (objspace=0x555555c0a1c0, obj=93825000456096) at gc.c:6618
    #7  0x0000555555666987 in newobj_init (klass=93824999964192, flags=5, v1=0, v2=0, v3=0, wb_protected=1, objspace=0x555555c0a1c0, obj=93825000456096) at gc.c:2134
    #8  0x0000555555666e49 in newobj_slowpath (klass=93824999964192, flags=5, v1=0, v2=0, v3=0, objspace=0x555555c0a1c0, wb_protected=1) at gc.c:2209
    #9  0x0000555555666b94 in newobj_slowpath_wb_protected (klass=93824999964192, flags=5, v1=0, v2=0, v3=0, objspace=0x555555c0a1c0) at gc.c:2220
    #10 0x000055555565751b in newobj_of (klass=93824999964192, flags=5, v1=0, v2=0, v3=0, wb_protected=1) at gc.c:2256
    #11 0x00005555556575ca in rb_wb_protected_newobj_of (klass=93824999964192, flags=5) at gc.c:2272
    #12 0x00005555557f36ea in str_alloc (klass=93824999964192) at string.c:728
    #13 0x00005555557f2128 in rb_str_buf_new (capa=0) at string.c:1317
    #14 0x000055555578c66d in rb_reg_preprocess (p=0x555555cc8148 "^-(.)(.+)?", end=0x555555cc8152 "", enc=0x555555cc7c80, fixed_enc=0x7fffffff74e8, err=0x7fffffff75f0 "") at re.c:2682
    #15 0x000055555578ea13 in rb_reg_initialize (obj=93825000046736, s=0x555555cc8148 "^-(.)(.+)?", len=10, enc=0x555555cc7c80, options=0, err=0x7fffffff75f0 "", sourcefile=0x555555d1a5c0 "lib/optparse.rb", sourceline=1460) at re.c:2808
    #16 0x000055555578e285 in rb_reg_initialize_str (obj=93825000046736, str=93825000046904, options=0, err=0x7fffffff75f0 "", sourcefile=0x555555d1a5c0 "lib/optparse.rb", sourceline=1460) at re.c:2869
    #17 0x000055555578ee02 in rb_reg_compile (str=93825000046904, options=0, sourcefile=0x555555d1a5c0 "lib/optparse.rb", sourceline=1460) at re.c:2958
    #18 0x0000555555748dfb in rb_parser_reg_compile (p=0x555555d1f760, str=93825000046904, options=0) at parse.y:12157
    #19 0x00005555557581c3 in parser_reg_compile (p=0x555555d1f760, str=93825000046904, options=0) at parse.y:12151
    #20 0x00005555557580ac in reg_compile (p=0x555555d1f760, str=93825000046904, options=0) at parse.y:12167
    #21 0x0000555555746ebb in new_regexp (p=0x555555d1f760, node=0x555555dece68, options=0, loc=0x7fffffff89e8) at parse.y:10072
    #22 0x000055555573d1f5 in ruby_yyparse (p=0x555555d1f760) at parse.y:4395
    #23 0x000055555574a582 in yycompile0 (arg=93825000404832) at parse.y:5945
    #24 0x00005555558c6898 in rb_suppress_tracing (func=0x55555574a470 <yycompile0>, arg=93825000404832) at vm_trace.c:427
    #25 0x0000555555748290 in yycompile (vparser=93824999283456, p=0x555555d1f760, fname=93824999283624, line=1) at parse.y:5994
    #26 0x00005555557481ae in rb_parser_compile_file_path (vparser=93824999283456, fname=93824999283624, file=93824999283400, start=1) at parse.y:6098
    #27 0x00005555557cdd35 in load_file_internal (argp_v=140737488331760) at ruby.c:2023
    #28 0x00005555556438c5 in rb_ensure (b_proc=0x5555557cd610 <load_file_internal>, data1=140737488331760, e_proc=0x5555557cddd0 <restore_load_file>, data2=140737488331760) at eval.c:1128
    #29 0x00005555557cb68b in load_file (parser=93824999283456, fname=93824999283624, f=93824999283400, script=0, opt=0x7fffffffa468) at ruby.c:2142
    #30 0x00005555557cb339 in rb_parser_load_file (parser=93824999283456, fname_v=93824999283624) at ruby.c:2164
    #31 0x00005555556ba3e1 in load_iseq_eval (ec=0x555555c0a650, fname=93824999283624) at load.c:579
    #32 0x00005555556b857a in require_internal (ec=0x555555c0a650, fname=93824999284352, exception=1) at load.c:1016
    #33 0x00005555556b7967 in rb_require_string (fname=93824999284464) at load.c:1105
    #34 0x00005555556b7939 in rb_f_require (obj=93824999994824, fname=93824999284464) at load.c:811
    #35 0x00005555558b7ae0 in call_cfunc_1 (recv=93824999994824, argc=1, argv=0x7ffff7ecd0a8, func=0x5555556b7920 <rb_f_require>) at vm_insnhelper.c:2348
    #36 0x00005555558a8889 in vm_call_cfunc_with_frame (ec=0x555555c0a650, reg_cfp=0x7ffff7fccfa0, calling=0x7fffffffaab0, cd=0x555555d76a10, empty_kw_splat=0) at vm_insnhelper.c:2513
    #37 0x000055555589fb5c in vm_call_cfunc (ec=0x555555c0a650, reg_cfp=0x7ffff7fccfa0, calling=0x7fffffffaab0, cd=0x555555d76a10) at vm_insnhelper.c:2538
    #38 0x000055555589f22e in vm_call_method_each_type (ec=0x555555c0a650, cfp=0x7ffff7fccfa0, calling=0x7fffffffaab0, cd=0x555555d76a10) at vm_insnhelper.c:2924
    #39 0x000055555589ef47 in vm_call_method (ec=0x555555c0a650, cfp=0x7ffff7fccfa0, calling=0x7fffffffaab0, cd=0x555555d76a10) at vm_insnhelper.c:3038
    #40 0x0000555555866dbd in vm_call_general (ec=0x555555c0a650, reg_cfp=0x7ffff7fccfa0, calling=0x7fffffffaab0, cd=0x555555d76a10) at vm_insnhelper.c:3075
    #41 0x00005555558ae557 in vm_sendish (ec=0x555555c0a650, reg_cfp=0x7ffff7fccfa0, cd=0x555555d76a10, block_handler=0, method_explorer=0x5555558ae5d0 <vm_search_method_wrap>) at vm_insnhelper.c:4021
    #42 0x000055555587745b in vm_exec_core (ec=0x555555c0a650, initial=0) at insns.def:801
    #43 0x0000555555899b9c in rb_vm_exec (ec=0x555555c0a650, mjit_enable_p=1) at vm.c:1907
    #44 0x000055555589aaf0 in rb_iseq_eval_main (iseq=0x555555c1da80) at vm.c:2166
    #45 0x0000555555641f0b in rb_ec_exec_node (ec=0x555555c0a650, n=0x555555c1da80) at eval.c:277
    #46 0x0000555555641d62 in ruby_run_node (n=0x555555c1da80) at eval.c:335
    #47 0x000055555557a188 in main (argc=11, argv=0x7fffffffc848) at main.c:50
    (gdb) fr 7
    #7  0x0000555555666987 in newobj_init (klass=93824999964192, flags=5, v1=0, v2=0, v3=0, wb_protected=1, objspace=0x555555c0a1c0, obj=93825000456096) at gc.c:2134
    2134        if (rgengc_remembered(objspace, (VALUE)obj)) rb_bug("newobj: %s is remembered.", obj_info(obj));
    (gdb) p ((struct RVALUE*)obj)->file
    $1 = 0x65a5992b0fb25ce7 <error: Cannot access memory at address 0x65a5992b0fb25ce7>
    (gdb)
    ```

commit 35eb12c06397e770392a41343cbffc4b204e15c9
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2019-12-12 12:39:24 +0900

    add casts

    %p is for void *.  Because fprintf is a function with variadic arguments
    automatic cast from any pointer to void * does not work.  We have to be
    explicit.

commit f40143fe7c55e3b2209f57e7ec4b3ad1d9468a1e
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2019-12-12 12:37:58 +0900

    fix arity mismatch

    I missed this in bc3e7924bc66d3ef77b219c72f3e59cc154550a3 because the
    function is inside of a #ifdef.

commit 12de92a3682f7a54941c511e6394068df2adefb3
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2019-12-12 11:11:39 +0900

    implement make test-all TESTS=--gc-compact

    79eb5e1acac2339c6ec71db723298bdfcd92b233 implemented
    RUBY_TEST_GC_COMPACT=1 so why not make it also possible via the command
    line argument.

commit 53e8589c69d1345235d9f02ecbcf6aa32fa9d39c
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-12 09:14:09 +0900

    Import json-2.3.0 from flori/json

commit 7d991a0571ab33f44c00fdc227f076d1eaf5fb2b
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-12 08:40:44 +0900

    Suppress to crash IRB if completed list has nil

commit 50ae8895f32f5fc620f0a0f288dae62815cb2a6f
  Author: Rei Odaira <rodaira@us.ibm.com>
  Date:   2019-12-12 04:31:38 +0900

    debug_counter.c: include ruby/config.h before stdio.h
    to define _LARGE_FILES

commit 27ac034f196967f54edf00474880886624d30245
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-12 04:26:03 +0900

    support gc_compact_checker on parallel test.

commit 7dbbba38a0a6acd41a43eb0c4fc416fe35e2345a
  Author: Aaron Patterson <tenderlove@ruby-lang.org>
  Date:   2019-10-12 09:13:02 +0900

    Make sure we don't push MOVED or NONE on the stack

commit 79eb5e1acac2339c6ec71db723298bdfcd92b233
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-12 03:31:13 +0900

    call GC.compact after each test.

    RUBY_TEST_GC_COMPACT=1 enables GC.compact checker which calls
    GC.compact after each test.

commit 51cc5a26df5f47ecdd88398ba1a50a8e62182649
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-12 03:18:44 +0900

    Some tests failed with before GNU Readline 6.0 on Windows

commit fe4502336680270d886b502e4b35ecb3de2f2164
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-12 03:13:32 +0900

    * 2019-12-12 [ci skip]

commit 0f90630983db3257c544c698761a00456af81d85
  Author: Aaron Patterson <tenderlove@ruby-lang.org>
  Date:   2019-12-12 03:12:14 +0900

    Update method tables only if there is a class ext pointer

    This makes reference updating look similar to marking, and may avoid
    dereferencing a wrong pointer.

commit cae657c32492a9b4e72b5e290c143e2c84d4c42d
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-11 21:54:18 +0900

    Fix .travis.yml to keep s390x-linux as allow_features

    [Misc #16360]

commit 47a365dd580f2dfe0f0d56155587dfdf2fc7afb7
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-11 20:44:39 +0900

    Move s390x-linux to allow_failures matrix

    ref [Misc #16360]

commit 49ffae7ca66f3e0bc3e2d87092197d3514d5925e
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2019-12-02 12:59:07 +0900

    [ruby/forwardable] Bump version to 1.3.1

    https://github.com/ruby/forwardable/commit/aa07c55f3f

commit 0dcd3340fb5f91112ce66c53315eff92b9f10fb7
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2019-12-02 12:57:06 +0900

    [ruby/forwardable] Make def_*_delegator return name of method defined (Fixes #10)

    This restores compatibility with previous versions.  This behavior
    was previously undefined, but it makes sense for the name of the
    defined method to be returned.

    https://github.com/ruby/forwardable/commit/a52ef3451e

commit c2f6aa4e4810f8f2aabc35bf4c98ee030ff504b9
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-11 19:39:37 +0900

    The result of Readline.completion_proc should have the same encoding of Encoding.default_external

commit 3098798044ada5a81862aa4668aaf7548f9b1c99
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-11 16:41:37 +0900

    Test `Thread#to_s` when used from to_s_spec.rb

commit d2d42081ce76954ff55392a6e07e3eb4f26c696c
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-11 16:19:49 +0900

    `Thread#to_s` has been added at ruby 2.5

commit eb9c0070535bc088ab2921613830ba983bfe07a1
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-11 16:48:19 +0900

    skip continuous failure test.

    On mingw this test fails and not solved long time, so skip it.
    Please revert it when it solved.

    https://ci.appveyor.com/project/ruby/ruby/builds/29458671/job/9nbcjnfe6p0xnxoe

commit 1269157a6e46895c0eda2ea202d44790bbe815c8
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-11 16:10:26 +0900

    Thread#to_s is not same as #inspect on old version.

    Thread#to_s returns simple Object#to_s until Ruby 2.4.

commit 7f5014e6e884d7fa091e3e6462827b910417267c
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-11 15:45:23 +0900

    rely on sorted compiled binary array.

    `builtin_binary` is sorted by miniruby loading order and this
    loading order should be same on ruby. So we can believe sorted
    order of `builtin_binary` on boot time.

commit 0afee4d80355dd03f0dfefe6120e2e1808d9cb50
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-11 14:27:21 +0900

    Show the failed message

commit 7fa821a80d60992f019c98ac813e2fc6e9775031
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-11 14:01:23 +0900

    Try to use `set-output`

    because commit info are not necessary in env.

commit 6025783a3b0b37517728c635250669449bb21a53
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-11 14:00:32 +0900

    fix for old MRI versions

commit fe8caf0ab93e69b743470d16f6cf7416fe9c98da
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-11 13:37:00 +0900

    add dependency pointed by update-deps

commit 35adc47e7eb1640d35e4d294af7e9651d918608d
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-11 13:08:21 +0900

    Create dummy files when check only

    because foo.rb in build directory breaks test-bundler
    https://github.com/ruby/ruby/runs/343168046#step:20:125

commit cf948a3d3f37c4a786611f5b48c9c020f6020161
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-10 23:01:23 +0900

    Do not load q.rb in build directory

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2736

commit 4f5dc15b049eacb9070e2c941183fed68c41f81e
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-10 21:44:34 +0900

    Create more dummy files in build directory

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2736

commit 1ed0212bcf76ec244ca5b75c65f09e5b04158377
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-10 18:31:01 +0900

    Do not load files in build directory

    related https://bugs.ruby-lang.org/issues/16177

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2736

commit 85e43e1dfecef69b935c48c235cc20f21bd4f0d4
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2019-12-11 06:38:12 +0900

    Fix Enumerator::Lazy#with_index

    * Make it correctly handle lambdas
    * Make it iterate over the block if block is given

    The original implementation was flawed, based on lazy_set_method
    instead of lazy_add_method.

    Note that there is no implicit map when passing a block, the return
    value of the block passed to with_index is ignored, just as it
    is for Enumerator#with_index. Also like Enumerator#with_index,
    when called with a block, the return value is an enumerator without
    the index.

    Fixes [Bug #16414]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2742

commit 8a80bfcfd4d510a20a62e21d8d2f4119cb823d4f
  Author: Jean byroot Boussier <jean.boussier+github@shopify.com>
  Date:   2019-12-10 19:49:39 +0900

    Make Thread#to_s consistent with Method and Proc to_s

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2738

commit 6a7af800dbd45946caaadfc4a1212fc523afe58b
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-11 11:36:21 +0900

    Add a message for CompatibilityError

commit 7e9b1609dae0998a4418179f40dc488842c56e5d
  Author: Eli Sadoff <9064062+snood1205@users.noreply.github.com>
  Date:   2019-12-11 11:25:54 +0900

    Added documentation for integer range sums (#1593)

commit 86e2c013d7ade7c93077d599e155aae0f3b632e8
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-11 11:25:00 +0900

    * remove trailing spaces. [ci skip]

commit bbbf451bffbc5605b53726c5977d96bffc10d162
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-11 11:22:27 +0900

    Update tool/mk_builtin_binary.rb

    Co-Authored-By: Sutou Kouhei <kou@cozmixng.org>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2735

commit 40026a408df5e3576380f6c1d8bf6c119fa2e32b
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-10 17:39:04 +0900

    support cross-compilation.

    On cross-compilation, compiled binary can no be created because
    compiled binary should be created by same interpreter (on cross-
    compilation, host ruby is used to build ruby (BASERUBY)).
    So that cross-compilation system loads required scripts in text.
    It is same as miniruby.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2735

commit 9c2807b2df14984e3c81d72a381d9a4d288b3fbe
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-10 17:13:42 +0900

    remove prelude.c

    prelude.c is an automatically generated file by template/prelude.c.tmpl.
    However it does not contain any required functions. So remove it from
    dependency.

    Also miniprelude.c is included by mini_builtin.c and does not need
    to make miniprelude.o.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2735

commit 2c5c60754cafe9895b7a7421cd0552eaa2ae8b09
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-10 16:19:13 +0900

    use compiled binary for gem_prelude.rb.

    `gem_prelude.rb` is not compiled yet. This patch compile it to
    compiled binary.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2735

commit 943f3e5fd463bf2a4a3a4e92b5134e238b9c931d
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-09 16:20:35 +0900

    add include guard

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2735

commit 69aa927a40618591082085fe04c010d516dd50d3
  Author: Corey Farwell <coreyf@rwell.org>
  Date:   2017-04-18 06:58:51 +0900

    Indicate `find_all` and `select` methods are aliases.

    This matches the documentation for `Enumerable::inject` and `Enumerable::reduce` which are also aliases.

commit 0fafb83b3878b11de18de7a2d09927842eaf5fb7
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-11 11:13:28 +0900

    * 2019-12-11 [ci skip]

commit ec54ac938104517dd61887006ef8cc324b3b1b35
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-11 11:12:54 +0900

    Support Readline.completion_quote_character by Reline

commit 8e49ef5a691cc9a249acae8c7335ec53bf445dc3
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-10 23:13:40 +0900

    [ruby/io-console] update depend for f9c0fe77c0e

commit 2a2a707829168b898508ae27a0458719a36bd316
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-10 21:21:19 +0900

    Followed up 38722fa179fcec549300b2f35206f4eb168f202e

commit 95f570d0d349a7fd86c6425c9c5d7d87cc5ecd46
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-10 20:56:09 +0900

    [ruby/logger] bump version to 1.4.2

    https://github.com/ruby/logger/commit/d6c01cc652

commit 0b10d46a577bb6b0e8e177f5c3f17f8d61007d6c
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2019-08-21 13:28:14 +0900

    [ruby/logger] Enable more timezone tests on OpenBSD

    https://github.com/ruby/logger/commit/bcd7e227e8

commit 7a1c56f978907d03876772d942619ec90cbbfa6b
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2019-11-18 10:34:56 +0900

    [ruby/logger] Document that shift_age of 0 disables log file rotation

    Fixes Ruby Bug 16349.

    https://github.com/ruby/logger/commit/b1b6d06f2d

commit 38722fa179fcec549300b2f35206f4eb168f202e
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2019-10-15 10:08:10 +0900

    [ruby/logger] Raise ArgumentError for invalid shift_age

    Consider 'now' and 'everytime' as valid values for the previous
    behavior of rotating every time.

    Fixes Ruby Bug 15977

    https://github.com/ruby/logger/commit/f92979a376

commit eb18cb3e476db3bc44d489e090e1535237c4c6c9
  Author: George Claghorn <george@basecamp.com>
  Date:   2019-09-07 07:28:05 +0900

    [ruby/logger] Honor Logger#level overrides

    https://github.com/ruby/logger/commit/7365c995bf

commit af11efd377965b6601bb54aa79072ef0789dc525
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2019-12-10 19:06:13 +0900

    fix ipaddr parameter of Net::HTTP.start to support proxy

    54072e329cab7207fba133caba4fc12b45add8f9

commit aedbee52c0e21358c33e775eab41c634905f63c3
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-10 18:49:53 +0900

    Prefer $(CHDIR) for the case srcdir contains symlinks

commit 79d2a1b004b06692279bb647e0eee712e55d14c4
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-10 18:41:05 +0900

    Update regression tests for 1.4.16

commit 8299bcd9465b98bd40711bb9c0d4488aba0b72e1
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-10 18:18:04 +0900

    .indent.pro: Removed because it is no longer used

commit c596e01a49d8c77b6dacc931a24eb4b7876617b7
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-10 18:05:51 +0900

    Move SECURITY.md into .github/ to reduce the files on the top directory

commit fe0df7dcfc92b81d3508473a08584f8372418323
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-10 17:27:43 +0900

    Change encoding of completion strings

commit 60c53ff6ee1eed054fc3d78ad6c06cbfc56900d6
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-10 17:10:23 +0900

    vm_core.h (iseq_unique_id): prefer uintptr_t instead of unsigned long

    It produced a warning about type cast in LLP64 (i.e., windows).

commit e27d2013db18d124d1362b6cc81ecec806ef1a0d
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-10 17:03:46 +0900

    Import racc-1.4.1 from ruby/racc.

commit 43544f8617a81fbaef03d926777df4a5311cdb74
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-10 17:03:13 +0900

    Added the missing gemspec of racc

commit 58e5ab78d0a88d9153770a82cff9b553f53dd5d5
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-10 15:26:14 +0900

    [ruby/io-console] bump up to 0.5.1

commit 2419b3dba6d86ea40a148f7547ff87b2074ca582
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-10 10:44:21 +0900

    [ruby/io-console] Suppress an unused-variable warning

    https://github.com/ruby/io-console/commit/ae5c72e481

commit f9c0fe77c0ef6c5da1d8454bf6be6841c984d606
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-10 10:09:33 +0900

    [ruby/io-console] Use rb_thread_call_without_gvl instead of the deprecated function

    https://github.com/ruby/io-console/commit/21338ab287

commit 09723b98f7a8db4ce6d22cd282525275154736fe
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-10 10:08:43 +0900

    [ruby/io-console] Warn vtime option without intr flag

    https://github.com/ruby/io-console/commit/499ff3de48

commit 0c2787b9b29d839876ac68afbd6209a8407fcb30
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-10 10:05:25 +0900

    [ruby/io-console] bump up to 0.5.0

commit 1bdabaa6b13344c195698ca5b0ced323cb93e2e1
  Author: Konstantin Papkovskiy <konstantin@papkovskiy.com>
  Date:   2017-08-15 23:35:58 +0900

    base64.rb: improve performance of Base64.urlsafe_encode64

    * lib/base64.rb: avoid unnecessary memory allocations

commit 3ca3c8d768f6d81da72df4798736c2e0059d19f9
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-10 14:15:35 +0900

    lib/net/http.rb: align the indentation

commit 7be550d046c726c2a3aa625ceb260d9b2268fb5a
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-10 12:41:09 +0900

    Stop Thread.new in `DRb::TimerIdConv::TimerHolder2#on_gc`

    and add more stop_pool after stop_service

commit 129c3216d966fc25209a7e50418413ffecd25281
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-10 12:11:56 +0900

    [cygwin] Removed unnecessary packages

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2734

commit cd35c0954085758ec1fb5a5fcfb7d6d9d5e71a90
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-10 12:11:37 +0900

    [cygwin] Removed unnecessary `-c` options

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2734

commit ec931ee9e13b939f6693032564ee9beeec5a4a1f
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2019-12-10 11:42:29 +0900

    forward declare struct timespec

    ... like we do so for struct timeval at several hundreds of lines above.
    Depending on OS/Compiler, this can be the first place for the struct to
    appear.  To make sure the struct is global, we need a forward
    declaration at this point.

commit c50d9dc67d350ad4e21ff1af39635bb5a6114282
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-10 11:26:22 +0900

    test/ruby/test_keywords.rb: suppress a warning

    https://rubyci.org/logs/rubyci.s3.amazonaws.com/ubuntu1604/ruby-master/log/20191210T003005Z.log.html.gz
    ```
    .../test/ruby/test_keyword.rb:2711: warning: `*' interpreted as argument prefix
    ```

commit 660388f6c5b148ea6f84d589482391bf78f35c6b
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-10 09:41:33 +0900

    test/net/http/test_https.rb (test_get_SNI_failure): stop proxy settings

    Because the test fails under HTTP proxy settings.

    https://rubyci.org/logs/rubyci.s3.amazonaws.com/solaris10-gcc/ruby-master/log/20191210T000004Z.fail.html.gz
    ```
      1) Failure:
    TestNetHTTPS#test_get_SNI_failure [/export/home/users/chkbuild/cb-gcc/tmp/build/20191210T000004Z/ruby/test/net/http/test_https.rb:81]:
    [OpenSSL::SSL::SSLError] exception expected, not #<Net::HTTPServerException: 403 "Forbidden">.
    ```

    The new SNI feature introduced at 54072e329c may need to be improved for
    HTTP proxy environment.

commit 6a22b2a091eda81a473eb1b0cc69fe0792560e27
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-10 07:01:26 +0900

    Support completion with case-insensitive fashion

    Reline performs completion in a case-insensitive fashon if
    Readline.completion_case_fold or completion-ignore-case of .inputrc are set
    "on".

commit 562fd754b55aaaf794fa8eb5461eb0ee87725464
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-10 00:10:44 +0900

    * 2019-12-10 [ci skip]

commit f45c0dc23980d7fd8167d290ea7c354cf2cdb500
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2019-12-06 04:01:20 +0900

    Add Proc#ruby2_keywords

    This allows passing keywords through a normal argument splat in a
    Proc.  While needing ruby2_keywords support for methods is more
    common, there is code that delegates keywords through normal
    argument splats in procs, including code in Rails.  For that
    reason, it makes sense to expose this for procs as well.

    Internally, ruby2_keywords is not tied to methods, but iseqs,
    so this just allows for setting the ruby2_keywords for the iseq
    related to the proc.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2728

commit c2dc27d6435f40ff24f553cf47816a1c696bbbba
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2019-12-09 20:48:35 +0900

    fix typo of 54072e329cab7207fba133caba4fc12b45add8f9

commit 54072e329cab7207fba133caba4fc12b45add8f9
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2019-12-09 20:19:11 +0900

    Add ipaddr optional parameter to Net::HTTP#start

    to replace the address for TCP/IP connection [Feature #5180]

    There're 3 layers of hostname:
    * host address for TCP/IP
    * TLS server name
    * HTTP Host header value
    To test DNS round robin or check server certificate from server local,
    people sometimes want to connect server with given IP address but keep
    TLS server name and HTTP Host header value.

    closes [Feature #15215]
    closes https://github.com/ruby/ruby/pull/1893
    closes https://github.com/ruby/ruby/pull/1977

commit 194327942690a7997c7b48d34cc105c6ec8b8d40
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-09 19:16:51 +0900

    Added workaround for CoreAssertions used by ruby/logger.

commit 4b36832ba64a8879a4b0702d6d5079ddd9d3078e
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-12-09 19:11:18 +0900

    Merge the upstream changes for test-unit on ruby/logger.

      This commits are based with:
        https://github.com/ruby/logger/commit/f067f7d1aa743b467d633ec6d1790bd93ed9e25b
        https://github.com/ruby/logger/commit/86058f420d8f6909500cccceb24f58bef0597b4d
        https://github.com/ruby/logger/commit/02db6e8ed85d1f4ba974f08fee292bad400d9fc2

commit ff7cc0dc34832a074ce42e383439b87ea63b42f7
  Author: sonots <sonots@gmail.com>
  Date:   2019-08-20 21:10:08 +0900

    [ruby/logger] 1.4.1

    https://github.com/ruby/logger/commit/5987f518d1

commit 895f86c81b95143ecdcca6a8cd4e9367a33b0aaa
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-08-20 16:39:38 +0900

    [ruby/logger] Fixes #38

    https://github.com/ruby/logger/commit/31efbb29ff

commit 0fe1b0508249bc6d64a67c17307a0037f29add74
  Author: sonots <sonots@gmail.com>
  Date:   2019-08-20 03:02:21 +0900

    [ruby/logger] 1.4.0

    https://github.com/ruby/logger/commit/8127ce0b56

commit 6158e28f8d02026e21317d8a0c2cb2115b3a0660
  Author: Akira Matsuda <ronnie@dio.jp>
  Date:   2019-07-31 14:38:38 +0900

    [ruby/logger] Avoid creating [] and "" when logging an Exception that has no backtrace

    https://github.com/ruby/logger/commit/75fd308053

commit 0aafc32995b935b6c46c8439a3e2da008cd683fc
  Author: sonots <sonots@gmail.com>
  Date:   2019-03-22 01:14:14 +0900

    [ruby/logger] frozen_string_literal: true

    https://github.com/ruby/logger/commit/a057eede7b

commit 22548195d59d8b5e421c586bec81615a0a1091bc
  Author: Alan Wu <XrXr@users.noreply.github.com>
  Date:   2019-07-15 14:52:06 +0900

    [ruby/logger] Fix typo

    https://github.com/ruby/logger/commit/5f70168ac5

commit 8395a6a9a0696d1a0a6aa6a019a1a919ee2c854f
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-09 15:05:17 +0900

    Add badge of Cygwin

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2733

commit a5e6a50cb8e4acd4feee2ad3a61eac568f2c62b6
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-09 15:04:59 +0900

    Add cache of cygwin packages

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2733

commit ea8f03e86c57ff28154345865a2560b8895f3e68
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-09 15:03:10 +0900

    Remove unused branch name

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2733

commit 801eafcc146808399f9ca53b3f3b730b81235abb
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-09 14:29:38 +0900

    Split cygwin-chocolatey cache

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2733

commit c19e62ddc9d7160d470f76dae823e9546d0a7bf3
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-09 14:06:06 +0900

    Remove debug print

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2733

commit 156fb72d7015b420c57b0bd230693f52d8d75b32
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-09 15:22:48 +0900

    vm_args.c (rb_warn_check): Use iseq_unique_id instead of its pointer

    (This is the second try of 036bc1da6c6c9b0fa9b7f5968d897a9554dd770e.)

    If iseq is GC'ed, the pointer of iseq may be reused, which may hide a
    deprecation warning of keyword argument change.

    http://ci.rvm.jp/results/trunk-test1@phosphorus-docker/2474221

    ```
    1) Failure:
    TestKeywordArguments#test_explicit_super_kwsplat [/tmp/ruby/v2/src/trunk-test1/test/ruby/test_keyword.rb:549]:
    --- expected
    +++ actual
    @@ -1 +1 @@
    -/The keyword argument is passed as the last hash parameter.* for `m'/m
    +""
    ```

    This change ad-hocly adds iseq_unique_id for each iseq, and use it
    instead of iseq pointer.  This covers the case where caller is GC'ed.
    Still, the case where callee is GC'ed, is not covered.

    But anyway, it is very rare that iseq is GC'ed.  Even when it occurs, it
    just hides some warnings.  It's no big deal.

commit 07664f3aec1b80f6ffe3929258c9a246f0bdcc48
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-09 14:21:05 +0900

    Remove workaround encoding modification

commit a14c01441b12552386c69233b0bcc53d06ed0b92
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-09 14:20:25 +0900

    Fix encoding compatibility checking of completion correctly

commit 3cdb37d9db9b7776f6adf96c70eacc39773718b4
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-09 13:49:24 +0900

    Revert "vm_args.c (rb_warn_check): Use iseq_unique_id instead of its pointer"

    This reverts commit 036bc1da6c6c9b0fa9b7f5968d897a9554dd770e.

    This caused a failure on iseq_binary mode.
    http://ci.rvm.jp/results/trunk-iseq_binary@silicon-docker/2474587

    Numbering iseqs is not trivial due to dump/load.

commit 39c7230a7a7a039639d2cb3587c054554a1beb18
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-09 13:49:17 +0900

    Revert "vm_args.c (rb_warn_check): Use unique_id * 2 instead of unique_id"

    This reverts commit 751a9b32e5a53336768eb878de1827245a3292bf.

commit 8b07c122b7785fde6b06dd31b09f59a7cbdac2cd
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-09 13:46:23 +0900

    Stop pool threads in test/rinda too

commit 751a9b32e5a53336768eb878de1827245a3292bf
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-09 12:30:00 +0900

    vm_args.c (rb_warn_check): Use unique_id * 2 instead of unique_id

    The function assumed that the LSB of `callee` was 0.

commit 036bc1da6c6c9b0fa9b7f5968d897a9554dd770e
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-09 12:04:58 +0900

    vm_args.c (rb_warn_check): Use iseq_unique_id instead of its pointer

    If iseq is GC'ed, the pointer of iseq may be reused, which may hide a
    deprecation warning of keyword argument change.

    http://ci.rvm.jp/results/trunk-test1@phosphorus-docker/2474221

    ```
      1) Failure:
    TestKeywordArguments#test_explicit_super_kwsplat [/tmp/ruby/v2/src/trunk-test1/test/ruby/test_keyword.rb:549]:
    --- expected
    +++ actual
    @@ -1 +1 @@
    -/The keyword argument is passed as the last hash parameter.* for `m'/m
    +""
    ```

    This change ad-hocly adds iseq_unique_id for each iseq, and use it
    instead of iseq pointer.  This covers the case where caller is GC'ed.
    Still, the case where callee is GC'ed, is not covered.

    But anyway, it is very rare that iseq is GC'ed.  Even when it occurs, it
    just hides some warnings.  It's no big deal.

commit 0e71fbc18e97007ac9a9b242b800f34057f5f287
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-09 00:13:07 +0900

    * 2019-12-09 [ci skip]

commit 963b84a51bf0b80da44ab775d788a911b676a6a9
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-08 23:37:04 +0900

    Separate steps

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2731

commit 5e65e65bd935954190a5d481def788524c4ae169
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-08 23:00:46 +0900

    Set PATH at once

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2731

commit d00349f99470cfddd522ee1e7fa9a5f6dc126771
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-08 23:09:39 +0900

    Fixed the checking out source

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2731

commit 689e74485598d2c023fc2a00fac80b717b6f29b7
  Author: Daisuke Fujimura (fd0) <booleanlabel@gmail.com>
  Date:   2019-12-06 23:53:25 +0900

    Add .github/workflows/cygwin.yml

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2731

commit 0d63a2104777e467568a31037a6573e1879870c7
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-08 18:29:39 +0900

    Skip completion tests for Editline

commit c38bc172bee99ff71440a1ebb4c38e6d092e0807
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-08 08:35:31 +0900

    Fix encoding of completed list

commit 2eb674377371d276b9de5ce06a591419f00f7c42
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-08 08:10:50 +0900

    * 2019-12-08 [ci skip]

commit c9b06d4a4e52b6ae705ebb16cafe455671780770
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-08 08:01:27 +0900

    Add test_simple_completion for Readline

commit be13b897ead62debd6d2e7696e5d28a8e8781620
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-07 22:02:24 +0900

    Show failed commits only when exists

commit 0ff84eda4e130ae17abccbb8aa92ad47e83d151d
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-07 20:28:23 +0900

    [ruby/irb] Version 1.2.0

    https://github.com/ruby/irb/commit/da6577a88c

commit 2e595c2d780814cc4d1357c687b44fd7208ff313
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-07 20:26:01 +0900

    [ruby/irb] New IRB needs Ruby 2.5 or later

    https://github.com/ruby/irb/commit/4be3158358

commit ad6837dd609654b02885199b25f7d79b1122b64a
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-07 20:21:08 +0900

    [ruby/irb] Revert "Reidline mode needs Reline what needs String#grapheme_clusters"

    This reverts commit 2b0b19b87c60d2cdb329979acbb96e12a1f940e7.

    New IRB parser needs new Ripper what has lex_state too. The new Ripper is
    adopted by Ruby 2.5 or later.

    https://github.com/ruby/irb/commit/9ab6e35a2c

commit c2afddccb36c10ac0eb530bfc3b38765882126d8
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-07 19:51:03 +0900

    [ruby/irb] Reidline mode needs Reline what needs String#grapheme_clusters

    https://github.com/ruby/irb/commit/2b0b19b87c

commit e72ffc55ba3cc9bf20c892d2d090a77f40c49ada
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-07 12:11:55 +0900

    [ruby/reline] Support Ruby 2.5 or later for String#grapheme_clusters

    https://github.com/ruby/reline/commit/33e8c8f15b

commit ebbc77836b74a74d7c07a9b91fff886219956e3c
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-07 13:15:47 +0900

    test/ruby/test_file_exhaustive.rb: shorten the name of temporary dir

    ```
      1) Error:
    TestFileExhaustive#test_socket_p:
    ArgumentError: too long unix socket path (109bytes given but 108bytes max)
        /export/home/users/chkbuild/cb-sunc/tmp/build/20191207T024036Z/ruby/test/ruby/test_file_exhaustive.rb:155:in `initialize'
    ```

commit dcf89b20d7b79b51e268ea3ffcfdc0829edf7643
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-07 01:28:20 +0900

    * 2019-12-07 [ci skip]

commit 544431e028e9d678f2989c35876a05c53f07e0ec
  Author: Namrata Bhave <Namrata.Bhave@ibm.com>
  Date:   2019-12-07 01:27:58 +0900

    Adding s390x support (#2727)

commit 2f6a8baac6a84935cef1f10adbba2f47df4a2346
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-06 15:56:14 +0900

    Test interfaces include localhost

    When interfaces do not include localhost,
    some other tests may fail.

commit 2c8d186c6e4fd03ea57466fa6dce6bad40d09401
  Author: Aaron Patterson <tenderlove@ruby-lang.org>
  Date:   2019-10-12 09:06:41 +0900

    Introduce an "Inline IVAR cache" struct

    This commit introduces an "inline ivar cache" struct.  The reason we
    need this is so compaction can differentiate from an ivar cache and a
    regular inline cache.  Regular inline caches contain references to
    `VALUE` and ivar caches just contain references to the ivar index.  With
    this new struct we can easily update references for inline caches (but
    not inline var caches as they just contain an int)

commit 38b7f947a2c76aad29a2e42f3bd0848854d96519
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-06 00:13:22 +0900

    * 2019-12-06 [ci skip]

commit 693cba1a136aafb0faa25f93434a2e8dbad320de
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-06 00:11:11 +0900

    Detect started threads when require only

commit 173b864668777ef157a0c82b6e6f1a6aa0f06ac9
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-05 23:56:14 +0900

    Do not start thread when `require 'drb/drb'` only

commit 6477d98e49dbe04deb03caee1a58a34c3b79d4e4
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-05 23:46:42 +0900

    test/lib/jit_support.rb: Update the regexp for icc

    MJIT_CC is always an absolute path.

commit d43b9eb22de1b1cd8de09a161cc836413cc158a1
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-05 22:37:08 +0900

    lib/drb/drb.rb: suppress warning: instance variable @pool_proxy not initialized

commit f4d9daf2b6f23af08296c7ccb770e1de1bc723bd
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-05 22:24:58 +0900

    coroutine/ucontext/Context.c: define __EXTENSIONS__ explicitly

    instead of ruby/config.h, per samuel's request.

    https://github.com/ruby/ruby/commit/dbfd4b780e3914a3f27e92c2248254452bf0fd6b#diff-7fd78c3cc8a19b7e0637502983ec26ff

commit c3abbc1b2f52015dc839fd96545380dbc11c77a9
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-05 16:18:22 +0900

    ext/openssl/extconf.rb: check with -Werror=deprecated-declarations

    This reverts commit 0d7d8b2989e1738dd902d354cc41186899e6b71e,
    but restore `$warnflags` without the flag, to get rid of using
    deprecated functions.

commit 4c88107c54b06c1a3e89970eb243c8ac887d84e1
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-05 18:14:31 +0900

    Fix `warning: already initialized constant DidYouMean::VERSION`

    ```
    .../gems/did_you_mean-1.3.1/lib/did_you_mean/version.rb:2: warning: already initialized constant DidYouMean::VERSION
    .../lib/did_you_mean/version.rb:2: warning: previous definition of VERSION was here
    ```

commit 75b644350a80bc31449b7cee741d309643dc27e1
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-05 17:57:05 +0900

    ext/psych/extconf.rb: braced VPATH is for nmake only

commit 0bca34ddaaf15caa852007f401707c1785aa8ed6
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-05 16:55:31 +0900

    test/io/console/test_io_console.rb: add a memo for the mysterious hack

commit 264d5aff5afecb08b0a2ccafedc0a43de4f8d16a
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-05 16:28:54 +0900

    Change encoding of completion list...for more tests

commit ee579200082329db66e153c465cb8332e55bacb2
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-05 15:01:37 +0900

    move an interrupt point.

    `args_ptr` can be corrupted by interrupt handlers.
    Pointed by nagachika <https://ruby-trunk-changes.hatenablog.com/entry/ruby_trunk_changes_20191204>.

commit b40bb27e3594bbc2e9c9ac00dfa5612ebae3151b
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-05 15:38:29 +0900

    test/io/console/test_io_console.rb: Try the hack for Solaris

    I'm not entirely sure why, but test_set_winsize_console gets stuck on
    Solaris (and if I recall, macOS).  I found a hack for FreeBSD, so I want
    to give it a try on Solaris too.

commit fa1db8f938c083ce1416f999fe8b3cf33f9f18f1
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-05 15:25:11 +0900

    Add missing dependency

    https://travis-ci.org/ruby/ruby/jobs/620972117

commit 72cff5f3af47ec8d694feef97516089e86d89673
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-05 15:18:42 +0900

    MJIT_CC and MJIT_SUPPORT are not a prefix

    0b19e15a1239bff9ae854f522f954206ec910cf8 was also for "MJIT_SUPPORT"
    too.

commit 5fbb4555b427909aed4fe2376c4c583849c1d51c
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-05 15:16:07 +0900

    Prefer using MJIT_CC for JIT support check

    because Solaris might have CC=cc and we'd like to check full path
    MJIT_CC=/opt/developerstudio12.5/bin/cc instead.

commit 199bd851e40438380b2e0f57662a212200e3ba1a
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-05 14:51:07 +0900

    parse.y: suppress "set but not used" warnings on ripper.y

commit edb80dfe3e6086fb9d5d905a40cdd6ec61a2e1ee
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-05 14:39:03 +0900

    add additional CF info for CI env

    Introduce new RUBY_DEBUG option 'ci' to inform Ruby interpreter
    that an interpreter is running on CI environment.

    With this option, `rb_bug()` shows more information includes
    method entry information, local variables information for each
    control frame.

commit c88afd532895a8527f7c9fffb2c635805d01f626
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-05 14:38:46 +0900

    fix parameter

commit 0d7d8b2989e1738dd902d354cc41186899e6b71e
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-05 14:41:38 +0900

    ext/openssl/extconf.rb: do not use -Werror=deprecated-declarations

    It fails to build on Solaris:

    ```
    ossl_cipher.c: 関数 ‘ossl_cipher_init’ 内:
    ossl_cipher.c:228:2: エラー: ‘EVP_md5’ is deprecated [-Werror=deprecated-declarations]
      228 |  EVP_BytesToKey(EVP_CIPHER_CTX_cipher(ctx), EVP_md5(), iv,
          |  ^~~~~~~~~~~~~~
    In file included from /usr/include/openssl/x509.h:73,
                     from /usr/include/openssl/x509v3.h:63,
                     from ossl.h:23,
                     from ossl_cipher.c:10:
    /usr/include/openssl/evp.h:732:26: 備考: ここで宣言されています
      732 | DEPRECATED const EVP_MD *EVP_md5(void);
          |                          ^~~~~~~
    ```

    I agree that `-Werror=` is a good habit, but adding it by default is too
    aggressive.

commit c0d118f41a3a66ab76a553f184efe431524b952d
  Author: Jun Aruga <junaruga@users.noreply.github.com>
  Date:   2019-12-05 14:17:16 +0900

    Fix "cannot find the function: strcpy()" error on arm32 on Travis CI. (#2686)

    This issue happened when `libc.so` and `libm.so` path were not found
    and `ldd ruby` command also failed to print the shared dependencies
    in `test/fiddle/helper.rb`.

    See https://travis-ci.org/ruby/ruby/jobs/611483288#L3018
    /home/travis/build/ruby/ruby/build/.ext/common/fiddle/import.rb:299:in `import_function': cannot find the function: strcpy() (Fiddle::DLError)

    * Set libc6:armhf as a installing dependency explicitly.
    * Remove arm32 from allow_failures.

commit ed5d032ea33a465fd7152a236a4aca0ff5653bf3
  Author: Antonio Terceiro <asa@terceiro.xyz>
  Date:   2019-11-26 09:25:53 +0900

    debug.rb: expand filenames in breakpoints

    When debugging some local code, specifying a breakpoint to a local
    filename does not work, i.e.

        break lib/foo.rb:10

    Expanding the filename makes it work. FWIW byebug has the same behavior.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2694

commit 20031f8b74a224bed88bfd149d59d6176c4f58e2
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-05 13:06:08 +0900

    Change encoding of completion list

commit df76f2c577b6567b617be2df9451123cc450d1cc
  Author: Alan Wu <XrXr@users.noreply.github.com>
  Date:   2019-12-05 11:02:21 +0900

    Make TracePoint.stat a singleton method again (#2726)

    [Bug #16399]

  Notes:
    Merged-By: XrXr

commit e4db0443bcfc94f9183e8ea72fb4ab560aa005bf
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2019-07-23 11:56:02 +0900

    Make rb_eval_string_wrap specify a cref so constant setting works correctly

    Fixes [Bug #10466]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2722

commit 18d3b5a93a2d52412f8f563d58db682b41d5c98c
  Author: Yuki Nishijima <yk.nishijima@gmail.com>
  Date:   2019-12-05 09:55:01 +0900

    Do not attempt to call methods on the receiver if it is a basic object

commit 88ee375dd6c93523bd5d8f9517e49215b9d8cf67
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-05 09:43:45 +0900

    Revert "Add debug option to check ci failures on solaris"

    This reverts commit f289e3994bbc6560e2e4e5905b52c35c829c972d.

commit fbf10ed5b3f37b7cd9950ac8d1f1c81255525d36
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-05 09:03:49 +0900

    * 2019-12-05 [ci skip]

commit e3587ed8498dcf7a3a8178030f7ae66cd0719c57
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-04 22:32:12 +0900

    Support disable-completion

commit ad8fbf444abdf1480d87c95b2868741f98eb953f
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-04 22:26:40 +0900

    Fix variable catch

commit fb11e6089dbe9d995510977def038a21882bcffe
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-04 21:52:29 +0900

    [DOC] Added File::FNM_SYSCASE example [Bug #16391] [ci skip]

commit dbfd4b780e3914a3f27e92c2248254452bf0fd6b
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-04 20:59:39 +0900

    coroutine/ucontext/Context.c: Include "ruby/config.h" for Solaris

    getcontext, makecontext, and swapcontext seem to be available only when
    `__EXTENSION__` is defined on Solaris.

commit a0bc0e1ba15e83c72426ac243ea96e6497c49859
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-04 18:43:19 +0900

    Fix thread leak in drb

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2724

commit 00bbdf4451d0e66f0f7823e77c47ac310614c1c3
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2019-12-04 15:31:51 +0900

    implement Range#count

    As matz requested in [Bug #16366].

commit c6e3db0c66312af1e932c21006437419efa9ac75
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-04 13:36:41 +0900

    new_cond before mon_initialize

    MonitorMixin#new_cond can be called before mon_initialize, so we
    need to initialize `@monitor` before it.

    https://bugs.ruby-lang.org/issues/16255#note-4

commit f9e5c74cd24025a5aa19e318e8fecabf207f1b7b
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-04 10:33:35 +0900

    compile.c: stop wrong peephole optimization when covearge is enabled

    jump-jump optimization ignores the event flags of the jump instruction
    being skipped, which leads to overlook of line events.

    This changeset stops the wrong optimization when coverage measurement is
    neabled and when the jump instruction has any event flag.

    Note that this issue is not only for coverage but also for TracePoint,
    and this change does not fix TracePoint.
    However, fixing it fundamentally is tough (which requires revamp of
    the compiler).  This issue is critical in terms of coverage measurement,
    but minor for TracePoint (ko1 said), so we here choose a stopgap
    measurement.

    [Bug #15980] [Bug #16397]

    Note for backporters: this changeset can be viewed by `git diff -w`.

commit 5a404efd29d255402e30f4f23a09d4e5398600b8
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-04 10:06:54 +0900

    [ruby/io-console] Fixed `intr: false` mode on Windows

    https://github.com/ruby/io-console/commit/4c172c01aa

commit 447d583536274a2489efc8792653ad35d6f7128a
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2019-08-28 03:48:50 +0900

    Silence incorrect assigned but unused variable warnings in ripper

    To only emit the warnings in correct cases would require tracking
    local variable usage in ripper, which ripper currently does not do.

    Fixes [Bug #15188]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2719

commit a91637c516779d9ecee5f323e211f0ed71eb06ad
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2019-10-03 07:20:10 +0900

    Make {Method,UnboundMethod}#super_method handle clone/bind/unbind

    This wasn't working previously because the iclass entry wasn't
    being copied, and without an iclass entry, super_method returns
    nil.

    Fixes [Bug #15629]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2723

commit f9754f0ea08e0d4fb28681a86cbc6ec2d884dba5
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-04 08:22:48 +0900

    compile.c: trivial refactoring

    Use `for` instead of `while` to make it explicit that it is a traverse
    of bytecode.

commit 8852fa876039ed177fd5e867f36177d8a9ff411c
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2019-12-04 01:26:29 +0900

    Revert "Regexp#match{?} with nil raises TypeError as String, Symbol (#1506)"

    This reverts commit 2a22a6b2d8465934e75520a7fdcf522d50890caf.
    Revert [Feature #13083]

commit 08074eb71229b4c9f669f7bfb215bbb43525bfc0
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2019-12-04 01:26:28 +0900

    Revert "Revert nil error and adding deprecation message"

    This reverts commit 452bee3ee8d68059fabd9b1c7a75661b14e3933e.

commit a705f6472c3e34422776d886bbc9f98676d8c0eb
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2019-12-04 01:26:27 +0900

    Revert "Improve warning message"

    This reverts commit 31110d820cc1258cbc84b46ecc65b254c7d5529a.

commit 34a66b1f36e9a065cf8433598b3fce03ce2c711e
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2019-12-04 01:26:24 +0900

    Revert "Fix warnings in Regexp#{match,match?} specs"

    This reverts commit 782d1b8fb0a039cedef9ad9c94f432dad51901e6.

commit a029b54ec716812ade37fef1f857c49f821a8cc8
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2019-08-29 08:41:39 +0900

    Make Enumerator::Chain#each treat lambdas as lambda

    Previously, lambdas were converted to procs because of how
    rb_block_call works.  Switch to rb_funcall_with_block, which
    handles procs as procs and lambdas as lambdas.

    Fixes [Bug #15613]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2720

commit 47c97e1e843159c3c4d57f8c5e22daea57c3ffe1
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2019-08-12 12:53:37 +0900

    Do not lose existing constant visibility when autoloading

    This copies the private/deprecate constant visibility across the
    autoload.  It still is backwards compatible with setting the
    private/deprecate constant visibility in the autoloaded file.
    However, if you explicitly set public constant in the autoloaded
    file, that will be reset after the autoload.

    Fixes [Bug #11055]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2716

commit b96d559c696c5141bdb6717442818f1206ff9d2e
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-04 00:27:58 +0900

    * 2019-12-04 [ci skip]

commit 5c2c3966851ed074eb468ad36d8d75e53b8eab6c
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2019-08-26 04:09:19 +0900

    Check interrupts before starting thread

    Fixes a hang when Thread.new calls Thread.new in a loop.

    Fixes [Bug #13688]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2715

commit 7f2cd2ae6fea76ff3a2b95b69e6e2f749e8a249f
  Author: KOSAKI Motohiro <kosaki.motohiro@gmail.com>
  Date:   2019-12-03 19:50:16 +0900

    fix typo

commit a1f98cd4c1d55efe4998ecd3d94508634baefc23
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-03 17:56:50 +0900

    vm_args.c: make the keyword deprecation message helpful

    ```
    $ ./miniruby -e 'def foo(kw: 1); end; h = {kw: 1}; foo(h)'
    -e:1: warning: The last argument is used as the keyword parameter
    -e:1: warning: for `foo' defined here; maybe ** should be added to the call?
    ```

commit 409e4ab740de3852c3667217bcf41b55040f638f
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-03 17:05:07 +0900

    tool/lib/test/unit/parallel.rb: fail explicitly when failing to get io

    `(ulimit -n 30; make test-tool)` fails with unexplicit message:
    "undefined method `write' for nil:NilClass" due to lack of stdout.

    This change makes it explicit.  [Bug #5577]

commit e42d9d8df87f58b9bfa65647249822df25851375
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-03 14:51:14 +0900

    Fixed the inverted condition

commit 9165fcdfa309052a2adc3c6100ab24204de6c2d1
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-03 14:46:49 +0900

    Wrap statements in AS_IF properly

commit 027e847cd2540553c9ddcf1b39028c43258a3fb4
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-03 13:02:01 +0900

    Fix auto-indent behavior correctly

commit 14a17063a11a01d518b4bbaf0eb967330aec3984
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-03 08:12:57 +0900

    Fixed stack overflow [Bug #16382]

    Get rid of infinite recursion in expanding a load path to the real
    path while loading a transcoder.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2714

commit 8bddf1bc9bdd1db7ce2e3fec15f2f06ff355b0a7
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2019-12-03 08:02:38 +0900

    mjit.c: fix a mismatch of malloc'ed type

    Coverity Scan found this issue.

commit 424ad9a49360be56244609c02678e8f055d92073
  Author: Benoit Daloze <eregontp@gmail.com>
  Date:   2019-12-03 05:23:10 +0900

    Make more attempts to check for the precision of Process.times

    * Process.clock_getres specs use 10_000 but that's quite slow for
      the Process.times spec.

commit c688487fae22e0f73b4e2a9ea5749cb224c25e48
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-03 01:41:22 +0900

    * 2019-12-03 [ci skip]

commit a92560132b1bff6a01782cfeacd62756b4b34d21
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-03 01:17:07 +0900

    Support incremental search by last determined word

    In the incremental search by C-r, search word is saved when it's determined. In
    the next incremental search by C-r, if a user presses C-r again with the empty
    search word, the determined previous search word is used to search.

commit bce38f706e9c434d8fd7c0e2e14bb4acdd085777
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-02 09:15:07 +0900

    The C-r in vi command mode is also incremental search

commit a47d6c256ff684392f00516a917735a14aec64b0
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-02 17:12:29 +0900

    Fix random failure on getusage-missing environments

    `* 1e6` makes a spurious result about floating point number's precision.

    ```
    irb(main)[01:0]> 16.028
    => 16.028
    irb(main)[02:0]> (16.028 * 1e6)
    => 16027999.999999998
    ```

commit 1a88adcd75d92cb36ef5b1d5f4aeb40e6fe4dcb7
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-12-02 15:21:15 +0900

    Fix Leaked file descriptor in test/did_you_mean

    https://github.com/ruby/ruby/commit/de74d2c3b0005048a2c4433bde68b9be10c86f01/checks?check_suite_id=336910877#step:19:131
    ```
    Leaked file descriptor: NameErrorExtensionTest#test_correctable_error_objects_are_dumpable: 7 : #<File:test_name_error_extension.rb>
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2712

commit 185f7608737a550a0891a7fc5a6a4ee32721bce3
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-02 16:23:40 +0900

    Debug random failure of ruby-spec on ci.rvm.jp

commit 9afaf139f232e8b2c697d33e984945464744def1
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-02 14:15:42 +0900

    Revert "builtin_binary.inc needs miniruby itself for RubyVM.each_builtin"

    This reverts commit 2615030c521afc822c66a7e139ccba3d2365ab56,
    which doesn't work when cross compiling, except for mingw.

commit 2615030c521afc822c66a7e139ccba3d2365ab56
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-02 14:03:46 +0900

    builtin_binary.inc needs miniruby itself for RubyVM.each_builtin

commit a7b9f085ff952fcb18f82de39b3bf9ab7e5ba3e7
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-02 13:20:00 +0900

    Disable _FORTIFY_SOURCE on mingw for now

    It causes a link error due to some `__*_chk` functions on mingw.

commit b1c92363a74b0e649a685ae47ae400fbaab7b29d
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-02 13:16:55 +0900

    Wait for the main thread to start reading by Queue

    Otherwise, the written data to pty before the reading started may
    be just lost.

commit de74d2c3b0005048a2c4433bde68b9be10c86f01
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-02 10:32:50 +0900

    Simplify variable declaration by C99

commit 103b04128f4e40b87bb9c7fb2916d2a800bfd94f
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-02 04:17:47 +0900

    Support incremental search again by C-r in incremental search

commit b3ea0980db87404c2b7763a3fdbe898c3812843d
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-02 03:53:58 +0900

    Check MJIT support in one place

    to fix test failure on trunk-no-mjit
    https://gist.github.com/ko1/32ab982ffd7555988818773c08f97123

commit 6bc8b4d8ea6cb8865225c0afcf1abd9e4b725376
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-02 03:51:04 +0900

    Skip --jit-debug= test on mswin

    it fails like
    https://ci.appveyor.com/project/ruby/ruby/builds/29235837/job/v0apdjj4qx8afars

commit c7f05310a248e44ef9747a159a0e9bc289bb7090
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-02 03:30:38 +0900

    Process Backspace key in incremental search correctly

commit e15b0313a78a6f381720cf362a1a94bda49f62ff
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-02 03:05:10 +0900

    Search history to back in the middle of histories

commit 4d7a6d04b2c71aabb9d6e619f4405887806a5be8
  Author: KOSAKI Motohiro <kosaki.motohiro@gmail.com>
  Date:   2019-12-02 01:21:05 +0900

    Avoid unnecessary tzset() call

    Akatsuki reported ENV['TZ'] = 'UTC' improved 7x-8x faster on following code.
    t = Time.now; 100000.times { Time.new(2019) }; Time.now - t
    https://hackerslab.aktsk.jp/2019/12/01/141551

    commit 4bc1669127(reduce tzset) dramatically improved this situation. But still,
    TZ=UTC is faster than default.

    This patch removs unnecessary tzset() call completely.

    Performance check
      ----------------------
    test program: t = Time.now; 100000.times { Time.new(2019) }; Time.now - t
    before:         0.387sec
    before(w/ TZ):  0.197sec
    after:          0.162sec
    after(w/ TZ):   0.165sec

    OK. Now, Time creation 2x faster *and* TZ=UTC doesn't improve anything.
    We can forget this hack completely. :)

    Side note:
    This patch slightly changes Time.new(t) behavior implicitly. Before this patch, it might changes
    default timezone implicitly. But after this patch, it doesn't. You need to reset TZ
    (I mean ENV['TZ'] = nil) explicitly.
    But I don't think this is big impact. Don't try to change /etc/localtime on runtime.

    Side note2: following test might be useful for testing "ENV['TZ'] = nil".
      -----------------------------------------
    % cat <<'End' | sudo sh -s
    rm -f /etc/localtime-; cp -a /etc/localtime /etc/localtime-
    rm /etc/localtime; ln -s /usr/share/zoneinfo/Asia/Tokyo /etc/localtime
    ./ruby -e '
    p Time.new(2000).zone # JST
    File.unlink("/etc/localtime"); File.symlink("/usr/share/zoneinfo/America/Los_Angeles", "/etc/localtime")
    p Time.new(2000).zone # JST (ruby does not follow /etc/localtime modification automatically)
    ENV["TZ"] = nil
    p Time.new(2000).zone # PST (ruby detect /etc/localtime modification)
    '
    rm /etc/localtime; cp -a /etc/localtime- /etc/localtime; rm /etc/localtime-
    End

commit 43811cc3b36739816788cbbac7a49b9bbf756293
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-02 00:05:20 +0900

    * 2019-12-02 [ci skip]

commit 7f0d51704a5cb789c16a6c05db455469f0b2601d
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-02 00:03:59 +0900

    Remove obsolete code

commit 8cb3f29abf9290838bdc3b9904868c78752427e8
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-01 23:53:59 +0900

    The ed_search_prev_history should always search to backward

commit f1cfc7da180a8cf26f758fbe553e6653e4a4dc53
  Author: aycabta <aycabta@gmail.com>
  Date:   2019-12-01 22:11:59 +0900

    Reline::HISTORY can take Range object

commit 617a3735aedc12fe82b6806d6d3a37c3f977fef1
  Author: Benoit Daloze <eregontp@gmail.com>
  Date:   2019-12-01 22:11:42 +0900

    Update to ruby/spec@dcf4955

commit 60d362b0bb0fb56bd3ef61c93f71bff997ccb824
  Author: Benoit Daloze <eregontp@gmail.com>
  Date:   2019-12-01 22:11:40 +0900

    Update to ruby/mspec@aa28e95

commit ab516e263c06fbd755d4805ad529c32b1b8292b5
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-01 21:14:58 +0900

    [ruby/spec] Fix failures with LC_ALL=C

    https://github.com/ruby/spec/commit/51047687c0
    https://github.com/ruby/spec/commit/2b87b467cc

commit 4e03a7298b3a99de9c57f9a4934d38445cad1b10
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-01 20:26:28 +0900

    Constified mjit_init

commit cb760f36aae42a63738394f170444b6ae4405b82
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-01 19:29:04 +0900

    Constified

commit 91af5542b503054ea059b6c4faa5cd821784774a
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-01 19:00:08 +0900

    Fix a mistake excluding NULL in the end

commit 8a677a6e80b3b7e1f52073b362083a78eb87397f
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-01 18:35:30 +0900

    Workaround missing strndup on Windows

    https://ci.appveyor.com/project/ruby/ruby/builds/29230976/job/c910t37313edb97k

commit 3e2753ad2e0b643f5c731fb162f5805d82435032
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-01 18:25:54 +0900

    Use build dir for testing --jit-debug

    to fix failure like https://github.com/ruby/ruby/runs/327745536

commit a19d625e667024fe27dcee04dd748e914bc24762
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-01 17:56:27 +0900

    Allow specifying arbitrary MJIT flags by --jit-debug

    This is a secret feature for me. It's only for testing and any behavior
    with this flag override is unsupported.

    I needed this because I sometimes want to add debug options but do not
    want to disable optimizations, for using Linux perf.

commit bdc62dfc8ecffd27dd5ad6756cce88eac5c993f5
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-12-01 14:38:33 +0900

    Fixed type of an index variable

commit 9914d6e992a69587e6d43ba7eaa6cdda9f178f8e
  Author: Yuki Nishijima <yk.nishijima@gmail.com>
  Date:   2019-12-01 13:26:09 +0900

    Relax test strictness for error message from KeyError

commit cc7455dd1e98e297dbea2fd92e491bd36f1b473e
  Author: Yuki Nishijima <yk.nishijima@gmail.com>
  Date:   2019-12-01 12:29:02 +0900

    Relax test requirements for DYM's verbose formatter

commit 56faa13a1c5261a0d046a4c0203e88fccfafae17
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2019-12-01 12:24:50 +0900

    remove spaces to pass a test.

    23d7f4c5e1ce164e78d77de694dccc0c41f6de3d breaks a test which expect
    to match error message. To avoid this failure, use #strip for expect
    and actual results.

commit 23d7f4c5e1ce164e78d77de694dccc0c41f6de3d
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-01 11:08:39 +0900

    * remove trailing spaces. [ci skip]

commit 0fef526606c72e7d2a3c83aebd9204da34016d96
  Author: Yuki Nishijima <yk.nishijima@gmail.com>
  Date:   2019-11-30 11:40:07 +0900

    Do not call 'gem "did_you_mean"' for now

    This will slow down the time that the +require+ method takes to load DYM,
    but this has caused a build failure in a certain situation:

      https://ci.appveyor.com/project/ruby/ruby/builds/29214253/job/r9u9c8p95tnlftt3#L24965

    which is reported as a separate bug:

      https://bugs.ruby-lang.org/issues/16382?next_issue_id=16381

    For now this commit should fix the builds, but we should come back and
    add back the 'gem' call.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2689

commit 171803d5d34feb1b4244ca81b9db0a7bc2171c85
  Author: Kevin Deisz <kevin.deisz@gmail.com>
  Date:   2019-10-29 23:08:37 +0900

    Promote did_you_mean to default gem

    At the moment, there are some problems with regard to bundler + did_you_mean because of did_you_mean being a bundled gem. Since the vendored version of thor inside bundler and ruby itself explicitly requires did_you_mean, it can become difficult to load it when using Bundler.setup. See this issue: https://github.com/yuki24/did_you_mean/issues/117#issuecomment-482733159 for more details.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2689

commit a2fc6a51dd2e1a153559038795e1e2509f9c6a94
  Author: David Rodríguez <deivid.rodriguez@riseup.net>
  Date:   2019-11-30 22:03:12 +0900

    [ruby/fileutils] Fix test failure under ruby 2.4

    `Exception#full_message` is only defined on ruby 2.5.0 and above.

    https://github.com/ruby/fileutils/commit/a8968f41ed

commit fa0f3eff228bb26de6d5b0e1238b1f358165dbd0
  Author: David Rodríguez <deivid.rodriguez@riseup.net>
  Date:   2019-11-30 22:01:18 +0900

    [ruby/fileutils] Fix error printing test failure

    `exception_details` is not defined anywhere.

    This commit fixes the following test crash in ruby 2.4

    ```
    Error: test_assert_output_lines(TestFileUtils): NoMethodError: undefined method `exception_details' for #<TestFileUtils:0x00005556ef699178>
    ```

    And replaces it with an actual test failure:

    ```
    [Test::Unit::CoreAssertions::MiniTest::Assertion] exception expected, not #<NoMethodError: undefined method `full_message' for #<RuntimeError: ok>
    Did you mean?  message>.
    ```

    https://github.com/ruby/fileutils/commit/2f38ba6e82

commit 5b1f7f26b4ff3b05e1c184ae87154a323b1be915
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2019-12-01 06:29:00 +0900

    Skip if getrusage is not supported

    1243255c3a36433041012b6107a5ac48658a0895 broke ci.rvm.jp tests like
    http://ci.rvm.jp/results/trunk_clang_39@silicon-docker/2445098.

    253232c028a5565dbeecc05fab5e81b35ab58bcc works only if getrusage is supported.

commit 1243255c3a36433041012b6107a5ac48658a0895
  Author: Benoit Daloze <eregontp@gmail.com>
  Date:   2019-12-01 05:26:52 +0900

    Update to ruby/spec@4eec3dc

commit ab8345271eb87ff155d8bd5f22f53a4cf2902c26
  Author: Benoit Daloze <eregontp@gmail.com>
  Date:   2019-12-01 05:26:49 +0900

    Update to ruby/mspec@a401f63

commit 93a512414cbe3713f478038f6d4f5fe81c4eb62a
  Author: git <svn-admin@ruby-lang.org>
  Date:   2019-12-01 02:18:45 +0900

    * 2019-12-01 [ci skip]

commit 5e0479f26afe1505afd9014ea96a206a88845828
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-10-01 12:23:25 +0900

    ENV.update should not call block on existing keys

    [Bug #16192]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2512

commit b94d06096b8f2a375719ce09370e004fcb277b25
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-11-30 18:20:02 +0900

    [ruby/zlib] Bump version to 1.1.0

    https://github.com/ruby/zlib/commit/5af77c1ee8

commit 7ebcee6b7634889f0bd92aaedf079845065ac797
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-11-30 18:13:16 +0900

    [ruby/gdbm] Bump version to 2.1.0

    https://github.com/ruby/gdbm/commit/ffb2b063a3

commit 56567c76487d42f12283ecf074d45adae96ca5f0
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-11-30 18:03:57 +0900

    [ruby/etc] Bump version to 1.1.0

    https://github.com/ruby/etc/commit/78987ce56a

commit 08c866d5281777e1f8f8503f7ebdec9aee62ed63
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-11-30 18:05:51 +0900

    [ruby/fileutils] Bump version to 1.4.1

    https://github.com/ruby/fileutils/commit/da15e3ce06

commit 06b9b78e21f5da5f348a932c3e7f21468674e4f1
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-11-30 17:54:44 +0900

    [ruby/dbm] Bump version to 1.1.0

    https://github.com/ruby/dbm/commit/163078359d

commit 32e547954fbbcbdd6f4468bf3be9e7eaa5d32f0f
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-11-30 17:58:39 +0900

    Revert "[ruby/fileutils] Fix #install with "X" mode option"

      This reverts commit eab88d20eaa925d5e61a2a65820a099b46ccf3f8.

      The some CI was broken with this.

commit 5e9f08647cead8b7fa303a5da88c5e96035f3497
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-08-28 21:58:25 +0900

    [ruby/webrick] Check the feature by itself, instead of the version number

    https://github.com/ruby/webrick/commit/79d7922de9

commit a98632d5c20e41e05074384b8f760af407e6d52a
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2019-08-12 04:57:11 +0900

    [ruby/webrick] Enabled chunked encoding if Transfer-Encoding: chunked header is set

    Patch from Leonard Garvey.

    Fixes Ruby Bug 9986.

    https://github.com/ruby/webrick/commit/8cff7f3995

commit edfbffb241a894eece57155a22a89637b33cfe58
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-11-30 17:39:58 +0900

    [ruby/webrick] Bump version to 1.6.0

    https://github.com/ruby/webrick/commit/c5635fa5e2

commit c75100d00401c32b3245ce8da5b8a045976216ca
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2019-08-27 13:41:27 +0900

    [ruby/webrick] Allow WEBrick::HTTPServlet::CGIHandler :CGIInterpreter option to be array

    This way you don't need to escape each entry.

    Implements Ruby Feature 15170.

    https://github.com/ruby/webrick/commit/d8086e600c

commit f7cf5416e471cd34153058952063da3457468e58
  Author: zverok <zverok.offline@gmail.com>
  Date:   2019-10-26 19:27:17 +0900

    [ruby/webrick] Document HTTPResponse#body callable option

    https://github.com/ruby/webrick/commit/d51836d03d

commit ea4272d02b02719e266c7cf30141e6275e38f9a7
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-11-30 17:23:13 +0900

    [ruby/fileutils] Bump version to 1.4.0

    https://github.com/ruby/fileutils/commit/f92145b10b

commit 3b9e1c0b2e5b3c507c94fd36c87288e789ee9c2a
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-11-30 17:32:38 +0900

    Move gemspec of fileutils under the toplevel of lib directory.

commit eab88d20eaa925d5e61a2a65820a099b46ccf3f8
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-10-03 01:39:02 +0900

    [ruby/fileutils] Fix #install with "X" mode option

    `FileUtils#install` methed raises an unexpected `TypeError`, when
    called with `mode:` option which has `"X"`.

    ```
    $ ruby -rfileutils -e 'FileUtils.install("tmp/a", "tmp/b", mode: "o+X")'
    /opt/local/lib/ruby/2.7.0/fileutils.rb:942:in `directory?': no implicit conversion of File::Stat into String (TypeError)
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:942:in `block (3 levels) in symbolic_modes_to_i'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:933:in `each_char'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:933:in `each'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:933:in `inject'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:933:in `block (2 levels) in symbolic_modes_to_i'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:931:in `each'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:931:in `each_slice'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:931:in `block in symbolic_modes_to_i'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:926:in `each'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:926:in `inject'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:926:in `symbolic_modes_to_i'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:973:in `fu_mode'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:883:in `block in install'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:1588:in `block in fu_each_src_dest'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:1604:in `fu_each_src_dest0'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:1586:in `fu_each_src_dest'
            from /opt/local/lib/ruby/2.7.0/fileutils.rb:877:in `install'
            from -e:1:in `<main>'
    ```

    In spite of that `symbolic_modes_to_i` considers the `File::Stat`
    `path` case at the beginning, in `"X"` case, `path` is passed to
    `FileTest.directory?` method which requires a `String`.  In such
    case, the mode in `path` should be examined instead.

    https://github.com/ruby/fileutils/commit/2ea54ade2f

commit aab74fc938453233a5f11a093ad6129a0be230d1
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-10-03 01:17:26 +0900

    [ruby/fileutils] Added `test_install_mode_option`

    https://github.com/ruby/fileutils/commit/bb10efe104

commit 0a7d26bea1b2d7ab4c36e471d387d1a9907a486d
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2019-10-03 00:55:19 +0900

    [ruby/fileutils] Remove version.rb

    Loading separate version.rb unnecessary increases every start-up
    time.  In the other hand, the gemspec file is parsed only when
    building the gem file.

    https://github.com/ruby/fileutils/commit/8359cf7cce

commit c064018a7584fe03403a3b175ac25dbbb1162c8c
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-11-19 15:13:35 +0900

    Make extract-gems only if test_task is check

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2678

commit bb3542cc6b3db5477c2a9efd76905a4133545da1
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-11-13 21:28:53 +0900

    Add update-gems before extract-gems

    (windows.yml used `nmake up`)

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2678

commit 2eb4afb10bd9a3849eb34292f33240ac3ef19905
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2019-11-13 19:45:14 +0900

    Add extract-gems to GitHub Actions CI

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2678

commit cf14592872684956df7c014de0f9808c8aaf0e22
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-11-30 16:01:23 +0900

    [ruby/readline-ext] Prepare to gem release

    https://github.com/ruby/readline-ext/commit/e5b969215a

commit 856f9990a90e601ec5245a934d1da153591fcf3b
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-11-30 15:50:57 +0900

    [ruby/forwardable] Bump version to 1.3.0

    https://github.com/ruby/forwardable/commit/e56f0f83c6

commit 9fa0166a580e72adf02562b7d60672c6c362d4b7
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2019-09-08 04:41:16 +0900

    [ruby/forwardable] Fix keyword argument separation warnings on Ruby 2.7+

    Do so in a way that is also compatible with previous versions.

    https://github.com/ruby/forwardable/commit/b2dd340988

commit af4b3f16ceed36f8b18856120940c9de6e6a0eee
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-11-30 15:26:01 +0900

    [ruby/stringio] Bump version to 0.1.0

    https://github.com/ruby/stringio/commit/4c1e267e1a

commit 990025cf60eb6586c13f5f055880ac60afbac646
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-11-30 15:16:13 +0900

    [ruby/stringio] RbConfig::LIMITS only provide after Ruby 2.5

    https://github.com/ruby/stringio/commit/1fed3aacd3

commit e764dff3641fd66fda1b9cf33cb7ddeb30e0b38a
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2019-11-30 14:31:00 +0900

    [ruby/date] Bump version to 3.0.0

    https://github.com/ruby/date/commit/202b2dad93

commit 80705e2c4fe7c1e968830880ea4408990e3f3c39
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
